"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FailedBackgroundJobsPanel = exports.Fullscreen = exports.OverlayTrigger = exports.FetcherInput = exports.TooltipComponent = exports.ErrorPanel = exports.Stretch = exports.Affix = exports.GlyphButton = exports.Alert = exports.DeleteButton = exports.Button = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _setImmediate2 = require("babel-runtime/core-js/set-immediate");

var _setImmediate3 = _interopRequireDefault(_setImmediate2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

exports.AddButton = AddButton;
exports.Help = Help;
exports.Label = Label;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _reactBootstrap = require("react-bootstrap");

var _PanelHeading = require("react-bootstrap/lib/PanelHeading");

var _PanelHeading2 = _interopRequireDefault(_PanelHeading);

var _PanelCollapse = require("react-bootstrap/lib/PanelCollapse");

var _PanelCollapse2 = _interopRequireDefault(_PanelCollapse);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _utils = require("../utils");

var _Context = require("../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = exports.Button = function (_Component) {
	(0, _inherits3.default)(Button, _Component);

	function Button() {
		(0, _classCallCheck3.default)(this, Button);
		return (0, _possibleConstructorReturn3.default)(this, (Button.__proto__ || (0, _getPrototypeOf2.default)(Button)).apply(this, arguments));
	}

	(0, _createClass3.default)(Button, [{
		key: "render",
		value: function render() {
			var _props2 = this.props,
			    tooltip = _props2.tooltip,
			    tooltipPlacement = _props2.tooltipPlacement,
			    tooltipTrigger = _props2.tooltipTrigger,
			    tooltipClass = _props2.tooltipClass,
			    _props = (0, _objectWithoutProperties3.default)(_props2, ["tooltip", "tooltipPlacement", "tooltipTrigger", "tooltipClass"]);

			return _react2.default.createElement(
				TooltipComponent,
				{ tooltip: tooltip, placement: tooltipPlacement, trigger: tooltipTrigger, className: tooltipClass },
				_react2.default.createElement(
					_reactBootstrap.Button,
					(0, _extends3.default)({
						bsStyle: "primary"
					}, _props),
					_props.children
				)
			);
		}
	}]);
	return Button;
}(_react.Component);

var DeleteButton = exports.DeleteButton = function (_Component2) {
	(0, _inherits3.default)(DeleteButton, _Component2);

	function DeleteButton(props) {
		(0, _classCallCheck3.default)(this, DeleteButton);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (DeleteButton.__proto__ || (0, _getPrototypeOf2.default)(DeleteButton)).call(this, props));

		_this2.onButtonKeyDown = function (_ref) {
			var key = _ref.key;

			if (key === "Enter") _this2.onConfirmedClick();else if (key === "Escape") _this2.setState({ show: false });
		};

		_this2.onHideConfirm = function () {
			_this2.setState({ show: false }, function () {
				if (_this2.callback) {
					_this2.callback(_this2.deleted);
					_this2.callbackCalled = true;
				}
			});
		};

		_this2.onShowConfirm = function (e) {
			e.preventDefault();
			e.stopPropagation();
			_this2.setState({ show: true }, function () {
				_this2._focusConfirm = true;
				if (_this2.props.confirmStyle === "browser") {
					_this2.browserConfirm();
				}
			});
		};

		_this2.onConfirmedClick = function (e) {
			e && e.preventDefault();
			e && e.stopPropagation();
			_this2.props.onClick();
			_this2.onHideConfirm();
			_this2.deleted = true;
		};

		_this2.onClick = function (e, callback) {
			_this2.callback = callback;
			_this2.props.confirm ? _this2.onShowConfirm(e) : _this2.onConfirmedClick(e);
		};

		_this2.componentWillUnmount = function () {
			if (_this2.callback && !_this2.callbackCalled) {
				_this2.callback(_this2.deleted);
			}
		};

		_this2.setConfirmAutofocus = function (elem) {
			if (_this2._focusConfirm) {
				(0, _setImmediate3.default)(function () {
					// Without setImmediate focusing causes scroll to jump to top of page. Popover isn't positioned correctly probably right away.

					var domElem = (0, _reactDom.findDOMNode)(elem);
					domElem && domElem.focus();
					_this2._focusConfirm = undefined;
				});
			}
		};

		_this2.renderConfirm = function () {
			var show = _this2.state.show;

			if (!show) {
				return null;
			}
			var _this2$props$confirmS = _this2.props.confirmStyle,
			    confirmStyle = _this2$props$confirmS === undefined ? "popup" : _this2$props$confirmS;

			if (confirmStyle === "popup") {
				return _this2.renderConfirmPopup();
			}
			return null;
		};

		_this2.state = { show: false };
		return _this2;
	}

	(0, _createClass3.default)(DeleteButton, [{
		key: "render",
		value: function render() {
			var _this3 = this;

			var props = this.props;
			var corner = props.corner,
			    tooltip = props.tooltip,
			    disabled = props.disabled,
			    readonly = props.readonly,
			    _props$glyphButton = props.glyphButton,
			    glyphButton = _props$glyphButton === undefined ? true : _props$glyphButton;

			var buttonClassName = glyphButton ? "glyph-button" : "";
			buttonClassName += corner ? " button-corner" : "";
			if (props.className) {
				buttonClassName = buttonClassName + " " + props.className;
			}
			var onClick = function onClick(e) {
				return _this3.onClick(e);
			};
			var maybeProps = {};
			if (props.id !== undefined) {
				maybeProps.id = props.id + "-delete";
			}
			var button = _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(
					Button,
					(0, _extends3.default)({}, maybeProps, {
						disabled: disabled || readonly,
						bsStyle: "danger",
						className: buttonClassName,
						style: this.props.style,
						ref: "del",
						onKeyDown: this.onButtonKeyDown,
						onClick: onClick }),
					this.props.children || "✖"
				),
				this.renderConfirm()
			);
			return tooltip ? _react2.default.createElement(
				TooltipComponent,
				{ tooltip: tooltip },
				button
			) : button;
		}
	}, {
		key: "renderConfirmPopup",
		value: function renderConfirmPopup() {
			var _this4 = this;

			var getOverlayTarget = function getOverlayTarget() {
				return (0, _reactDom.findDOMNode)(_this4.refs.del);
			};
			var _props3 = this.props,
			    translations = _props3.translations,
			    _props3$confirmPlacem = _props3.confirmPlacement,
			    confirmPlacement = _props3$confirmPlacem === undefined ? "left" : _props3$confirmPlacem;

			return _react2.default.createElement(
				_reactBootstrap.Overlay,
				{ show: true, placement: confirmPlacement, rootClose: true, onHide: this.onHideConfirm,
					target: getOverlayTarget },
				_react2.default.createElement(
					_reactBootstrap.Popover,
					{ id: this.props.id + "-button-confirm" },
					_react2.default.createElement(
						"span",
						null,
						translations.ConfirmRemove
					),
					_react2.default.createElement(
						_reactBootstrap.ButtonGroup,
						null,
						_react2.default.createElement(
							Button,
							{ bsStyle: "danger", onClick: this.onConfirmedClick, ref: this.setConfirmAutofocus, id: this.props.id + "-delete-confirm-yes" },
							translations.Remove
						),
						_react2.default.createElement(
							Button,
							{ bsStyle: "default", onClick: this.onHideConfirm, id: this.props.id + "-delete-confirm-no" },
							translations.Cancel
						)
					)
				)
			);
		}
	}, {
		key: "browserConfirm",
		value: function browserConfirm() {
			var choice = confirm(this.props.translations.ConfirmRemove);
			if (choice) {
				this.onConfirmedClick();
			} else {
				this.onHideConfirm();
			}
		}
	}]);
	return DeleteButton;
}(_react.Component);

DeleteButton.propTypes = {
	confirm: _propTypes2.default.bool,
	onClick: _propTypes2.default.func.isRequired,
	translations: _propTypes2.default.object.isRequired,
	confirmStyle: _propTypes2.default.oneOf(["popup", "browser"])
};
function AddButton(_ref2) {
	var onClick = _ref2.onClick;

	return _react2.default.createElement(
		_reactBootstrap.Row,
		null,
		_react2.default.createElement(
			_reactBootstrap.Col,
			{ xs: 2 },
			_react2.default.createElement(
				Button,
				{ onClick: onClick },
				"\u2795"
			)
		)
	);
}

var Alert = exports.Alert = function (_Component3) {
	(0, _inherits3.default)(Alert, _Component3);

	function Alert() {
		var _ref3;

		var _temp, _this5, _ret;

		(0, _classCallCheck3.default)(this, Alert);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this5 = (0, _possibleConstructorReturn3.default)(this, (_ref3 = Alert.__proto__ || (0, _getPrototypeOf2.default)(Alert)).call.apply(_ref3, [this].concat(args))), _this5), _this5.onKeyDown = function (e) {
			if (e.key === "Enter" || e.key === "Escape") _this5.props.onOk();
		}, _temp), (0, _possibleConstructorReturn3.default)(_this5, _ret);
	}

	(0, _createClass3.default)(Alert, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(
				_reactBootstrap.Modal,
				{ show: true, enforceFocus: true, onKeyDown: this.onKeyDown },
				_react2.default.createElement(
					_reactBootstrap.Modal.Body,
					null,
					this.props.children
				),
				_react2.default.createElement(
					_reactBootstrap.Modal.Footer,
					null,
					_react2.default.createElement(
						Button,
						{ onClick: this.props.onOk },
						"Ok"
					)
				)
			);
		}
	}]);
	return Alert;
}(_react.Component);

var GlyphButton = function GlyphButton(props) {
	var glyph = props.glyph,
	    buttonProps = (0, _objectWithoutProperties3.default)(props, ["glyph"]);

	return _react2.default.createElement(
		Button,
		(0, _extends3.default)({}, buttonProps, {
			className: "glyph-button" + (props.className ? " " + props.className : ""),
			tooltipPlacement: props.tooltipPlacement || "left" }),
		_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: glyph }),
		props.children
	);
};

exports.GlyphButton = GlyphButton;
var TOP = "TOP",
    AFFIXED = "AFFIXED",
    BOTTOM = "BOTTOM";

var Affix = exports.Affix = function (_Component4) {
	(0, _inherits3.default)(Affix, _Component4);

	function Affix(props) {
		(0, _classCallCheck3.default)(this, Affix);

		var _this6 = (0, _possibleConstructorReturn3.default)(this, (Affix.__proto__ || (0, _getPrototypeOf2.default)(Affix)).call(this, props));

		_initialiseProps.call(_this6);

		_this6.state = _this6.getState(props);
		return _this6;
	}

	(0, _createClass3.default)(Affix, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			window.addEventListener("scroll", this.onScroll);
			window.addEventListener("resize", this.onResize);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			window.removeEventListener("scroll", this.onScroll);
			window.removeEventListener("resize", this.onResize);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			if (!this.props.onAffixChange || !prevState || !this.state) return;
			if (prevState.affixState !== AFFIXED && this.state.affixState === AFFIXED) {
				this.props.onAffixChange(true);
			} else if (prevState.affixState === AFFIXED && this.state.affixState !== AFFIXED) {
				this.props.onAffixChange(false);
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _props4 = this.props,
			    children = _props4.children,
			    containerStyle = _props4.style;

			var _ref4 = this.state || {},
			    top = _ref4.top,
			    width = _ref4.width,
			    affixState = _ref4.affixState,
			    affixHeight = _ref4.affixHeight,
			    fixerHeight = _ref4.fixerHeight;

			var style = {};
			var fixerStyle = { position: "relative", zIndex: -1, height: fixerHeight };
			style.position = "relative";
			if (affixState === BOTTOM || affixState === AFFIXED) {
				style.position = "fixed";
				style.width = width;
				style.top = top;
				style.zIndex = 1000;
				style.height = affixHeight;
				if (affixState === BOTTOM) {
					style.overflow = "hidden";
				}
			}
			return _react2.default.createElement(
				"div",
				{ style: containerStyle, ref: "container" },
				_react2.default.createElement("div", { ref: "positioner" }),
				_react2.default.createElement(
					"div",
					{ ref: "wrapper", style: style, className: this.props.className },
					children
				),
				_react2.default.createElement("div", { style: fixerStyle })
			);
		}
	}]);
	return Affix;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this16 = this;

	this.getState = function (props) {
		var _props$topOffset = props.topOffset,
		    topOffset = _props$topOffset === undefined ? 0 : _props$topOffset,
		    _props$bottomOffset = props.bottomOffset,
		    bottomOffset = _props$bottomOffset === undefined ? 0 : _props$bottomOffset,
		    getContainer = props.getContainer;


		var container = getContainer ? getContainer() : _this16.refs.container;
		var wrapperElem = (0, _reactDom.findDOMNode)(_this16.refs.wrapper);
		if (!container || !document.body.contains(container) || !wrapperElem) return;

		var containerTop = container.getBoundingClientRect().top;
		var containerHeight = container.offsetHeight;
		var containerVisibleHeight = containerHeight + containerTop;
		var wrapperHeight = wrapperElem.offsetHeight;
		var wrapperScrollHeight = wrapperElem.scrollHeight;
		var scrolled = _this16.refs.container.getBoundingClientRect().top < topOffset;

		var viewportHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
		var bottomDist = viewportHeight - container.getBoundingClientRect().top - containerHeight;
		var bottomInvisibleHeight = Math.min(bottomDist, 0);

		var affixState = TOP;
		if (scrolled && containerVisibleHeight < wrapperScrollHeight + topOffset) affixState = BOTTOM;else if (scrolled) affixState = AFFIXED;

		var width = wrapperElem ? wrapperElem.offsetWidth : undefined;
		var top = topOffset;

		var affixHeight = affixState === BOTTOM ? Math.max(containerVisibleHeight - topOffset + Math.min(bottomInvisibleHeight, 0) - (bottomDist < bottomOffset ? Math.min(bottomOffset - bottomDist, bottomOffset) : 0), 0) : undefined;
		var wrapperCutHeight = wrapperHeight - (affixHeight || 0);

		var change = void 0;
		if (affixState === BOTTOM) {
			if (!_this16.state) {
				change = wrapperCutHeight;
			} else {
				if (_this16.state.affixState === BOTTOM) {
					var lastChange = _this16.state.change;
					var changeNow = wrapperCutHeight;
					change = lastChange + changeNow;
				} else {
					change = wrapperCutHeight;
				}
			}
		}

		var fixerHeight = affixState === AFFIXED ? wrapperHeight - (affixHeight || 0) : affixState === BOTTOM ? affixHeight + change : 0;
		return { affixState: affixState, width: width, top: top, affixHeight: affixHeight, fixerHeight: fixerHeight, change: change };
	};

	this._onScroll = function () {
		_this16.setState(_this16.getState(_this16.props));
	};

	this.onScroll = function () {
		requestAnimationFrame(_this16._onScroll);
	};

	this._onResize = function () {
		var positioner = (0, _reactDom.findDOMNode)(_this16.refs.positioner);
		var width = positioner.getBoundingClientRect().width;

		var state = { width: width };

		var _state = _this16.getState(_this16.props);
		if (_state.affixState !== TOP) state.top = _state.top;

		_this16.setState(state);
	};

	this.onResize = function () {
		requestAnimationFrame(_this16._onResize);
	};
};

var Stretch = exports.Stretch = function (_Component5) {
	(0, _inherits3.default)(Stretch, _Component5);

	function Stretch(props) {
		(0, _classCallCheck3.default)(this, Stretch);

		var _this7 = (0, _possibleConstructorReturn3.default)(this, (Stretch.__proto__ || (0, _getPrototypeOf2.default)(Stretch)).call(this, props));

		_this7._onScroll = function () {
			var callback = undefined;
			var state = _this7.getState();
			if (!_this7.cameToViewFirstTime && state.height > _this7.props.enterViewPortTreshold || 0) {
				_this7.cameToViewFirstTime = true;
				if (_this7.props.onEnterViewPort) callback = function callback() {
					return _this7.props.onEnterViewPort();
				};
			}
			_this7.update(state, callback);
		};

		_this7.onScroll = function () {
			requestAnimationFrame(_this7._onScroll);
		};

		_this7.invalidate = function (callback) {
			_this7.update(_this7.getState(), callback);
		};

		_this7.update = function (state, callback) {
			var afterStateChange = function afterStateChange() {
				if (_this7.props.onResize) _this7.props.onResize();
				callback && callback();
			};
			state ? _this7.setState(state, function () {
				afterStateChange();
			}) : afterStateChange;
		};

		_this7.getState = function () {
			var _this7$props = _this7.props,
			    getContainer = _this7$props.getContainer,
			    _this7$props$topOffse = _this7$props.topOffset,
			    topOffset = _this7$props$topOffse === undefined ? 0 : _this7$props$topOffse,
			    _this7$props$bottomOf = _this7$props.bottomOffset,
			    bottomOffset = _this7$props$bottomOf === undefined ? 0 : _this7$props$bottomOf,
			    minHeight = _this7$props.minHeight;

			var container = getContainer();

			if (_this7.refs.wrapper && _this7.props.getContainer().getBoundingClientRect().top !== (0, _reactDom.findDOMNode)(_this7.refs.wrapper).getBoundingClientRect().top) {
				return {
					horizontallyAligned: false
				};
			}

			var containerHeight = container.offsetHeight;
			if (minHeight && containerHeight < minHeight) {
				containerHeight = minHeight;
				container = _this7.refs.wrapper;
			}

			var viewportHeight = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
			var bottomDist = viewportHeight - container.getBoundingClientRect().top - containerHeight;
			var bottomInvisibleHeight = Math.min(bottomDist, 0);

			return {
				horizontallyAligned: true,
				containerHeight: containerHeight,
				height: Math.max(containerHeight + Math.min(container.getBoundingClientRect().top, 0) + Math.min(bottomInvisibleHeight, 0) - (container.getBoundingClientRect().top < topOffset ? Math.min(topOffset - container.getBoundingClientRect().top, topOffset) : 0) - (bottomDist < bottomOffset ? Math.min(bottomOffset - bottomDist, bottomOffset) : 0), 0),
				top: Math.max(-container.getBoundingClientRect().top + topOffset, 0)
			};
		};

		_this7.state = {};
		return _this7;
	}

	(0, _createClass3.default)(Stretch, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			if (props.mounted && !this.initialized) {
				var state = this.getState();
				this.update(state);
				this.cameToViewFirstTime = state.height > this.props.enterViewPortTreshold || 0;
				this.initialized = true;
			}
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			window.addEventListener("scroll", this.onScroll);
			window.addEventListener("resize", this.onResize);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			window.removeEventListener("scroll", this.onScroll);
		}
	}, {
		key: "render",
		value: function render() {
			var children = this.props.children;


			var wrapperStyle = {
				height: this.state.horizontallyAligned ? this.state.containerHeight : this.props.minHeight
			};
			var style = {
				position: "relative",
				top: this.state.horizontallyAligned ? this.state.top : undefined,
				height: this.state.horizontallyAligned ? this.state.height : "100%"
			};

			return _react2.default.createElement(
				"div",
				{ ref: "wrapper", style: wrapperStyle, className: this.props.className },
				_react2.default.createElement(
					"div",
					{ style: style },
					children
				)
			);
		}
	}]);
	return Stretch;
}(_react.Component);

function Help(_ref5) {
	var help = _ref5.help,
	    id = _ref5.id;

	var helpGlyph = _react2.default.createElement(
		"span",
		{ className: "label-info laji-form-help-glyph" },
		_react2.default.createElement(
			"strong",
			null,
			"?"
		)
	);

	return help ? _react2.default.createElement(
		OverlayTrigger,
		{ placement: "right", overlay: _react2.default.createElement(
				_reactBootstrap.Tooltip,
				{ id: id },
				_react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: help } })
			) },
		helpGlyph
	) : helpGlyph;
}

function Label(_ref6) {
	var label = _ref6.label,
	    help = _ref6.help,
	    children = _ref6.children,
	    id = _ref6.id,
	    required = _ref6.required,
	    _context = _ref6._context,
	    helpHoverable = _ref6.helpHoverable,
	    helpPlacement = _ref6.helpPlacement;

	var showHelp = label && help;

	var tooltipElem = _react2.default.createElement(
		_reactBootstrap.Tooltip,
		{ id: id + "-tooltip" },
		help ? _react2.default.createElement(
			"span",
			null,
			_react2.default.createElement("strong", { dangerouslySetInnerHTML: { __html: label } }),
			_react2.default.createElement("br", null),
			_react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: help } })
		) : label
	);

	var labelElem = _react2.default.createElement(
		"label",
		{ htmlFor: id },
		_react2.default.createElement(
			"div",
			null,
			_react2.default.createElement("strong", { dangerouslySetInnerHTML: { __html: label + (required ? "*" : "") } }),
			showHelp ? _react2.default.createElement(Help, null) : null
		),
		children
	);

	return label || help ? _react2.default.createElement(
		OverlayTrigger,
		{ placement: helpPlacement || "right", overlay: tooltipElem, hoverable: helpHoverable, _context: _context },
		labelElem
	) : labelElem;
}

var ErrorPanel = exports.ErrorPanel = function (_Component6) {
	(0, _inherits3.default)(ErrorPanel, _Component6);

	function ErrorPanel(props) {
		(0, _classCallCheck3.default)(this, ErrorPanel);

		var _this8 = (0, _possibleConstructorReturn3.default)(this, (ErrorPanel.__proto__ || (0, _getPrototypeOf2.default)(ErrorPanel)).call(this, props));

		_this8.expand = function () {
			if (!_this8.state.expanded) _this8.setState({ expanded: true });
		};

		_this8.collapseToggle = function () {
			return _this8.setState({ expanded: !_this8.state.expanded });
		};

		_this8.state = { expanded: true };
		return _this8;
	}

	(0, _createClass3.default)(ErrorPanel, [{
		key: "render",
		value: function render() {
			var _props5 = this.props,
			    errors = _props5.errors,
			    title = _props5.title,
			    clickHandler = _props5.clickHandler,
			    poppedToggle = _props5.poppedToggle,
			    showToggle = _props5.showToggle,
			    classNames = _props5.classNames;


			if (errors.length === 0) return null;

			return _react2.default.createElement(
				_reactBootstrap.Panel,
				{ collapsible: "true", expanded: this.state.expanded, onToggle: this.collapseToggle,
					className: classNames },
				_react2.default.createElement(
					_PanelHeading2.default,
					null,
					_react2.default.createElement(
						"div",
						{ className: "laji-form-clickable-panel-header", onClick: this.collapseToggle },
						_react2.default.createElement(
							"div",
							{ className: "panel-title" },
							title,
							_react2.default.createElement(
								"span",
								{ className: "pull-right" },
								_react2.default.createElement(GlyphButton, { glyph: this.state.expanded ? "chevron-up" : "chevron-down", bsStyle: "link" }),
								showToggle ? _react2.default.createElement(GlyphButton, { glyph: "new-window", bsStyle: "link", onClick: poppedToggle }) : null
							)
						)
					)
				),
				_react2.default.createElement(
					_PanelCollapse2.default,
					null,
					_react2.default.createElement(
						_reactBootstrap.ListGroup,
						null,
						errors.map(function (_ref7, i) {
							var label = _ref7.label,
							    error = _ref7.error,
							    id = _ref7.id,
							    getId = _ref7.getId,
							    _ref7$extra = _ref7.extra,
							    extra = _ref7$extra === undefined ? null : _ref7$extra,
							    disabled = _ref7.disabled;

							var message = error && error.message ? error.message : error;
							var _clickHandler = function _clickHandler() {
								clickHandler(id || (getId ? getId() : undefined));
							};

							return _react2.default.createElement(
								_reactBootstrap.ListGroupItem,
								{ key: i, onClick: _clickHandler, disabled: disabled },
								label ? _react2.default.createElement(
									"b",
									null,
									label,
									":"
								) : null,
								" ",
								message,
								" ",
								extra
							);
						})
					)
				)
			);
		}
	}]);
	return ErrorPanel;
}(_react.Component);

function NullTooltip() {
	return _react2.default.createElement("div", null);
}

// Tooltip component that doesn't show tooltip for empty/undefined tooltip.

var TooltipComponent = exports.TooltipComponent = function (_Component7) {
	(0, _inherits3.default)(TooltipComponent, _Component7);

	function TooltipComponent() {
		var _ref8;

		var _temp2, _this9, _ret2;

		(0, _classCallCheck3.default)(this, TooltipComponent);

		for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
			args[_key2] = arguments[_key2];
		}

		return _ret2 = (_temp2 = (_this9 = (0, _possibleConstructorReturn3.default)(this, (_ref8 = TooltipComponent.__proto__ || (0, _getPrototypeOf2.default)(TooltipComponent)).call.apply(_ref8, [this].concat(args))), _this9), _this9.setOverlayRef = function (elem) {
			_this9.overlayElem = elem;
		}, _this9.onMouseOver = function () {
			return _this9.overlayElem.show();
		}, _this9.onMouseOut = function () {
			return _this9.overlayElem.hide();
		}, _temp2), (0, _possibleConstructorReturn3.default)(_this9, _ret2);
	}

	(0, _createClass3.default)(TooltipComponent, [{
		key: "render",
		value: function render() {
			var _props6 = this.props,
			    tooltip = _props6.tooltip,
			    children = _props6.children,
			    id = _props6.id,
			    placement = _props6.placement,
			    trigger = _props6.trigger,
			    className = _props6.className;


			var overlay = _react2.default.createElement(
				_reactBootstrap.OverlayTrigger,
				{ ref: this.setOverlayRef, placement: placement, trigger: trigger === "hover" ? [] : trigger, key: id + "-overlay", overlay: tooltip ? _react2.default.createElement(
						_reactBootstrap.Tooltip,
						{ id: id + "-tooltip", className: "" + className },
						_react2.default.isValidElement(tooltip) ? tooltip : _react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: tooltip } })
					) : _react2.default.createElement(NullTooltip, null) },
				children
			);

			return trigger === "hover" ? _react2.default.createElement(
				"div",
				{ onMouseOver: this.onMouseOver, onMouseOut: this.onMouseOut },
				overlay
			) : overlay;
		}
	}]);
	return TooltipComponent;
}(_react.Component);

var FetcherInput = exports.FetcherInput = function (_Component8) {
	(0, _inherits3.default)(FetcherInput, _Component8);

	function FetcherInput() {
		var _ref9;

		var _temp3, _this10, _ret3;

		(0, _classCallCheck3.default)(this, FetcherInput);

		for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
			args[_key3] = arguments[_key3];
		}

		return _ret3 = (_temp3 = (_this10 = (0, _possibleConstructorReturn3.default)(this, (_ref9 = FetcherInput.__proto__ || (0, _getPrototypeOf2.default)(FetcherInput)).call.apply(_ref9, [this].concat(args))), _this10), _this10.setRef = function (elem) {
			if (_this10.props.getRef) _this10.props.getRef(elem);
		}, _temp3), (0, _possibleConstructorReturn3.default)(_this10, _ret3);
	}

	(0, _createClass3.default)(FetcherInput, [{
		key: "render",
		value: function render() {
			var _props7 = this.props,
			    loading = _props7.loading,
			    validationState = _props7.validationState,
			    glyph = _props7.glyph,
			    getRef = _props7.getRef,
			    extra = _props7.extra,
			    appendExtra = _props7.appendExtra,
			    onMouseOver = _props7.onMouseOver,
			    onMouseOut = _props7.onMouseOut,
			    _props7$className = _props7.className,
			    className = _props7$className === undefined ? "" : _props7$className,
			    InputComponent = _props7.InputComponent,
			    inputProps = (0, _objectWithoutProperties3.default)(_props7, ["loading", "validationState", "glyph", "getRef", "extra", "appendExtra", "onMouseOver", "onMouseOut", "className", "InputComponent"]); // eslint-disable-line no-unused-vars

			var Input = InputComponent ? InputComponent : FetcherInputDefaultInput;
			return _react2.default.createElement(
				"div",
				{ className: "fetcher-input " + (extra ? " input-group" : "") + " has-feedback" + (validationState ? " has-" + validationState : "") + " " + className, onMouseOver: onMouseOver, onMouseOut: onMouseOut },
				extra,
				_react2.default.createElement(Input, (0, _extends3.default)({}, inputProps, { ref: this.setRef })),
				glyph ? _react2.default.createElement(
					_reactBootstrap.FormControl.Feedback,
					null,
					glyph
				) : null,
				loading ? _react2.default.createElement(_reactSpinner2.default, null) : null,
				appendExtra
			);
		}
	}]);
	return FetcherInput;
}(_react.Component);

var FetcherInputDefaultInput = function (_Component9) {
	(0, _inherits3.default)(FetcherInputDefaultInput, _Component9);

	function FetcherInputDefaultInput() {
		(0, _classCallCheck3.default)(this, FetcherInputDefaultInput);
		return (0, _possibleConstructorReturn3.default)(this, (FetcherInputDefaultInput.__proto__ || (0, _getPrototypeOf2.default)(FetcherInputDefaultInput)).apply(this, arguments));
	}

	(0, _createClass3.default)(FetcherInputDefaultInput, [{
		key: "render",
		value: function render() {
			var _props8 = this.props,
			    readonly = _props8.readonly,
			    inputProps = (0, _objectWithoutProperties3.default)(_props8, ["readonly"]);

			return _react2.default.createElement("input", (0, _extends3.default)({ className: "form-control", type: "text" }, inputProps, { readOnly: readonly, ref: this.ref }));
		}
	}]);
	return FetcherInputDefaultInput;
}(_react.Component);

// Bootstrap OverlayTrigger that is hoverable if hoverable === true


var OverlayTrigger = exports.OverlayTrigger = function (_Component10) {
	(0, _inherits3.default)(OverlayTrigger, _Component10);

	function OverlayTrigger() {
		var _ref10;

		var _temp4, _this12, _ret4;

		(0, _classCallCheck3.default)(this, OverlayTrigger);

		for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
			args[_key4] = arguments[_key4];
		}

		return _ret4 = (_temp4 = (_this12 = (0, _possibleConstructorReturn3.default)(this, (_ref10 = OverlayTrigger.__proto__ || (0, _getPrototypeOf2.default)(OverlayTrigger)).call.apply(_ref10, [this].concat(args))), _this12), _this12.setOverlayTriggerRef = function (elem) {
			_this12.overlayTriggerRef = elem;
		}, _this12.overlayTriggerMouseOver = function () {
			_this12.overlayTriggerMouseIn = true;
			_this12.overlayTriggerRef.show();
		}, _this12.overlayTriggerMouseOut = function () {
			_this12.overlayTriggerMouseIn = false;
			if (_this12.overlayTimeout) {
				clearTimeout(_this12.overlayTimeout);
			}
			_this12.overlayTimeout = _this12.props._context.setTimeout(function () {
				if (!_this12.popoverMouseIn && !_this12.overlayTriggerMouseIn && _this12.overlayTriggerRef) _this12.overlayTriggerRef.hide();
			}, 200);
		}, _this12.overlayMouseOver = function () {
			_this12.overlayMouseIn = true;
		}, _this12.overlayMouseOut = function () {
			_this12.overlayMouseIn = false;
			if (_this12.overlayTimeout) {
				clearTimeout(_this12.overlayTimeout);
			}
			_this12.overlayTimeout = _this12.props._context.setTimeout(function () {
				if (!_this12.overlayMouseIn && !_this12.overlayTriggerMouseIn && _this12.overlayTriggerRef) _this12.overlayTriggerRef.hide();
			}, 200);
		}, _temp4), (0, _possibleConstructorReturn3.default)(_this12, _ret4);
	}

	(0, _createClass3.default)(OverlayTrigger, [{
		key: "render",
		value: function render() {
			var _props9 = this.props,
			    children = _props9.children,
			    overlay = _props9.overlay,
			    _context = _props9._context,
			    props = (0, _objectWithoutProperties3.default)(_props9, ["children", "overlay", "_context"]);


			if (!this.props.hoverable) return _react2.default.createElement(
				_reactBootstrap.OverlayTrigger,
				(0, _extends3.default)({}, props, { overlay: overlay }),
				children
			);

			var _overlay = _react2.default.cloneElement(overlay, { onMouseOver: this.overlayMouseOver, onMouseOut: this.overlayMouseOut });

			return _react2.default.createElement(
				"div",
				{ onMouseOver: this.overlayTriggerMouseOver, onMouseOut: this.overlayTriggerMouseOut },
				_react2.default.createElement(
					_reactBootstrap.OverlayTrigger,
					(0, _extends3.default)({}, props, {
						delay: 1,
						trigger: [],
						placement: this.props.placement || "top",
						ref: this.setOverlayTriggerRef,
						overlay: _overlay }),
					children
				)
			);
		}
	}]);
	return OverlayTrigger;
}(_react.Component);

var Fullscreen = exports.Fullscreen = function (_Component11) {
	(0, _inherits3.default)(Fullscreen, _Component11);

	function Fullscreen() {
		(0, _classCallCheck3.default)(this, Fullscreen);
		return (0, _possibleConstructorReturn3.default)(this, (Fullscreen.__proto__ || (0, _getPrototypeOf2.default)(Fullscreen)).apply(this, arguments));
	}

	(0, _createClass3.default)(Fullscreen, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.bodyOverFlow = document.body.style.overflow;

			if (this.props.onKeyDown) {
				this._onKeyDown = true;
				new _Context2.default(this.props.contextId).addGlobalEventHandler("keydown", this.props.onKeyDown);
			}
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			document.body.style.overflow = this.bodyOverFlow;
			if (this._onKeyDown) {
				new _Context2.default(this.props.contextId).removeGlobalEventHandler("keydown", this.props.onKeyDown);
			}
		}
	}, {
		key: "render",
		value: function render() {
			return (0, _reactDom.createPortal)(_react2.default.createElement(
				"div",
				{ className: "laji-form fullscreen" },
				this.props.children
			), document.body);
		}
	}]);
	return Fullscreen;
}(_react.Component);

var FailedBackgroundJobsPanel = exports.FailedBackgroundJobsPanel = function (_Component12) {
	(0, _inherits3.default)(FailedBackgroundJobsPanel, _Component12);

	function FailedBackgroundJobsPanel(props) {
		(0, _classCallCheck3.default)(this, FailedBackgroundJobsPanel);

		var _this14 = (0, _possibleConstructorReturn3.default)(this, (FailedBackgroundJobsPanel.__proto__ || (0, _getPrototypeOf2.default)(FailedBackgroundJobsPanel)).call(this, props));

		_this14.dismissFailedJob = function (_ref11) {
			var id = _ref11.id,
			    hook = _ref11.hook,
			    running = _ref11.running;
			return function (e) {
				e.stopPropagation();
				if (running) return;
				_this14.props.context.removeSubmitHook(id, hook);
			};
		};

		_this14.retryFailedJob = function (_ref12) {
			var hook = _ref12.hook,
			    running = _ref12.running;
			return function (e) {
				e.stopPropagation();
				if (running) return;
				hook();
			};
		};

		_this14.poppedToggle = function (e) {
			e.stopPropagation();
			_this14.setState({ popped: !_this14.state.popped, poppedTouched: true });
		};

		_this14.state = { popped: true };
		return _this14;
	}

	(0, _createClass3.default)(FailedBackgroundJobsPanel, [{
		key: "render",
		value: function render() {
			var _this15 = this;

			var _props10 = this.props,
			    _props10$jobs = _props10.jobs,
			    jobs = _props10$jobs === undefined ? [] : _props10$jobs,
			    schema = _props10.schema,
			    uiSchema = _props10.uiSchema,
			    translations = _props10.formContext.translations;


			if (!jobs.length) return null;

			var errors = jobs.reduce(function (_errors, error) {
				var lajiFormId = error.lajiFormId,
				    relativePointer = error.relativePointer,
				    e = error.e,
				    running = error.running;

				if (!e) {
					return _errors;
				}
				var getJsonPointer = function getJsonPointer() {
					return (0, _utils.getJSONPointerFromLajiFormIdAndRelativePointer)(_this15.props.tmpIdTree, _this15.props.context.formData, lajiFormId, relativePointer);
				};
				var jsonPointer = getJsonPointer();
				var label = (0, _utils.parseJSONPointer)(uiSchema, (0, _utils.uiSchemaJSONPointer)(uiSchema, jsonPointer) + "/ui:title", "safely") || (0, _utils.parseJSONPointer)(schema, (0, _utils.schemaJSONPointer)(schema, jsonPointer) + "/title", "safely");
				var retryButton = _react2.default.createElement(
					"a",
					{ key: "rety", className: "pull-right", disabled: running, onClick: _this15.retryFailedJob(error) },
					_react2.default.createElement(_reactBootstrap.Glyphicon, { className: running ? "rotating" : "", glyph: "refresh" }),
					" ",
					translations.Retry
				);
				var dismissButton = _react2.default.createElement(
					"a",
					{ key: "dismiss", className: "pull-right", onClick: _this15.dismissFailedJob(error) },
					_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "ok" }),
					" ",
					translations.Dismiss
				);

				var getId = function getId() {
					var jsonPointer = getJsonPointer();
					return "root_" + (0, _utils.JSONPointerToId)(jsonPointer);
				};
				var _error = { getId: getId, error: e, extra: [dismissButton, retryButton], disabled: running };
				if (label) _error.label = label;
				return [].concat((0, _toConsumableArray3.default)(_errors), [_error]);
			}, []);

			if (!errors.length) return null;

			return _react2.default.createElement(
				"div",
				{ className: "laji-form-error-list laji-form-failed-jobs-list" + (this.state.popped ? " laji-form-popped" : ""),
					style: this.state.popped ? { top: (this.props.formContext.topOffset || 0) + 5 } : null },
				_react2.default.createElement(ErrorPanel, {
					title: translations.FailedBackgroundJobs,
					errors: errors,
					showToggle: true,
					poppedToggle: this.poppedToggle,
					clickHandler: this.props.errorClickHandler,
					classNames: "error-panel"
				}),
				_react2.default.createElement(
					"div",
					{ className: "panel-footer" },
					_react2.default.createElement(
						Button,
						{ onClick: this.props.context.removeAllSubmitHook },
						_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: "ok" }),
						" ",
						translations.Dismiss + " " + translations.all
					)
				)
			);
		}
	}]);
	return FailedBackgroundJobsPanel;
}(_react.Component);