"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _reactBootstrap = require("react-bootstrap");

var _LajiForm = require("../LajiForm");

var _LajiForm2 = _interopRequireDefault(_LajiForm);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _components = require("../components");

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _utils2 = require("laji-map/lib/utils");

var _utils3 = require("react-jsonschema-form/lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var AnnotationField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(AnnotationField, _Component);

	function AnnotationField(props) {
		(0, _classCallCheck3.default)(this, AnnotationField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (AnnotationField.__proto__ || (0, _getPrototypeOf2.default)(AnnotationField)).call(this, props));

		_this.getButton = function () {
			var annotations = _this.getAnnotations();
			return {
				glyph: "comment",
				tooltip: _this.props.formContext.translations.ShowAnnotations,
				tooltipPlacement: "left",
				fn: _this.onClick,
				bsStyle: annotations && annotations.length ? "primary" : "default"
			};
		};

		_this.onClick = function () {
			return function () {
				_this.setState({ show: !_this.state.show });
			};
		};

		_this.onHide = function () {
			_this.setState({ show: false });
		};

		_this.getAnnotations = function () {
			var _this$props$formConte = _this.props.formContext.uiSchemaContext.annotations,
			    annotations = _this$props$formConte === undefined ? {} : _this$props$formConte;
			var id = _this.props.formData.id;

			return new _Context2.default(_this.props.formContext.contextId + "_ANNOTATIONS")[id] || annotations[id];
		};

		_this.state = { show: false };
		return _this;
	}

	(0, _createClass3.default)(AnnotationField, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    adminOnly = _getUiOptions.adminOnly,
			    container = _getUiOptions.container,
			    add = _getUiOptions.add,
			    filter = _getUiOptions.filter,
			    annotationUiSchema = _getUiOptions.uiSchema,
			    _getUiOptions$buttons = _getUiOptions.buttonsPath,
			    buttonsPath = _getUiOptions$buttons === undefined ? "/" : _getUiOptions$buttons,
			    formId = _getUiOptions.formId;

			var innerUiSchema = (0, _utils.getInnerUiSchema)(this.props.uiSchema);
			var uiSchema = adminOnly && !this.props.formContext.uiSchemaContext.isAdmin || !this.props.formContext.uiSchemaContext.isEdit || !this.props.formData.id ? innerUiSchema : (0, _utils.injectButtons)(innerUiSchema, [this.getButton()], buttonsPath);

			var Container = undefined;

			switch (container) {
				case "modal":
					Container = function Container(_ref) {
						var children = _ref.children;

						return _react2.default.createElement(
							_reactBootstrap.Modal,
							{ show: true, dialogClassName: "laji-form", onHide: _this2.onHide },
							_react2.default.createElement(_reactBootstrap.Modal.Header, { closeButton: true }),
							_react2.default.createElement(
								_reactBootstrap.Modal.Body,
								null,
								children
							)
						);
					};
					break;
				default:
					Container = function Container(_ref2) {
						var children = _ref2.children;
						return _react2.default.createElement(
							"div",
							null,
							children
						);
					};
			}

			var SchemaField = this.props.registry.fields.SchemaField;

			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: uiSchema })),
				this.props.formData.id && (container !== "modal" || this.state.show) && _react2.default.createElement(
					Container,
					null,
					_react2.default.createElement(AnnotationBox, {
						id: this.props.formData.id,
						annotations: this.getAnnotations(),
						lang: this.props.formContext.lang,
						formContext: this.props.formContext,
						add: add,
						uiSchema: annotationUiSchema,
						filter: filter,
						formId: formId
					})
				)
			);
		}
	}]);
	return AnnotationField;
}(_react.Component)) || _class;

AnnotationField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			adminOnly: _propTypes2.default.bool,
			container: _propTypes2.default.oneOf(["modal"]),
			add: _propTypes2.default.object,
			filter: _propTypes2.default.object,
			uiSchema: _propTypes2.default.object,
			buttonsPath: _propTypes2.default.string,
			formId: _propTypes2.default.string
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = AnnotationField;


new _Context2.default("SCHEMA_FIELD_WRAPPERS").AnnotationField = true;

var AnnotationBox = function (_Component2) {
	(0, _inherits3.default)(AnnotationBox, _Component2);

	function AnnotationBox(props) {
		(0, _classCallCheck3.default)(this, AnnotationBox);

		var _this3 = (0, _possibleConstructorReturn3.default)(this, (AnnotationBox.__proto__ || (0, _getPrototypeOf2.default)(AnnotationBox)).call(this, props));

		_this3.onAnnotationSubmit = function (_ref3) {
			var formData = _ref3.formData;

			var _this3$getAddOptions = _this3.getAddOptions(),
			    type = _this3$getAddOptions.type;

			var context = new _Context2.default(_this3.props.formContext.contextId);
			context.pushBlockingLoader();
			_this3.props.formContext.apiClient.fetchRaw("/annotations", undefined, {
				method: "POST",
				body: (0, _stringify2.default)((0, _extends3.default)({}, formData, { targetID: _this3.props.id, rootID: context.formData.id, type: type, byRole: "MMAN.formAdmin" }))
			}).then(function (response) {
				if (response.status >= 400) {
					throw new Error("Request failed");
				}
				return response.json();
			}).then(function (annotation) {
				context.popBlockingLoader();
				var annotationContext = new _Context2.default(_this3.props.formContext.contextId + "_ANNOTATIONS");
				var annotations = [annotation];
				annotationContext[_this3.props.id] = annotations;
				_this3.setState({ annotations: annotations, fail: false });
			}).catch(function () {
				context.popBlockingLoader();
				_this3.setState({ fail: true });
			});
		};

		_this3.onAnnotationChange = function (formData) {
			var state = {};
			if (_this3.state.fail !== undefined) {
				state.fail = undefined;
			}

			var _this3$getAddOptions2 = _this3.getAddOptions(),
			    submitOnChange = _this3$getAddOptions2.submitOnChange;

			if (submitOnChange) {
				_this3.onAnnotationSubmit({ formData: formData });
			}
			state.addFormData = formData;
			_this3.setState(state);
		};

		_this3.getAddOptions = function () {
			var _this3$props = _this3.props,
			    add = _this3$props.add,
			    isAdmin = _this3$props.formContext.uiSchemaContext.isAdmin;

			var addOptions = (0, _utils2.isObject)(add) ? add : {};
			var submitOnChange = "submitOnChange" in addOptions ? addOptions.submitOnChange : false;
			var type = isAdmin ? "MAN.typeAdmin" : addOptions.type;
			return (0, _extends3.default)({}, addOptions, { submitOnChange: submitOnChange, type: type });
		};

		_this3.renderAdd = function () {
			var _this3$props2 = _this3.props,
			    formContext = _this3$props2.formContext,
			    add = _this3$props2.add;
			var lang = formContext.lang,
			    translations = formContext.translations;
			var metadataForm = _this3.state.metadataForm;


			if (!metadataForm) {
				return null;
			}

			var _uiSchema = _this3.getUiSchema();
			var addSchema = undefined;
			var addUiSchema = undefined;
			var submitOnChange = undefined;
			var addFormData = undefined;
			if (add && metadataForm && metadataForm.schema) {
				var _this3$getAddOptions3 = _this3.getAddOptions(),
				    adminOnly = _this3$getAddOptions3.adminOnly,
				    _filter = _this3$getAddOptions3.filter,
				    _addUiSchema = _this3$getAddOptions3.uiSchema,
				    _submitOnChange = _this3$getAddOptions3._submitOnChange,
				    formData = _this3$getAddOptions3.formData;

				if (adminOnly && !formContext.uiSchemaContext.isAdmin) {
					return null;
				}

				var propArray = (0, _keys2.default)(metadataForm.schema.properties);
				propArray = (0, _utils.filter)(propArray, ["created", "annotationByPerson"], "blacklist");
				if (_filter) propArray = (0, _utils.filter)(propArray, _filter.filter, _filter.filterType);

				var addSchemaProperties = propArray.reduce(function (properties, prop) {
					properties[prop] = metadataForm.schema.properties[prop];
					return properties;
				}, {});
				addSchema = (0, _extends3.default)({}, metadataForm.schema, { properties: addSchemaProperties });
				addUiSchema = _addUiSchema || (0, _extends3.default)({}, _uiSchema, { "ui:readonly": false });
				submitOnChange = _submitOnChange;
				addFormData = _this3.state.addFormData || (formData ? (0, _utils3.getDefaultFormState)(addSchema, formData) : undefined);
			}

			var renderSubmit = !submitOnChange;

			return add && addSchema ? _react2.default.createElement(
				_LajiForm2.default,
				(0, _extends3.default)({}, metadataForm, {
					schema: addSchema,
					uiSchema: addUiSchema || _uiSchema,
					onSubmit: _this3.onAnnotationSubmit,
					onChange: _this3.onAnnotationChange,
					renderSubmit: renderSubmit,
					formData: addFormData,
					lang: lang,
					apiClient: _this3.props.formContext.apiClient.apiClient,
					uiSchemaContext: _this3.props.formContext.uiSchemaContext
				}),
				_react2.default.createElement(
					"div",
					null,
					_this3.state.fail !== undefined && _react2.default.createElement(
						_reactBootstrap.Alert,
						{ bsStyle: _this3.state.fail ? "danger" : "success" },
						translations[_this3.state.fail ? "SaveFail" : "SaveSuccess"]
					),
					renderSubmit && _react2.default.createElement(
						_components.Button,
						{ id: "submit", type: "submit" },
						translations.Submit
					)
				)
			) : null;
		};

		_this3.getUiSchema = function () {
			var uiSchema = _this3.props.uiSchema;

			var mainContext = new _Context2.default(_this3.props.contextId);
			var _this3$state$metadata = _this3.state.metadataForm,
			    metadataForm = _this3$state$metadata === undefined ? {} : _this3$state$metadata;

			return uiSchema || (0, _extends3.default)({}, metadataForm.uiSchema, {
				"ui:shortcuts": (0, _extends3.default)({}, (metadataForm.uiSchema || {})["ui:shorcuts"] || {}, mainContext.shortcuts || {}),
				"ui:showShortcutsButton": false
			});
		};

		_this3.onDelete = function (id) {
			return function () {
				_this3.props.formContext.apiClient.fetchRaw("/annotations/" + id, undefined, {
					method: "DELETE"
				}).then(function () {
					var annotationContext = new _Context2.default(_this3.props.formContext.contextId + "_ANNOTATIONS");
					var annotations = _this3.state.annotations.filter(function (_ref4) {
						var _id = _ref4.id;
						return _id !== id;
					});
					annotationContext[_this3.props.id] = annotations;
					_this3.setState({ deleteFail: false, annotations: annotations });
				}).catch(function () {
					_this3.setState({ deleteFail: true });
				});
			};
		};

		_this3.state = { annotations: props.annotations || [] };
		return _this3;
	}

	(0, _createClass3.default)(AnnotationBox, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this4 = this;

			this.mounted = true;
			this.props.formContext.apiClient.fetchCached("/forms/" + this.props.formId, { lang: this.props.lang, format: "schema" }).then(function (metadataForm) {
				if (!_this4.mounted) return;
				var _filter = _this4.props.filter;

				var propArray = (0, _keys2.default)(metadataForm.schema.properties);
				if (_filter) propArray = (0, _utils.filter)(propArray, _filter.filter, _filter.filterType);

				var schemaProperties = propArray.reduce(function (properties, prop) {
					properties[prop] = metadataForm.schema.properties[prop];
					return properties;
				}, {});
				var schema = (0, _extends3.default)({}, metadataForm.schema, { properties: schemaProperties });
				_this4.setState({ metadataForm: (0, _extends3.default)({}, metadataForm, { schema: schema }) });
			});
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var _this5 = this;

			var _props$formContext = this.props.formContext,
			    translations = _props$formContext.translations,
			    lang = _props$formContext.lang,
			    apiClient = _props$formContext.apiClient;
			var _state = this.state,
			    _state$metadataForm = _state.metadataForm,
			    metadataForm = _state$metadataForm === undefined ? {} : _state$metadataForm,
			    _state$annotations = _state.annotations,
			    annotations = _state$annotations === undefined ? [] : _state$annotations;

			var _uiSchema = (0, _extends3.default)({}, this.getUiSchema(), { "ui:readonly": true });

			return _react2.default.createElement(
				_reactBootstrap.Panel,
				{ header: _react2.default.createElement(
						"strong",
						null,
						translations.Comments
					) },
				this.renderAdd(),
				_react2.default.createElement(
					_reactBootstrap.ListGroup,
					null,
					this.state.metadataForm ? annotations.slice(0).reverse().map(function (annotation, idx) {
						return _react2.default.createElement(
							_reactBootstrap.ListGroupItem,
							{ key: idx, className: "annotation-list" + (idx % 2 === 0 ? "" : "-odd") },
							_react2.default.createElement(
								"div",
								null,
								_react2.default.createElement(_LajiForm2.default, (0, _extends3.default)({}, metadataForm, {
									uiSchema: _uiSchema,
									lang: lang,
									formData: annotation,
									renderSubmit: false,
									apiClient: apiClient.apiClient,
									uiSchemaContext: _this5.props.formContext.uiSchemaContext
								}))
							)
						);
					}) : _react2.default.createElement(_reactSpinner2.default, null)
				),
				this.state.deleteFail && _react2.default.createElement(
					_reactBootstrap.Alert,
					{ bsStyle: "danger" },
					translations["DeleteFail"]
				)
			);
		}
	}]);
	return AnnotationBox;
}(_react.Component);

AnnotationBox.defaultProps = {
	formId: "MHL.15"
};