"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _utils2 = require("../../utils");

var _deepmerge = require("deepmerge");

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Transforms an object schema containing arrays to an array schema containing objects.
 *
 * uischema = {"ui:options": {
 *  uiSchema: <uiSchema> (uiSchema which is passed to array items)
 * }
 */
var ArrayCombinerField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ArrayCombinerField, _Component);

	function ArrayCombinerField() {
		(0, _classCallCheck3.default)(this, ArrayCombinerField);
		return (0, _possibleConstructorReturn3.default)(this, (ArrayCombinerField.__proto__ || (0, _getPrototypeOf2.default)(ArrayCombinerField)).apply(this, arguments));
	}

	(0, _createClass3.default)(ArrayCombinerField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _this2 = this;

			var _getUiOptions = this.getUiOptions(),
			    additionalItemsAmount = _getUiOptions.additionalItemsAmount;

			var itemSchema = { type: "object", properties: {}, required: props.schema.required };
			var schema = { type: "array" };
			if (additionalItemsAmount) schema.additionalItems = itemSchema;
			if (props.schema.hasOwnProperty("title")) schema.title = props.schema.title;
			(0, _keys2.default)(props.schema.properties).forEach(function (propertyName) {
				var propertyOrigin = props.schema.properties[propertyName];
				var property = propertyOrigin.items;
				if (property.type === "object" || property.type === "array") throw "items properties can't be objects or arrays";
				if (propertyOrigin.title) property.title = propertyOrigin.title;
				itemSchema.properties[propertyName] = property;
			});

			schema.items = itemSchema;
			if (additionalItemsAmount) {
				schema.items = Array(additionalItemsAmount).fill(itemSchema);
				schema.additionalItems = itemSchema;
			}

			var uiSchema = (0, _keys2.default)(props.schema.properties).reduce(function (_uiSchema, field) {
				if (field in _uiSchema) {
					_uiSchema = (0, _extends4.default)({}, _uiSchema, { items: (0, _extends4.default)({}, _uiSchema.items || {}, (0, _defineProperty3.default)({}, field, _uiSchema[field])) });
					(0, _utils2.immutableDelete)("_uiSchema", field);
				}
				return _uiSchema;
			}, props.uiSchema);

			function objectsToArray(array, objects) {
				if (objects) (0, _keys2.default)(objects).forEach(function (dataCol) {
					if (objects[dataCol]) for (var row in objects[dataCol]) {
						var val = objects[dataCol][row];
						if (!array[row]) array[row] = {};
						array[row][dataCol] = val;
					}
				});
				return array;
			}

			function rotateErrorSchema(rotatedErrorSchema, errorSchema) {
				if (errorSchema) (0, _keys2.default)(errorSchema).forEach(function (property) {
					var error = errorSchema[property];

					if (property === "__errors") {
						rotatedErrorSchema.__errors = error;
					} else {
						if (error) (0, _keys2.default)(error).forEach(function (idx) {
							if (idx === "__errors") {
								rotatedErrorSchema.__errors = rotatedErrorSchema.__errors ? [].concat((0, _toConsumableArray3.default)(rotatedErrorSchema.__errors), (0, _toConsumableArray3.default)(error.__errors)) : error.__errors;
							} else {
								var propertyError = (0, _defineProperty3.default)({}, property, error[idx]);
								rotatedErrorSchema[idx] = rotatedErrorSchema[idx] ? (0, _deepmerge2.default)(rotatedErrorSchema[idx], propertyError) : propertyError;
							}
						});
					}
				});
				return rotatedErrorSchema;
			}

			var errorSchema = rotateErrorSchema({}, props.errorSchema);
			var formData = objectsToArray([], props.formData);
			formData.forEach(function (obj) {
				(0, _keys2.default)(itemSchema.properties).forEach(function (prop) {
					if (!obj.hasOwnProperty(prop)) {
						obj[prop] = (0, _utils.getDefaultFormState)(itemSchema.properties[prop], undefined, _this2.props.registry.definitions);
					}
				});
			});
			return { schema: schema, errorSchema: errorSchema, formData: formData, uiSchema: uiSchema };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _this3 = this;

			var origArraysContainer = {};
			if (!formData || formData.length === 0) {
				(0, _keys2.default)(this.props.schema.properties).forEach(function (prop) {
					origArraysContainer[prop] = [];
				});
			} else {
				formData.forEach(function (obj) {
					(0, _keys2.default)(_this3.props.schema.properties).forEach(function (arrName) {
						origArraysContainer[arrName] ? origArraysContainer[arrName].push(obj[arrName]) : origArraysContainer[arrName] = [obj[arrName]];
					});
				});
			}
			this.props.onChange(origArraysContainer);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "ArrayCombinerField";
		}
	}]);
	return ArrayCombinerField;
}(_react.Component)) || _class;

ArrayCombinerField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			additionalItemsAmount: _propTypes2.default.number
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = ArrayCombinerField;