"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Enables leaking any prop to any other prop container.
 *
 * uiSchema = {"ui:options": {
 *	props: [
 *		{
 *			from: If a regular string, a property to copy from formData. If a JSON pointer, the root will be this.props.
 *			target: Target where to copy the 'from'. If a regular string, it will be copied to /uischema/ui:options. If a JSON pointer, the root will be this.props.
 *		}
 */
var DataLeakerField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(DataLeakerField, _Component);

	function DataLeakerField() {
		(0, _classCallCheck3.default)(this, DataLeakerField);
		return (0, _possibleConstructorReturn3.default)(this, (DataLeakerField.__proto__ || (0, _getPrototypeOf2.default)(DataLeakerField)).apply(this, arguments));
	}

	(0, _createClass3.default)(DataLeakerField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _getUiOptions = this.getUiOptions(props.uiSchema),
			    _getUiOptions$props = _getUiOptions.props,
			    _props = _getUiOptions$props === undefined ? [] : _getUiOptions$props;

			return (Array.isArray(_props) ? _props : [_props]).reduce(function (props, strOrObjProp) {
				var _map = ["from", "fromArrayKey", "target", "joinArray"].map(function (p) {
					return strOrObjProp[p];
				}),
				    _map2 = (0, _slicedToArray3.default)(_map, 4),
				    fromPath = _map2[0],
				    fromArrayKey = _map2[1],
				    targetPath = _map2[2],
				    joinArray = _map2[3];

				var from = fromPath[0] === "/" ? (0, _utils.parseJSONPointer)(props, fromPath) : (0, _utils.parseJSONPointer)(props.formData, fromPath);

				if (fromArrayKey) {
					from = (from || []).map(function (obj) {
						return obj[fromArrayKey];
					});
				}
				if (joinArray && Array.isArray(from)) {
					from = from.join(",");
				}

				var _targetPath = targetPath[0] === "/" ? targetPath : "/uiSchema/ui:options/" + targetPath;
				props = (0, _utils.updateSafelyWithJSONPointer)(props, from, _targetPath);
				return props;
			}, props);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "DataLeakerField";
		}
	}]);
	return DataLeakerField;
}(_react.Component)) || _class;

DataLeakerField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			props: _propTypes2.default.arrayOf(_propTypes2.default.shape({
				from: _propTypes2.default.string.isRequired,
				fromArrayKey: _propTypes2.default.string,
				target: _propTypes2.default.string,
				joinArray: _propTypes2.default.bool
			}))
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array", "object"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object])
};
exports.default = DataLeakerField;