"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _extends4 = require("babel-runtime/helpers/extends");

var _extends5 = _interopRequireDefault(_extends4);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Transforms an array field to o boolean field, where each value is true/false according to another array field.
 * Each value is true, if formData[booleanDefiner] == formData[booleanField].
 * uiSchema = { "ui:options": {
 *  booleanField: <array field name>,
 *  booleanDefiner: <array field name>,
 *  uiSchema: <uiSchema> (uiSchema used for each object).
 * }}
 */
var DependentBooleanField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(DependentBooleanField, _Component);

	function DependentBooleanField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, DependentBooleanField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DependentBooleanField.__proto__ || (0, _getPrototypeOf2.default)(DependentBooleanField)).call.apply(_ref, [this].concat(args))), _this), _this.getDictionarifiedFormData = function (formData, field) {
			var formDataDictionarified = {};
			(formData[field] || []).forEach(function (value) {
				formDataDictionarified[value] = true;
			});
			return formDataDictionarified;
		}, _this.getDictionarifiedBooleanFieldData = function (formData) {
			return _this.getDictionarifiedFormData(formData, _this.getUiOptions().booleanField);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(DependentBooleanField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var uiSchema = props.uiSchema,
			    formData = props.formData;

			var _getUiOptions = this.getUiOptions(),
			    booleanField = _getUiOptions.booleanField,
			    booleanDefiner = _getUiOptions.booleanDefiner;

			var schema = (0, _immutabilityHelper2.default)(props.schema, { properties: (0, _defineProperty3.default)({}, booleanField, { items: { $merge: { type: "boolean" } } }) });

			var booleanFieldDataDictionarified = this.getDictionarifiedBooleanFieldData(formData);

			var booleanFieldData = [];
			(formData[booleanDefiner] || []).forEach(function (definerItem) {
				booleanFieldData.push(!!booleanFieldDataDictionarified[definerItem]);
			});
			formData = (0, _extends5.default)({}, props.formData, (0, _defineProperty3.default)({}, booleanField, booleanFieldData));

			return { schema: schema, uiSchema: uiSchema, formData: formData };
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _getUiOptions2 = this.getUiOptions(),
			    booleanField = _getUiOptions2.booleanField,
			    booleanDefiner = _getUiOptions2.booleanDefiner;

			var propsFormData = this.props.formData;

			var newData = this.props.formData[booleanField];
			// if the change happened in booleanField data, reflect the changes to all booleanField items with same data.
			if ((0, _stringify2.default)(propsFormData[booleanDefiner]) === (0, _stringify2.default)(formData[booleanDefiner])) {
				var dictionarifiedOrigData = this.getDictionarifiedFormData(propsFormData, booleanField);
				formData[booleanDefiner].forEach(function (definerItem, i) {
					if (dictionarifiedOrigData[definerItem] && !formData[booleanField][i]) {
						newData = (0, _immutabilityHelper2.default)(newData, { $splice: [[newData.indexOf(definerItem), 1]] });
					} else if (!dictionarifiedOrigData[definerItem] && formData[booleanField][i]) {
						newData = newData ? [].concat((0, _toConsumableArray3.default)(newData), [definerItem]) : [definerItem];
					}
				});
			}

			if (newData) newData = newData.filter(function (item) {
				return formData[booleanDefiner].indexOf(item) !== -1;
			});

			formData = (0, _extends5.default)({}, formData, (0, _defineProperty3.default)({}, booleanField, newData));
			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "DependentBooleanField";
		}
	}]);
	return DependentBooleanField;
}(_react.Component)) || _class;

DependentBooleanField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			booleanField: _propTypes2.default.string.isRequired,
			booleanDefiner: _propTypes2.default.string.isRequired
		}).isRequired,
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = DependentBooleanField;