"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _utils = require("../../utils");

var _AutosuggestWidget = require("../widgets/AutosuggestWidget");

var _TagArrayField = require("./TagArrayField");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var EnumRangeArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(EnumRangeArrayField, _Component);
	(0, _createClass3.default)(EnumRangeArrayField, null, [{
		key: "getName",
		value: function getName() {
			return "EnumRangeArrayField";
		}
	}]);

	function EnumRangeArrayField(props) {
		(0, _classCallCheck3.default)(this, EnumRangeArrayField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (EnumRangeArrayField.__proto__ || (0, _getPrototypeOf2.default)(EnumRangeArrayField)).call(this, props));

		_this.setRef = function (elem) {
			_this.autosuggestRef = elem;
		};

		_this.onInputChange = function (e, autosuggestEvent) {
			var value = autosuggestEvent.newValue;


			if (autosuggestEvent.method !== "click") {
				_this.setState({ value: value });
			} else {
				_this.setState({ value: "" });
				if (!(0, _utils.focusNextInput)(_this.props.formContext.getFormRef(), document.getElementById(_this.props.idSchema.$id))) {
					var tagComponent = _this.autosuggestRef.inputElem;
					var tagComponentElem = (0, _reactDom.findDOMNode)(tagComponent);
					var input = tagComponentElem.querySelector("input");
					if (input) {
						input.focus();
					}
				}
			}
		};

		_this.onSuggestionSelected = function (suggestion) {
			_this.setState({ value: "" }, function () {
				_this.onChange([].concat((0, _toConsumableArray3.default)(_this.props.formData || []), [suggestion.value]), "suggestion selected");
			});
		};

		_this.onConfirmUnsuggested = function (value) {
			_this.setState({ value: "" }, function () {
				_this.onChange([].concat((0, _toConsumableArray3.default)(_this.props.formData || []), [value]), "unsuggested selected");
			});
		};

		_this.onChange = function (formData, reason) {
			function onlyUnique(value, index, self) {
				return self.indexOf(value) === index;
			}
			formData = formData.filter(onlyUnique);
			if (reason !== "remove" && reason !== "suggestion selected" && reason !== "unsuggested selected") {
				_this.setState({ value: "" });
				return;
			}
			_this.setState({ value: "" }, function () {
				_this.props.onChange(formData);
			});
		};

		_this.state = { value: "" };
		return _this;
	}

	(0, _createClass3.default)(EnumRangeArrayField, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			if (!(0, _deepEqual2.default)(props.formData, this.props.formData)) {
				new _Context2.default(props.formContext.contextId).sendCustomEvent(props.idSchema.$id, "resize");
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    range = _getUiOptions.range;

			var autosuggestOptions = {
				autosuggestField: range,
				onSuggestionSelected: this.onSuggestionSelected,
				onConfirmUnsuggested: this.onConfirmUnsuggested,
				id: this.props.idSchema.$id,
				value: this.state.value,
				controlledValue: true,
				minFetchLength: 0,
				wrapperClassName: "laji-form-enum-range",
				inputProps: {
					value: this.state.value,
					that: this,
					InputComponent: EnumRangeInputInjection,
					onChange: this.onInputChange,
					tags: this.props.formData,
					id: this.props.idSchema.$id
				}
			};

			var Label = this.props.formContext.Label;

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(Label, { label: this.props.schema.title, id: this.props.idSchema.$id }),
				_react2.default.createElement(_AutosuggestWidget.Autosuggest, (0, _extends3.default)({}, this.props, autosuggestOptions, { ref: this.setRef }))
			);
		}
	}]);
	return EnumRangeArrayField;
}(_react.Component)) || _class;

EnumRangeArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			range: _propTypes2.default.string
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = EnumRangeArrayField;

var EnumRangeInputInjection = function (_Component2) {
	(0, _inherits3.default)(EnumRangeInputInjection, _Component2);

	function EnumRangeInputInjection() {
		var _ref;

		var _temp, _this2, _ret;

		(0, _classCallCheck3.default)(this, EnumRangeInputInjection);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref = EnumRangeInputInjection.__proto__ || (0, _getPrototypeOf2.default)(EnumRangeInputInjection)).call.apply(_ref, [this].concat(args))), _this2), _this2.onInputChange = function (e) {
			_this2.props.onChange(e, { newValue: e.target.value });
		}, _this2.onChange = function (tags, reason) {
			_this2.props.that.onChange(tags, reason);
		}, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
	}

	(0, _createClass3.default)(EnumRangeInputInjection, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(_TagArrayField.TagInputComponent, (0, _extends3.default)({}, this.props, { onChange: this.onChange, onInputChange: this.onInputChange }));
		}
	}]);
	return EnumRangeInputInjection;
}(_react.Component);