"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ExtraLabelRowField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ExtraLabelRowField, _Component);

	function ExtraLabelRowField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ExtraLabelRowField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ExtraLabelRowField.__proto__ || (0, _getPrototypeOf2.default)(ExtraLabelRowField)).call.apply(_ref, [this].concat(args))), _this), _this.setContainerRef = function (elem) {
			_this.containerElem = elem;
		}, _this.getContainerRef = function () {
			return _this.containerElem;
		}, _this.getColContent = function (label, i) {
			var cols = _this.getCols(label.size);

			var Label = _this.props.formContext.Label;

			return _react2.default.createElement(
				_reactBootstrap.Col,
				(0, _extends3.default)({}, cols, { key: i }),
				_react2.default.createElement(Label, { label: label.label, id: _this.props.idSchema.$id, help: label.help })
			);
		}, _this.getCols = function (property) {
			var cols = { lg: 12, md: 12, sm: 12, xs: 12 };

			var options = (0, _utils.getUiOptions)(_this.props.uiSchema);
			(0, _keys2.default)(cols).forEach(function (col) {
				var optionCol = options[col];
				if ((typeof optionCol === "undefined" ? "undefined" : (0, _typeof3.default)(optionCol)) === "object") {
					var selector = undefined;
					if (optionCol[property]) selector = property;else if (optionCol["*"]) selector = "*";
					cols[col] = optionCol[selector];
				} else {
					cols[col] = optionCol;
				}
			});

			return cols;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ExtraLabelRowField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var propsWithInnerUiSchema = (0, _extends3.default)({}, props, {
				schema: (0, _extends3.default)({}, props.schema, { title: "" }),
				uiSchema: (0, _utils.getInnerUiSchema)(props.uiSchema),
				options: (0, _utils.getUiOptions)(props.uiSchema)
			});

			return (0, _extends3.default)({}, propsWithInnerUiSchema);
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props$registry$field = this.props.registry.fields,
			    SchemaField = _props$registry$field.SchemaField,
			    TitleField = _props$registry$field.TitleField;

			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    labels = _getUiOptions.labels,
			    titleClassName = _getUiOptions.titleClassName,
			    hiddenXs = _getUiOptions.hiddenXs,
			    affixed = _getUiOptions.affixed;

			var cols = [];

			labels.forEach(function (label, i) {
				cols.push(_this2.getColContent(label, i));
			});

			var title = this.props.schema.title !== undefined ? this.props.schema.title : this.props.name;

			var labelRow = _react2.default.createElement(
				_reactBootstrap.Row,
				{ className: "laji-form-label-row" + (hiddenXs ? " hidden-xs" : "") + (affixed ? " affixed-labels" : "") },
				cols
			);

			if (affixed) {
				labelRow = _react2.default.createElement(
					_components.Affix,
					{ getContainer: this.getContainerRef,
						style: affixed ? { position: "relative", zIndex: 1 } : undefined,
						topOffset: this.props.formContext.topOffset,
						bottomOffset: this.props.formContext.bottomOffset },
					labelRow
				);
			}

			return _react2.default.createElement(
				"div",
				{ ref: this.setContainerRef },
				title ? _react2.default.createElement(TitleField, { title: title, className: titleClassName, help: this.props.uiSchema["ui:help"], id: this.props.idSchema.$id }) : null,
				labelRow,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, this.state))
			);
		}
	}]);
	return ExtraLabelRowField;
}(_react.Component)) || _class;

ExtraLabelRowField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			labels: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
			lg: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			md: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			sm: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			xs: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.object]),
			hiddenXs: _propTypes2.default.boolean
		})
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object", "array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]).isRequired
};
exports.default = ExtraLabelRowField;