"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _from = require("babel-runtime/core-js/array/from");

var _from2 = _interopRequireDefault(_from);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _isomorphicFetch = require("isomorphic-fetch");

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _components = require("../components");

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _globals = require("laji-map/lib/globals");

var _utils2 = require("react-jsonschema-form/lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cache = {};

var GeocoderField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(GeocoderField, _Component);
	(0, _createClass3.default)(GeocoderField, null, [{
		key: "getName",
		value: function getName() {
			return "GeocoderField";
		}
	}]);

	function GeocoderField(props) {
		(0, _classCallCheck3.default)(this, GeocoderField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (GeocoderField.__proto__ || (0, _getPrototypeOf2.default)(GeocoderField)).call(this, props));

		_initialiseProps.call(_this);

		var loading = _this.getComponentContext().fetching;
		_this.state = _this.getStateFromProps(props, loading);
		return _this;
	}

	(0, _createClass3.default)(GeocoderField, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			var geometryUpdated = (0, _deepEqual2.default)(this.getGeometry(props), this.getGeometry(this.props)) ? false : undefined;
			this.setState(this.getStateFromProps(props, geometryUpdated));
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this2 = this;

			this.mounted = true;
			this.componentDidUpdate();
			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "locate", this.onLocate);
			this.getComponentContext().resetRemountedState = function (loading) {
				return _this2.setState(_this2.getStateFromProps(_this2.props, loading));
			};
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "locate", this.onLocate);
			delete this.getComponentContext().resetRemountedState;
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			var _this3 = this;

			var _getOptions = this.getOptions(this.props),
			    updateOnlyEmpty = _getOptions.updateOnlyEmpty,
			    button = _getOptions.button,
			    fields = _getOptions.fields;

			var hasData = fields.some(function (field) {
				return !(0, _utils.isEmptyString)(_this3.props.formData[field]);
			});
			var geometry = this.getGeometry(this.props);
			var geometriesEqual = prevProps && (0, _deepEqual2.default)(this.getGeometry(prevProps), geometry);
			var geometryEmpty = geometry && geometry.geometries && geometry.geometries.length === 0;
			if (updateOnlyEmpty && !geometryEmpty && hasData) {
				return;
			}
			if (!prevProps && hasData) {
				return;
			}
			if (geometryEmpty && prevProps && !geometriesEqual || // was emptied
			this.state.loading === undefined && !this.state && geometry || !geometriesEqual) {
				button ? this.onButtonClick()() : this.update(this.props);
			}
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props, loading) {
			var state = { loading: loading };

			var _getOptions2 = this.getOptions(props),
			    button = _getOptions2.button;

			var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			if (button) {
				state.uiSchema = (0, _extends3.default)({}, innerUiSchema, {
					"ui:options": (0, _extends3.default)({}, (0, _utils.getUiOptions)(innerUiSchema), {
						buttons: [].concat((0, _toConsumableArray3.default)((0, _utils.getUiOptions)(innerUiSchema).buttons || []), [this.getButton(props, loading)])
					})
				});
			} else {
				state.uiSchema = innerUiSchema;
			}

			return state;
		}
	}, {
		key: "getButton",
		value: function getButton(props, loading) {
			var _this4 = this;

			// Button is disabled when loading is false 
			// (it is false only after fetch and no formData updates, otherwise it will be true/undefined.

			var geometry = this.getGeometry(props);
			return {
				fn: this.onButtonClick,
				position: "top",
				key: loading,
				render: function render(onClick) {
					return _react2.default.createElement(
						_components.Button,
						{ key: "geolocate", onClick: onClick, disabled: loading || props.disabled || props.readonly || !_this4.state.timeout && (loading === false || !geometry || !geometry.geometries || geometry.geometries.length === 0), className: "geocoder-btn" },
						_react2.default.createElement(
							"strong",
							null,
							loading ? _react2.default.createElement(_reactSpinner2.default, null) : _react2.default.createElement("i", { className: "glyphicon glyphicon-globe" }),
							" ",
							props.formContext.translations.Geolocate
						)
					);
				}
			};
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;

			return _react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: this.state.uiSchema }));
		}
	}]);
	return GeocoderField;
}(_react.Component)) || _class;

GeocoderField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			updateOnlyEmpty: _propTypes2.default.bool,
			button: _propTypes2.default.bool,
			fields: _propTypes2.default.arrayOf(_propTypes2.default.oneOf(["country", "municipality", "biologicalProvince", "biogeographicalProvince", "administrativeProvince"])),
			geometryField: _propTypes2.default.string,
			"fieldOptions": _propTypes2.default.arrayOf(_propTypes2.default.shape({
				field: _propTypes2.default.string,
				enum: _propTypes2.default.string
			}))
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this5 = this;

	this.onLocate = function (geometry) {
		_this5.updateForGeometry(_this5.props, undefined, _this5.normalizeGeometry(geometry));
	};

	this.getOptions = function (props) {
		return (0, _extends3.default)({
			updateOnlyEmpty: false,
			button: false,
			fields: ["country", "municipality", "biologicalProvince", "biogeographicalProvince", "administrativeProvince"]
		}, (0, _utils.getUiOptions)((props || _this5.props).uiSchema));
	};

	this.onButtonClick = function () {
		return function () {
			_this5.mounted ? _this5.setState(_this5.getStateFromProps(_this5.props, true), function () {
				_this5.update(_this5.props, function () {
					var failed = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

					_this5.fetchedButton = _this5.fetchedButton ? _this5.fetchedButton + 1 : 1;
					_this5.mounted && _this5.setState((0, _extends3.default)({}, _this5.getStateFromProps(_this5.props, false), { timeout: failed }));
				});
			}) : _this5.update(_this5.props, function () {
				var failed = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

				_this5.mounted && _this5.setState((0, _extends3.default)({}, _this5.getStateFromProps(_this5.props, false), { timeout: failed }));
			});
		};
	};

	this.getGeometry = function (props) {
		var uiSchema = props.uiSchema,
		    formData = props.formData;

		var _getUiOptions = (0, _utils.getUiOptions)(uiSchema),
		    _getUiOptions$geometr = _getUiOptions.geometryField,
		    geometryField = _getUiOptions$geometr === undefined ? "geometry" : _getUiOptions$geometr;

		var geometry = _this5.normalizeGeometry(formData[geometryField]);

		// TODO misses geometry collections
		if (formData.units) formData.units.forEach(function (_ref) {
			var unitGathering = _ref.unitGathering;

			if (unitGathering && unitGathering.geometry && unitGathering.geometry.coordinates) {
				geometry = (0, _immutabilityHelper2.default)(geometry, { geometries: { $push: [unitGathering.geometry] } });
			}
		});
		return geometry;
	};

	this.normalizeGeometry = function (geometry) {
		if (!geometry || !geometry.type) {
			geometry = { type: "GeometryCollection", geometries: [] };
		} else if ("type" in geometry && geometry.type !== "GeometryCollection") {
			geometry = { type: "GeometryCollection", geometries: [geometry] };
		}
		return geometry;
	};

	this.fetch = function (url) {
		cache[url] = cache[url] || (0, _isomorphicFetch2.default)(url).then(function (response) {
			if (response.status >= 400) {
				throw new Error(_this5.props.formContext.translations.RequestFailed);
			}
			return response.json();
		}).catch(function () {
			delete cache[url];
			throw new Error(_this5.props.formContext.translations.RequestFailed);
		});
		return cache[url];
	};

	this.update = function (props, callback) {
		var geometry = _this5.getGeometry(props);
		_this5.updateForGeometry(props, callback, geometry);
	};

	this.getComponentContext = function () {
		return new _Context2.default(_this5.props.formContext.contextId + "_" + _this5.getUUID() + "_GEOCODERFIELD");
	};

	this.updateForGeometry = function (props, callback, geometry) {
		var mainContext = new _Context2.default(props.formContext.contextId);

		var _getOptions3 = _this5.getOptions(),
		    fields = _getOptions3.fields;

		var fieldByKeys = fields.reduce(function (_fields, option) {
			_fields[option] = true;
			return _fields;
		}, {});

		if (!geometry || !geometry.geometries || !geometry.geometries.length) {
			_this5.mounted && _this5.setState(_this5.getStateFromProps(props, false));
			return;
		}

		var bounds = L.geoJson({ // eslint-disable-line no-undef
			type: "FeatureCollection",
			features: geometry.geometries.map(function (geometry) {
				return { type: "Feature", properties: {}, geometry: geometry };
			})
		}).getBounds();
		var center = bounds.getCenter();
		var lat = center.lat,
		    lng = center.lng;


		var join = function join(oldValue, value) {
			return (0, _utils.isEmptyString)(oldValue) ? value : oldValue + ", " + value;
		};

		var lajiFormInstance = mainContext.formInstance;
		var timestamp = Date.now();
		_this5.promiseTimestamp = timestamp;
		var doAsync = function doAsync() {
			_this5.getComponentContext().hook = _this5.addSubmitHook(function () {
				return new _promise2.default(function (resolve, reject) {
					var afterFetch = function afterFetch(callback) {
						var timeout = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

						if (_this5.getComponentContext().fetching) {
							if (callback) callback(timeout);
						}
						_this5.getComponentContext().fetching = false;
						if (_this5.getComponentContext().resetRemountedState) _this5.getComponentContext().resetRemountedState(false);
					};
					var success = function success(callback, timeout) {
						afterFetch(callback, timeout);
						resolve();
					};
					var fail = function fail(e, callback, timeout) {
						afterFetch(callback, timeout);
						reject(e);
					};

					var handleResponse = function handleResponse(country) {
						for (var _len = arguments.length, fields = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
							fields[_key - 1] = arguments[_key];
						}

						return function (response) {
							fields = fields.reduce(function (_fields, field) {
								_fields[field] = true;
								return _fields;
							}, {});

							var changes = {};
							if (fieldByKeys.biologicalProvince) {
								changes.biologicalProvince = undefined;
							}
							if (fieldByKeys.biogeographicalProvince) {
								changes.biogeographicalProvince = undefined;
							}
							if (fieldByKeys.administrativeProvince) {
								changes.administrativeProvince = undefined;
							}

							var parsers = {
								country: {
									type: ["country"],
									responseField: "long_name"
								},
								administrativeProvince: {
									type: ["administrative_area_level_1"],
									responseField: "long_name"
								},
								municipality: {
									type: ["municipality", "administrative_area_level_3", "administrative_area_level_2"],
									responseField: "long_name"
								},
								biologicalProvince: {
									type: ["biogeographicalProvince"],
									responseField: "long_name"
								},
								biogeographicalProvince: {
									type: ["biogeographicalProvince"],
									responseField: "long_name"
								}
							};

							if (response.status === "OK") {
								var found = {};
								(0, _keys2.default)(parsers).forEach(function (field) {
									var parser = parsers[field];
									parser.type.some(function (type, typeIdx) {
										response.results.forEach(function (result) {
											return result.address_components.forEach(function (addressComponent) {
												if (addressComponent.types.indexOf(type) !== -1) {
													if (!found[field]) found[field] = {};
													if (!found[field][typeIdx]) found[field][typeIdx] = {};
													var responseField = addressComponent[parser.responseField] ? parser.responseField : "short_name";
													found[field][typeIdx][addressComponent[responseField]] = true;
												}
											});
										});
										return found[field] && found[field][typeIdx];
									});
								});
								(0, _keys2.default)(parsers).forEach(function (field) {
									if (!fieldByKeys[field] || !_this5.props.schema.properties[field]) {
										return;
									}
									if (found[field]) {
										var keys = (0, _keys2.default)(found[field]);
										var responseForField = found[field][keys[0]];
										(0, _keys2.default)(responseForField).forEach(function (value) {
											// If target field is array.
											if (_this5.props.schema.properties[field].type === "array") {
												var temp = (0, _from2.default)(_this5.props.formData[field] || []);

												// Find correct enum from fieldOptions.
												var fieldOptions = _this5.props.uiSchema["ui:options"].fieldOptions;
												var enumField = fieldOptions[fieldOptions.findIndex(function (element) {
													return element.field === field;
												})].enum;

												// Find enum value from key (eg. municipalityName --> municipalityId).
												var _enum = _this5.props.formContext.uiSchemaContext[enumField];
												var enumValue = _enum.enum[_enum.enumNames.indexOf(value)];

												// Push enum value to changes.
												if (enumValue !== undefined) {
													!(temp.indexOf(enumValue) !== -1) && temp.push(enumValue);
													changes[field] = temp;
												}
											} else {
												changes[field] = join(changes[field], value);
											}
										});
									} else {
										changes[field] = (0, _utils2.getDefaultFormState)(_this5.props.schema.properties[field], undefined, _this5.props.registry.definitions);
									}
								});
								if (country && _this5.props.schema.properties.country && fieldByKeys.country) changes.country = country;
								success(function () {
									if (timestamp !== _this5.promiseTimestamp) return;
									if (_this5.mounted) {
										_this5.props.onChange((0, _extends3.default)({}, _this5.props.formData, changes));
									} else {
										var pointer = (0, _utils.getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId)(lajiFormInstance.tmpIdTree, lajiFormInstance.state.formData, _this5.props.idSchema.$id, _this5.getUUID());
										var newFormData = (0, _extends3.default)({}, (0, _utils.parseJSONPointer)(lajiFormInstance.state.formData, pointer), changes);
										lajiFormInstance.onChange({ formData: (0, _utils.updateSafelyWithJSONPointer)(lajiFormInstance.state.formData, newFormData, pointer) });
									}
									if (callback) callback();
								});
							} else if (country) {
								fetchForeign();
							}
						};
					};

					var fetchForeign = function fetchForeign() {
						if (!props.formContext.googleApiKey) return fail("No Google API key", callback);

						_this5.fetch("https://maps.googleapis.com/maps/api/geocode/json\t\t\t\t\t?latlng=" + lat + "," + lng + "\t\t\t\t\t&key=" + props.formContext.googleApiKey + "\t\t\t\t\t&language=en\t\t\t\t\t&filter=country|administrative_area_level_1|administrative_area_level_2|administrative_area_level_3").then(handleResponse(undefined, "country", "municipality", "administrativeProvince")).catch(function (e) {
							fail(e.message, callback, !!"failed");
						});
					};

					_this5.getComponentContext().fetching = true;

					_this5.getContext().setTimeout(function () {
						if (timestamp !== _this5.promiseTimestamp) return;
						if (_this5.getComponentContext().fetching) {
							fail(_this5.props.formContext.translations.GeocodingTimeout);
							_this5.mounted && _this5.setState({ timeout: true }, function () {
								_this5.mounted && _this5.setState(_this5.getStateFromProps(_this5.props, false));
							});
						}
					}, 30 * 1000);

					!bounds.overlaps(_globals.FINLAND_BOUNDS) ? fetchForeign() : _this5.props.formContext.apiClient.fetchRaw("/coordinates/location", undefined, {
						method: "POST",
						headers: {
							"accept": "application/json",
							"content-type": "application/json"
						},
						body: (0, _stringify2.default)(geometry)
					}).then(function (response) {
						return response.json();
					}).then(handleResponse(props.formContext.translations.Finland, "municipality", "biologicalProvince", "biogeographicalProvince")).catch(function (e) {
						fail(e.message);
					});
				});
			});
		};

		if (_this5.getComponentContext().hook) {
			mainContext.removeSubmitHook(_this5.getUUID(), _this5.getComponentContext().hook).then(doAsync);
		} else {
			doAsync();
		}
	};
};

exports.default = GeocoderField;