"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

exports.MediaArrayField = MediaArrayField;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _DescriptionField = require("react-jsonschema-form/lib/components/fields/DescriptionField");

var _DescriptionField2 = _interopRequireDefault(_DescriptionField);

var _reactBootstrap = require("react-bootstrap");

var _reactDropzone = require("react-dropzone");

var _reactDropzone2 = _interopRequireDefault(_reactDropzone);

var _components = require("../components");

var _LajiForm = require("../LajiForm");

var _LajiForm2 = _interopRequireDefault(_LajiForm);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _exifJs = require("exif-js");

var _exifJs2 = _interopRequireDefault(_exifJs);

var _utils2 = require("laji-map/lib/utils");

var _moment = require("moment");

var _moment2 = _interopRequireDefault(_moment);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function toDecimal(number) {
	if (!number) return undefined;
	return number[0].numerator + number[1].numerator / (60 * number[1].denominator) + number[2].numerator / (3600 * number[2].denominator);
}

var mediaUuid = 0;

var ImageArrayField = MediaArrayField(_class = function (_Component) {
	(0, _inherits3.default)(ImageArrayField, _Component);

	function ImageArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, ImageArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = ImageArrayField.__proto__ || (0, _getPrototypeOf2.default)(ImageArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.ALLOWED_FILE_TYPES = ["image/jpeg", "image/png", "image/bmp", "image/tiff", "image/gif"], _this.ACCEPT_FILE_TYPES = ["image/*"], _this.MAX_FILE_SIZE = 20000000, _this.KEY = "IMAGE", _this.ENDPOINT = "images", _this.GLYPH = "camera", _this.TRANSLATION_TAKE_NEW = "TakeNewPhoto", _this.TRANSLATION_SELECT_FILE = "SelectPhoto", _this.TRANSLATION_NO_MEDIA = "NoPhoto", _this.CONTAINER_CLASS = "images-container", _this.METADATA_FORM_ID = "JX.111712", _this.renderMedia = function (id) {
			return _react2.default.createElement(Thumbnail, { id: id, apiClient: _this.props.formContext.apiClient });
		}, _this.renderLoadingMedia = function (id) {
			return _react2.default.createElement(Thumbnail, { dataURL: id, loading: true });
		}, _this.onMediaClick = function (i) {
			return _this.openModalFor(i);
		}, _this.renderModalMedia = function () {
			return _react2.default.createElement("img", { src: _this.state.modalMediaSrc });
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(ImageArrayField, [{
		key: "formatValue",
		value: function formatValue(value, options, props, parentProps) {
			var imgs = value && value.length ? value.map(function (id, idx) {
				return _react2.default.createElement(Thumbnail, { key: idx, id: id, apiClient: props.formContext.apiClient });
			}) : [];
			var parentFormData = (parentProps || {}).formData || {};
			var lajiFormId = (0, _utils.getUUID)(parentFormData || {});

			var _ref2 = new _Context2.default("IMAGE_ARRAY_FIELD"),
			    _ref2$tmpMedias = _ref2.tmpMedias,
			    tmpMedias = _ref2$tmpMedias === undefined ? {} : _ref2$tmpMedias;

			if (lajiFormId && tmpMedias[lajiFormId]) {
				return [].concat((0, _toConsumableArray3.default)(imgs), (0, _toConsumableArray3.default)((0, _keys2.default)(tmpMedias[lajiFormId]).map(function (id) {
					return _react2.default.createElement(Thumbnail, { key: id, dataURL: tmpMedias[lajiFormId][id] });
				})));
			}
			return imgs;
		}
	}]);
	return ImageArrayField;
}(_react.Component)) || _class;

exports.default = ImageArrayField;
function MediaArrayField(ComposedComponent) {
	var _class2, _temp2, _initialiseProps, _class3;

	return _temp2 = _class2 = (0, _BaseComponent2.default)(_class3 = function (_ComposedComponent) {
		(0, _inherits3.default)(MediaArrayField, _ComposedComponent);

		function MediaArrayField(props) {
			(0, _classCallCheck3.default)(this, MediaArrayField);

			var _this2 = (0, _possibleConstructorReturn3.default)(this, (MediaArrayField.__proto__ || (0, _getPrototypeOf2.default)(MediaArrayField)).call(this, props));

			_initialiseProps.call(_this2);

			["ALLOWED_FILE_TYPES", "MAX_FILE_SIZE", "KEY", "ENDPOINT", "GLYPH", "renderMedia", "renderLoadingMedia", "onMediaClick", "formatValue", "TRANSLATION_TAKE_NEW", "TRANSLATION_SELECT_FILE", "TRANSLATION_NO_MEDIA", "CONTAINER_CLASS"].forEach(function (prop) {
				if (_this2[prop] === undefined) {
					throw new Error((0, _utils.getReactComponentName)(ComposedComponent) + " doesn't implement MediaArrayField " + prop);
				}
			});
			var options = _this2.getOptions(props.uiSchema);
			(0, _keys2.default)(_this2.deprecatedOptions).forEach(function (deprecated) {
				if (options[deprecated] !== undefined) {
					console.warn("laji-form warning: {getReactComponentName(ComposedComponent)} ui:option '" + deprecated + "' is deprecated. Use '" + _this2.deprecatedOptions[deprecated] + "' instead!");
				}
			});
			_this2.apiClient = props.formContext.apiClient;
			_this2._context = new _Context2.default(_this2.KEY + "_ARRAY_FIELD");
			if (!_this2._context.metadatas) _this2._context.metadatas = {};
			if (!_this2._context.tmpMedias) _this2._context.tmpMedias = {};
			_this2.mainContext = _this2.getContext();
			_this2.state = { tmpMedias: (0, _keys2.default)(_this2._context.tmpMedias[_this2.getContainerId()] || {}) };
			var addModal = options.addModal,
			    autoOpenAddModal = options.autoOpenAddModal;

			if (addModal && autoOpenAddModal && (props.formData || []).length === 0 && !props.formContext.uiSchemaContext.isEdit) {
				_this2.state.addModal = addModal; // eslint-disable-line react/no-direct-mutation-state
			}
			return _this2;
		}

		(0, _createClass3.default)(MediaArrayField, [{
			key: "componentDidMount",
			value: function componentDidMount() {
				var _this3 = this;

				this.mounted = true;
				var settings = this.props.formContext.settings || {};
				if (settings && settings.defaultImageMetadata) {
					this._context.defaultMetadata = settings.defaultImageMetadata;
				}
				this.mainContext.addSettingSaver("defaultImageMetadata", function () {
					return _this3._context.defaultMetadata;
				}, !!"global");
			}
		}, {
			key: "componentWillUnmount",
			value: function componentWillUnmount() {
				this.mounted = false;
				this.mainContext.removeSettingSaver("defaultMetadata", !!"global");
			}
		}, {
			key: "componentDidUpdate",
			value: function componentDidUpdate(prevProps, prevState) {
				var getCount = function getCount(_props, _state) {
					return (_props.formData || []).length + (_state.tmpMedias || []).length;
				};

				if (getCount(prevProps, prevState) !== getCount(this.props, this.state)) {
					new _Context2.default(this.props.formContext.contextId).sendCustomEvent(this.props.idSchema.$id, "resize");
				}
			}
		}, {
			key: "render",
			value: function render() {
				var _this4 = this;

				var _props2 = this.props,
				    schema = _props2.schema,
				    uiSchema = _props2.uiSchema,
				    idSchema = _props2.idSchema,
				    name = _props2.name,
				    formContext = _props2.formContext,
				    readonly = _props2.readonly,
				    disabled = _props2.disabled;
				var translations = formContext.translations;

				var _getUiOptions = (0, _utils.getUiOptions)(uiSchema),
				    description = _getUiOptions.description,
				    titleClassName = _getUiOptions.titleClassName,
				    addModal = _getUiOptions.addModal;

				var title = schema.title === undefined ? name : schema.title;
				var TitleField = this.props.registry.fields.TitleField;


				var tooltip = _react2.default.createElement(
					_reactBootstrap.Tooltip,
					{ id: this.props.idSchema.$id + "-drop-zone-tooltip" },
					_react2.default.createElement(
						"span",
						null,
						translations.DropOrSelectFiles,
						". "
					),
					_react2.default.createElement(
						"span",
						null,
						translations.AllowedFileFormats,
						" ",
						this.getAllowedMediaFormatsAsString(),
						" ",
						translations.and,
						" ",
						translations.allowedFileSize,
						" ",
						this.getMaxFileSizeAsString(),
						"."
					)
				);

				var dragging = this.state.dragging;


				return _react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						_reactBootstrap.Col,
						{ xs: 12 },
						_react2.default.createElement(TitleField, { title: title, className: titleClassName, help: uiSchema["ui:help"], id: idSchema.$id }),
						description !== undefined ? _react2.default.createElement(_DescriptionField2.default, { description: description }) : null,
						_react2.default.createElement(
							"div",
							{ className: "laji-form-medias " + this.CONTAINER_CLASS },
							this.renderMedias(),
							this.renderLoadingMedias(),
							_react2.default.createElement(
								_reactBootstrap.OverlayTrigger,
								{ overlay: tooltip },
								_react2.default.createElement(
									_reactDropzone2.default,
									{ accept: this.ACCEPT_FILE_TYPES,
										onDragEnter: this.onDragEnter,
										onDragLeave: this.onDragLeave,
										onDrop: this.onDrop,
										disabled: readonly || disabled
									},
									function (_ref3) {
										var getRootProps = _ref3.getRootProps,
										    getInputProps = _ref3.getInputProps;

										var _getRootProps = getRootProps(),
										    _onClick = _getRootProps.onClick,
										    rootProps = (0, _objectWithoutProperties3.default)(_getRootProps, ["onClick"]);

										var onClick = addModal ? function () {
											_this4.setState({ addModal: addModal });
										} : _onClick;
										return _react2.default.createElement(
											"div",
											(0, _extends4.default)({ className: "laji-form-drop-zone" + (dragging ? " dragging" : "") + (readonly || disabled ? " disabled" : ""),
												onClick: onClick
											}, rootProps),
											_react2.default.createElement("input", getInputProps()),
											_react2.default.createElement(_reactBootstrap.Glyphicon, { glyph: _this4.GLYPH })
										);
									}
								)
							),
							this.renderMetadataModal(),
							this.renderMediaAddModal()
						)
					)
				);
			}
		}, {
			key: "saveMedias",
			value: function saveMedias(files) {
				var _this5 = this;

				var containerId = this.getContainerId();
				var tmpMedias = void 0;

				var fail = function fail(translationKey) {
					var additionalInfo = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "";

					var translation = (Array.isArray(translationKey) ? translationKey : [translationKey]).map(function (key) {
						return _this5.props.formContext.translations[key];
					}).join(". ");
					throw translation + " " + additionalInfo;
				};

				return this.processFiles(files).then(function (processedFiles) {
					var invalidFile = files.length <= 0;
					var fileTooLarge = false;
					var noValidData = true;

					if (!_this5._context.tmpMedias[containerId]) {
						_this5._context.tmpMedias[containerId] = {};
					}
					tmpMedias = processedFiles.map(function (f) {
						mediaUuid++;
						_this5._context.tmpMedias[containerId][mediaUuid] = f.dataURL;
						return mediaUuid;
					});
					_this5.mounted && _this5.setState({ tmpMedias: [].concat((0, _toConsumableArray3.default)(_this5.state.tmpMedias || []), (0, _toConsumableArray3.default)(tmpMedias)) });

					var formDataBody = files.reduce(function (body, file) {
						if (!(_this5.ALLOWED_FILE_TYPES.indexOf(file.type) !== -1)) {
							invalidFile = true;
						} else if (file.size > _this5.MAX_FILE_SIZE) {
							fileTooLarge = true;
						} else {
							body.append("data", file);
							noValidData = false;
						}
						return body;
					}, new FormData());

					if (noValidData && invalidFile) {
						fail("AllowedFileFormats", _this5.getAllowedMediaFormatsAsString() + ".");
					} else if (noValidData && fileTooLarge) {
						fail("AllowedFileSize", _this5.getMaxFileSizeAsString() + ".");
					} else {
						return _this5.apiClient.fetchRaw("/" + _this5.ENDPOINT, undefined, {
							method: "POST",
							body: formDataBody
						});
					}
				}).then(function (response) {
					if (!response) return;
					if (response.status < 400) {
						return response.json();
					} else if (response.status === 400) {
						fail("InvalidFile");
					} else if (response.status === 503) {
						fail("InsufficientSpace");
					} else {
						fail(["SomethingWentWrong", "TryAgainLater"]);
					}
				}).then(function (response) {
					if (!response) return;
					return _this5.getDefaultMetadataPromise().then(function (defaultMetadata) {
						return _promise2.default.all(response.map(function (item) {
							return _this5.apiClient.fetchRaw("/" + _this5.ENDPOINT + "/" + item.id, undefined, {
								method: "POST",
								headers: {
									"accept": "application/json",
									"content-type": "application/json"
								},
								body: (0, _stringify2.default)(defaultMetadata)
							}).then(function (response) {
								if (response.status < 400) {
									return response.json();
								}
							});
						}));
					});
				}).then(function (response) {
					if (!response) return;
					var ids = response.map(function (item) {
						return item ? item.id : undefined;
					}).filter(function (item) {
						return item !== undefined;
					});

					tmpMedias.forEach(function (id) {
						delete _this5._context.tmpMedias[containerId][id];
					});
					_this5.mounted && _this5.setState({ tmpMedias: _this5.state.tmpMedias.filter(function (id) {
							return !(tmpMedias.indexOf(id) !== -1);
						}) });
					return ids;
				}).catch(function (e) {
					if (tmpMedias) {
						tmpMedias.forEach(function (id) {
							delete _this5._context.tmpMedias[containerId][id];
						});
						_this5.mounted && _this5.setState({ tmpMedias: _this5.state.tmpMedias.filter(function (id) {
								return !(tmpMedias.indexOf(id) !== -1);
							}) });
					}
					throw e;
				});
			}
		}]);
		return MediaArrayField;
	}(ComposedComponent)) || _class3, _class2.propTypes = {
		uiSchema: _propTypes2.default.shape({
			"ui:options": _propTypes2.default.shape({
				titleClassName: _propTypes2.default.string,
				addModal: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.shape({
					labels: _propTypes2.default.shape({
						cancel: _propTypes2.default.string
					})
				})]),
				autoOpenAddModal: _propTypes2.default.bool,
				autoOpenMetadataModal: _propTypes2.default.bool,
				sideEffects: _propTypes2.default.object,
				exifParsers: _propTypes2.default.arrayOf(_propTypes2.default.object)
			})
		}),
		schema: _propTypes2.default.shape({
			type: _propTypes2.default.oneOf(["array"]),
			items: _propTypes2.default.shape({
				type: _propTypes2.default.oneOf(["string"]).isRequired
			}).isRequired
		}).isRequired,
		formData: _propTypes2.default.array
	}, _class2.displayName = (0, _utils.getReactComponentName)(ComposedComponent), _initialiseProps = function _initialiseProps() {
		var _this6 = this;

		this.deprecatedOptions = {
			imageAddModal: "addModal",
			autoOpenImageAddModal: "autoOpenAddModal"
		};

		this.getOptions = function (uiSchema) {
			var options = (0, _utils.getUiOptions)(uiSchema);
			(0, _keys2.default)(_this6.deprecatedOptions).forEach(function (deprecated) {
				if (options[deprecated] !== undefined) {
					options = (0, _extends4.default)({}, options, (0, _defineProperty3.default)({}, _this6.deprecatedOptions[deprecated], options[deprecated]));
				}
			});
			return options;
		};

		this.onSettingsChange = function (defaultMetadata) {
			if (!(0, _deepEqual2.default)(_this6._context.defaultMetadata, defaultMetadata)) {
				_this6._context.defaultMetadata = defaultMetadata;
				_this6.mainContext.onSettingsChange(!!"global");
			}
		};

		this.onDragEnter = function () {
			_this6.setState({ dragging: true });
		};

		this.onDragLeave = function () {
			_this6.setState({ dragging: false });
		};

		this.onDrop = function (files) {
			_this6.state.dragging && _this6.setState({ dragging: false });
			_this6.onFileFormChange(files);
		};

		this.renderMedias = function () {
			var _props3 = _this6.props,
			    disabled = _props3.disabled,
			    readonly = _props3.readonly;

			var _getUiOptions2 = (0, _utils.getUiOptions)(_this6.props.uiSchema),
			    _getUiOptions2$delete = _getUiOptions2.deleteConfirmPlacement,
			    deleteConfirmPlacement = _getUiOptions2$delete === undefined ? "top" : _getUiOptions2$delete;

			return (_this6.props.formData || []).map(function (item, i) {
				return _react2.default.createElement(
					"div",
					{ key: i, className: "media-container" },
					_react2.default.createElement(
						"a",
						{ onClick: _this6.onMediaClick(i) },
						_this6.renderMedia(item, i)
					),
					_react2.default.createElement(
						_components.DeleteButton,
						{ corner: true,
							confirm: true,
							confirmPlacement: deleteConfirmPlacement,
							translations: _this6.props.formContext.translations,
							onClick: _this6.onMediaRmClick(i),
							disabled: disabled || readonly,
							id: _this6.props.idSchema.$id + "_" + i
						},
						"\u2716"
					)
				);
			});
		};

		this.renderLoadingMedias = function () {
			var containerId = _this6.getContainerId();
			return (_this6.state.tmpMedias || []).map(function (item, i) {
				var medias = _this6._context.tmpMedias[containerId];
				if (!medias || !medias[item]) return null;
				return _react2.default.createElement(
					"div",
					{ key: i, className: "media-container" },
					_react2.default.createElement(
						"a",
						null,
						_this6.renderLoadingMedia(medias[item])
					)
				);
			});
		};

		this.openModalFor = function (i) {
			return function () {
				var item = _this6.props.formData[i];
				_this6.setState({ metadataModalOpen: i });
				_this6.fetching = item;
				_this6.apiClient.fetch("/" + _this6.ENDPOINT + "/" + item).then(function (response) {
					if (response.id !== _this6.fetching) return;
					_this6._context.metadatas[item] = response;
					_this6.setState({ modalIdx: i, modalMediaSrc: response.fullURL, modalMetadata: _this6._context.metadatas[item] });
				});
			};
		};

		this.onMediaRmClick = function (i) {
			return function () {
				var id = _this6.props.formData[i];
				_this6.props.onChange((0, _immutabilityHelper2.default)(_this6.props.formData, { $splice: [[i, 1]] }));
				_this6.apiClient.fetch("/" + _this6.ENDPOINT + "/" + id, undefined, {
					method: "DELETE",
					failSilently: true
				});
			};
		};

		this.hideMetadataModal = function () {
			return _this6.setState({ metadataModalOpen: false, metadataSaveSuccess: undefined });
		};

		this.onMetadataFormChange = function (formData) {
			return _this6.setState({ modalMetadata: formData });
		};

		this.renderMetadataModal = function () {
			var _state2 = _this6.state,
			    metadataModalOpen = _state2.metadataModalOpen,
			    modalIdx = _state2.modalIdx,
			    modalMetadata = _state2.modalMetadata,
			    metadataSaveSuccess = _state2.metadataSaveSuccess;
			var _props$registry$formC = _this6.props.registry.formContext,
			    lang = _props$registry$formC.lang,
			    translations = _props$registry$formC.translations;


			var metadataForm = _this6.state.metadataForm || {};

			if (typeof metadataModalOpen === "number" && !_this6.state.metadataForm) {
				_this6.apiClient.fetchCached("/forms/" + _this6.METADATA_FORM_ID, { lang: lang, format: "schema" }).then(function (metadataForm) {
					if (_this6.mounted) {
						_this6.setState({ metadataForm: metadataForm });
					}
				});
			}

			var _props$formContext$tr = _this6.props.formContext.translations,
			    Previous = _props$formContext$tr.Previous,
			    Next = _props$formContext$tr.Next;


			var isOpen = modalIdx === metadataModalOpen && modalMetadata && metadataForm.schema;

			var uiSchema = isOpen ? (0, _extends4.default)({}, metadataForm.uiSchema, {
				"ui:shortcuts": (0, _extends4.default)({}, metadataForm.uiSchema["ui:shorcuts"] || {}, _this6.mainContext.shortcuts || {}),
				"ui:disabled": _this6.props.disabled,
				"ui:readonly": _this6.props.readonly
			}) : undefined;

			var _getUiOptions3 = (0, _utils.getUiOptions)(_this6.props.uiSchema),
			    _getUiOptions3$metada = _getUiOptions3.metadataModal,
			    metadataModal = _getUiOptions3$metada === undefined ? true : _getUiOptions3$metada;

			return typeof metadataModalOpen === "number" ? _react2.default.createElement(
				_reactBootstrap.Modal,
				{ dialogClassName: "laji-form media-modal", show: true,
					onHide: _this6.hideMetadataModal },
				_react2.default.createElement(
					_reactBootstrap.Modal.Header,
					{ closeButton: true },
					_react2.default.createElement("br", null),
					_react2.default.createElement(
						_reactBootstrap.Pager,
						null,
						_react2.default.createElement(
							_reactBootstrap.Pager.Item,
							{ previous: true, onClick: _this6.openModalFor(metadataModalOpen - 1), disabled: metadataModalOpen <= 0 },
							"\u2190 ",
							Previous
						),
						_react2.default.createElement(
							_reactBootstrap.Pager.Item,
							{ next: true, onClick: _this6.openModalFor(metadataModalOpen + 1), disabled: metadataModalOpen >= _this6.props.formData.length - 1 },
							Next,
							" \u2192"
						)
					)
				),
				_react2.default.createElement(
					_reactBootstrap.Modal.Body,
					null,
					_react2.default.createElement(
						"div",
						{ className: "laji-form" + (metadataModal ? " media-modal-content" : "") },
						isOpen ? _react2.default.createElement(
							_react2.default.Fragment,
							null,
							_this6.renderModalMedia(modalIdx),
							metadataModal && _react2.default.createElement(
								_LajiForm2.default,
								(0, _extends4.default)({}, metadataForm, {
									uiSchema: uiSchema,
									formData: modalMetadata,
									onChange: _this6.onMetadataFormChange,
									onSubmit: _this6.onMediaMetadataUpdate,
									submitText: translations.Save,
									lang: lang,
									apiClient: _this6.props.formContext.apiClient.apiClient,
									uiSchemaContext: _this6.props.formContext.uiSchemaContext,
									showShortcutButton: false }),
								metadataSaveSuccess !== undefined ? _react2.default.createElement(
									_reactBootstrap.Alert,
									{ bsStyle: metadataSaveSuccess ? "success" : "danger" },
									translations[metadataSaveSuccess ? "SaveSuccess" : "SaveFail"]
								) : null
							)
						) : _react2.default.createElement(_reactSpinner2.default, null)
					)
				)
			) : null;
		};

		this.onHideMediaAddModal = function () {
			return _this6.setState({ addModal: undefined }, function () {
				_this6.parseExif([]);
			});
		};

		this.renderMediaAddModal = function () {
			var _props4 = _this6.props,
			    disabled = _props4.disabled,
			    readonly = _props4.readonly;
			var addModal = _this6.state.addModal;

			var _ref4 = (0, _utils.isObject)(addModal) ? addModal : {},
			    _ref4$labels = _ref4.labels;

			_ref4$labels = _ref4$labels === undefined ? {} : _ref4$labels;
			var cancel = _ref4$labels.cancel;
			var translations = _this6.props.formContext.translations;


			if (!addModal) return null;

			return _react2.default.createElement(
				_reactBootstrap.Modal,
				{ dialogClassName: "laji-form media-add-modal", show: true, onHide: _this6.onHideMediaAddModal },
				_react2.default.createElement(_reactBootstrap.Modal.Header, { closeButton: true }),
				_react2.default.createElement(
					_reactBootstrap.Modal.Body,
					null,
					[["environment", _this6.TRANSLATION_TAKE_NEW], [undefined, _this6.TRANSLATION_SELECT_FILE]].map(function (_ref5) {
						var _ref6 = (0, _slicedToArray3.default)(_ref5, 2),
						    captureMethod = _ref6[0],
						    label = _ref6[1];

						return _react2.default.createElement(
							_reactDropzone2.default,
							{ key: captureMethod || "",
								accept: _this6.ACCEPT_FILE_TYPES,
								onDrop: _this6.onDrop,
								disabled: readonly || disabled
							},
							function (_ref7) {
								var getRootProps = _ref7.getRootProps,
								    getInputProps = _ref7.getInputProps;

								return _react2.default.createElement(
									"div",
									(0, _extends4.default)({ className: "btn-block" }, getRootProps()),
									_react2.default.createElement("input", (0, _extends4.default)({}, getInputProps(), { capture: captureMethod })),
									_react2.default.createElement(
										_components.Button,
										{ block: true, disabled: readonly || disabled },
										translations[label]
									)
								);
							}
						);
					}),
					_react2.default.createElement(
						_components.Button,
						{ className: "cancel", block: true, onClick: _this6.onHideMediaAddModal },
						cancel || translations[_this6.TRANSLATION_NO_MEDIA]
					)
				)
			);
		};

		this.onAlertOk = function () {
			_this6.setState({ alert: false, alertMsg: undefined });
		};

		this.parseExif = function (files) {
			var _getUiOptions4 = (0, _utils.getUiOptions)(_this6.props.uiSchema),
			    _getUiOptions4$exifPa = _getUiOptions4.exifParsers,
			    exifParsers = _getUiOptions4$exifPa === undefined ? [] : _getUiOptions4$exifPa;

			if (!exifParsers) return;

			var found = exifParsers.reduce(function (found, _ref8) {
				var parse = _ref8.parse;

				found[parse] = false;
				return found;
			}, {});
			return files.reduce(function (promise, file) {
				if ((0, _keys2.default)(found).every(function (k) {
					return found[k];
				})) {
					return promise;
				}
				return promise.then(function (found) {
					return new _promise2.default(function (resolve) {
						_exifJs2.default.getData(file, function () {
							var _this7 = this;

							if (found.hasOwnProperty("geometry")) try {
								var coordinates = ["GPSLongitude", "GPSLatitude"].map(function (tag) {
									return toDecimal(_exifJs2.default.getTag(_this7, tag));
								});
								var rawDatum = _exifJs2.default.getTag(this, "GPSMapDatum");
								var datum = typeof rawDatum === "string" ? rawDatum.trim().toUpperCase() : undefined;
								if ((!datum || datum === "WGS-84" || datum === "WGS84") && (0, _utils2.validateLatLng)(coordinates, _utils2.wgs84Validator)) {
									found.geometry = {
										type: "Point",
										coordinates: coordinates
									};
								}
							} catch (e) {
								console.info("Reading GPS from EXIF failed", e);
							}

							var readDateFromFile = function readDateFromFile() {
								if (file.lastModified) {
									var momentDate = (0, _moment2.default)(file.lastModified);
									if (momentDate.isValid()) {
										var date = momentDate.format("YYYY-MM-DDTHH:mm");
										if (date) {
											found.date = date;
										}
									}
								}
							};

							if (found.hasOwnProperty("date")) {
								try {
									var rawDate = _exifJs2.default.getTag(this, "DateTimeOriginal");
									var momentDate = (0, _moment2.default)(rawDate, "YYYY:MM:DD HH:mm:ss");
									if (momentDate.isValid()) {
										found.date = momentDate.format("YYYY-MM-DDTHH:mm");
									} else {
										readDateFromFile();
									}
								} catch (e) {
									console.info("Reading date from EXIF failed, trying to read from file", e);
									readDateFromFile();
								}
							} else {
								readDateFromFile();
							}
							resolve(found);
						});
					});
				});
			}, _promise2.default.resolve(found)).then(function (found) {
				var _props5 = _this6.props,
				    registry = _props5.registry,
				    contextId = _props5.formContext.contextId;

				var lajiFormInstance = new _Context2.default(_this6.props.formContext.contextId).formInstance;
				var schema = lajiFormInstance.props.schema;
				var formData = lajiFormInstance.state.formData;

				exifParsers.filter(function (f) {
					return f.type === "event" || found[f.parse];
				}).forEach(function (_ref9) {
					var field = _ref9.field,
					    parse = _ref9.parse,
					    type = _ref9.type,
					    eventName = _ref9.eventName;

					if (type === "mutate") {
						formData = (0, _utils.updateFormDataWithJSONPointer)({ formData: formData, schema: schema, registry: registry }, found[parse], field);
					}
					if (type === "event") {
						new _Context2.default(contextId).sendCustomEvent("root_" + (0, _utils.JSONPointerToId)(field), eventName, found[parse], undefined, { bubble: false });
					}
				});
				return formData;
			});
		};

		this.sideEffects = function (formData) {
			var lajiFormInstance = new _Context2.default(_this6.props.formContext.contextId).formInstance;
			var lajiFormFormData = lajiFormInstance.state.formData;
			var schema = lajiFormInstance.props.schema;

			var _getUiOptions5 = (0, _utils.getUiOptions)(_this6.props.uiSchema),
			    sideEffects = _getUiOptions5.sideEffects;

			if (sideEffects) {
				var thisPath = (0, _utils.idSchemaIdToJSONPointer)(_this6.props.idSchema.$id);
				var containerPath = thisPath.replace(/^(\/.*)\/.*$/, "$1");
				var parseRelativePaths = function parseRelativePaths(path, containerPath) {
					while ((path.match(/\/\.\./g) || []).length > 1) {
						containerPath = containerPath.replace(/^(\/.*)\/.*$/, "$1");
						path = path.replace(/^(.*)\/\.\.(.*)/, "$1$2");
					}
					return path.replace(/^(.*)\/\.\.(.*)/, "$1" + containerPath + "$2");
				};
				formData = (0, _keys2.default)(sideEffects).reduce(function (formData, field) {
					return (0, _utils.updateFormDataWithJSONPointer)({ schema: schema, registry: _this6.props.registry, formData: formData }, sideEffects[field], parseRelativePaths(field, containerPath));
				}, formData);
			}
			if (formData !== lajiFormFormData) {
				lajiFormInstance.onChange({ formData: formData });
			}
		};

		this.onFileFormChange = function (files) {
			if (_this6.state.addModal) {
				_this6.setState({ addModal: undefined });
			}

			_this6.parseExif(files).then(_this6.sideEffects);

			var id = _this6.getContainerId();

			var lajiFormInstance = new _Context2.default(_this6.props.formContext.contextId).formInstance;
			var saveAndOnChange = function saveAndOnChange() {
				return _this6.saveMedias(files).then(function (mediaIds) {
					if (!lajiFormInstance.mounted) {
						return;
					}

					var pointer = (0, _utils.getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId)(lajiFormInstance.tmpIdTree, lajiFormInstance.state.formData, _this6.props.idSchema.$id, id);
					var newFormData = [].concat((0, _toConsumableArray3.default)(_this6.mounted ? _this6.props.formData || [] : (0, _utils.parseJSONPointer)(lajiFormInstance.state.formData, pointer) || []), (0, _toConsumableArray3.default)(mediaIds));

					if (!lajiFormInstance.mounted) return;

					if (_this6.mounted || id === "root") {
						_this6.props.onChange(newFormData);
						// Settimeout because the resource is undefined 404 if fetched right away.
						setTimeout(function () {
							if (!_this6.mounted) return;

							var _getUiOptions6 = (0, _utils.getUiOptions)(_this6.props.uiSchema),
							    _getUiOptions6$autoOp = _getUiOptions6.autoOpenMetadataModal,
							    autoOpenMetadataModal = _getUiOptions6$autoOp === undefined ? false : _getUiOptions6$autoOp;

							var shouldOpenMetadataModal = autoOpenMetadataModal;
							if (shouldOpenMetadataModal) {
								_this6.openModalFor(newFormData.length - mediaIds.length)();
							}
						}, 0);
						return;
					}

					pointer = (0, _utils.getJSONPointerFromLajiFormIdAndFormDataAndIdSchemaId)(lajiFormInstance.tmpIdTree, lajiFormInstance.state.formData, _this6.props.idSchema.$id, id);
					lajiFormInstance.onChange({ formData: (0, _utils.updateSafelyWithJSONPointer)(lajiFormInstance.state.formData, newFormData, pointer) });
				});
			};

			_this6.addSubmitHook(saveAndOnChange);
		};

		this.getContainerId = function () {
			var _props$formContext$_p = _this6.props.formContext._parentLajiFormId,
			    _parentLajiFormId = _props$formContext$_p === undefined ? "root" : _props$formContext$_p;

			return _parentLajiFormId;
		};

		this.addNameToDataURL = function (dataURL, name) {
			return dataURL.replace(";base64", ";name=" + name + ";base64");
		};

		this.processFiles = function (files) {
			return _promise2.default.all([].map.call(files, _this6.processFile));
		};

		this.processFile = function (file) {
			var name = file.name,
			    size = file.size,
			    type = file.type;

			return new _promise2.default(function (resolve) {
				var reader = new window.FileReader();
				reader.onload = function (event) {
					resolve({
						dataURL: _this6.addNameToDataURL(event.target.result, name),
						name: name,
						size: size,
						type: type
					});
				};
				reader.readAsDataURL(file);
			});
		};

		this.onMediaMetadataUpdate = function (_ref10) {
			var formData = _ref10.formData;

			_this6.mainContext.pushBlockingLoader();
			_this6.apiClient.fetch("/" + _this6.ENDPOINT + "/" + formData.id, undefined, {
				method: "PUT",
				headers: {
					"accept": "application/json",
					"content-type": "application/json"
				},
				body: (0, _stringify2.default)(formData)
			}).then(function () {
				_this6.mainContext.popBlockingLoader();
				var notify = function notify() {
					return _this6.props.formContext.notifier.success(_this6.props.formContext.translations.SaveSuccess);
				};
				if (_this6.mounted) {
					_this6.setState({ metadataModalOpen: false }, notify);
				} else {
					notify();
				}
				_this6.onSettingsChange({
					intellectualRights: formData.intellectualRights,
					capturerVerbatim: formData.capturerVerbatim,
					intellectualOwner: formData.intellectualOwner
				});
			}).catch(function () {
				_this6.mainContext.popBlockingLoader();
				_this6.mounted && _this6.setState({ metadataSaveSuccess: false });
			});
		};

		this.getDefaultMetadataPromise = function () {
			var defaultMetadata = _this6._context.defaultMetadata || { intellectualRights: "MZ.intellectualRightsCC-BY-SA-4.0" };
			var MACode = _this6.props.formContext.uiSchemaContext.creator;

			return !defaultMetadata.capturerVerbatim && MACode !== undefined ? _this6.apiClient.fetchCached("/person/by-id/" + MACode).then(function (_ref11) {
				var fullName = _ref11.fullName;

				var name = fullName || MACode;
				defaultMetadata = (0, _extends4.default)({}, defaultMetadata, {
					capturerVerbatim: Array.isArray(name) ? name : [name],
					intellectualOwner: name
				});
				_this6.onSettingsChange(defaultMetadata);
				return defaultMetadata;
			}).catch(function () {
				return new _promise2.default(function (resolve) {
					_this6.onSettingsChange(defaultMetadata);
					resolve(defaultMetadata);
				});
			}) : new _promise2.default(function (resolve) {
				_this6.onSettingsChange(defaultMetadata);
				resolve(defaultMetadata);
			});
		};

		this.getMaxFileSizeAsString = function () {
			var maxSize = _this6.MAX_FILE_SIZE.toString().substring(0, _this6.MAX_FILE_SIZE.toString().length - 6);
			return maxSize + " " + ("" + _this6.props.formContext.translations.Mb);
		};

		this.getAllowedMediaFormatsAsString = function () {
			var formats = "";

			for (var i = 0; i < _this6.ALLOWED_FILE_TYPES.length; i++) {
				formats += _this6.ALLOWED_FILE_TYPES[i].split("/")[1];
				if (i < _this6.ALLOWED_FILE_TYPES.length - 2) {
					formats += ", ";
				} else if (i === _this6.ALLOWED_FILE_TYPES.length - 2) {
					formats += " " + _this6.props.formContext.translations.and + " ";
				}
			}

			return formats;
		};
	}, _temp2;
}

var Thumbnail = function (_PureComponent) {
	(0, _inherits3.default)(Thumbnail, _PureComponent);

	function Thumbnail(props) {
		(0, _classCallCheck3.default)(this, Thumbnail);

		var _this8 = (0, _possibleConstructorReturn3.default)(this, (Thumbnail.__proto__ || (0, _getPrototypeOf2.default)(Thumbnail)).call(this, props));

		_this8.updateURL = function (_ref12) {
			var id = _ref12.id,
			    apiClient = _ref12.apiClient;

			if (!id) return;
			apiClient.fetchCached("/images/" + id, undefined, { failSilently: true }).then(function (response) {
				if (!_this8.mounted) return;
				_this8.setState({ url: response.squareThumbnailURL });
			});
		};

		_this8.state = {};
		_this8.updateURL(props);
		return _this8;
	}

	(0, _createClass3.default)(Thumbnail, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.updateURL(props);
		}
	}, {
		key: "render",
		value: function render() {
			var url = this.state.url || this.props.dataURL;
			var img = url ? _react2.default.createElement("img", { src: url }) : null;
			return !url || this.props.loading ? _react2.default.createElement(
				"div",
				{ className: "media-loading" },
				img,
				_react2.default.createElement(_reactSpinner2.default, null)
			) : img;
		}
	}]);
	return Thumbnail;
}(_react.PureComponent);