"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Injects given fields value as default value to target field.
 * uiSchema = { "ui:options": {
 *  "injections": [
 *    {
 *      "fields": [field1, field2...], (fields to inject from source field)
 *      "target": fieldName (target field where default value is injected)
 *      "source": fieldName (source field where default value is injected from. Must be object field)
 *    }
 *    ...
 *  ]
 * }}
 */
var InjectDefaultValueField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(InjectDefaultValueField, _Component);

	function InjectDefaultValueField() {
		(0, _classCallCheck3.default)(this, InjectDefaultValueField);
		return (0, _possibleConstructorReturn3.default)(this, (InjectDefaultValueField.__proto__ || (0, _getPrototypeOf2.default)(InjectDefaultValueField)).apply(this, arguments));
	}

	(0, _createClass3.default)(InjectDefaultValueField, [{
		key: "onChange",
		value: function onChange(formData) {
			var _this2 = this;

			var schema = this.props.schema;

			var options = this.getUiOptions();
			var fields = options.fields,
			    target = options.target;


			var source = options.source ? formData[options.source] : formData;
			fields.forEach(function (field) {
				if (schema.properties[target].type === "array") {
					if (formData && formData[target]) formData[target].forEach(function (item, i) {
						if (item[field] === _this2.props.formData[options.source][field]) {
							formData = (0, _immutabilityHelper2.default)(formData, (0, _defineProperty3.default)({}, target, { $splice: [[i, 1, (0, _immutabilityHelper2.default)(item, { $merge: (0, _defineProperty3.default)({}, field, source[field]) })]] }));
						}
					});
				}
			});

			this.props.onChange(formData);
		}
	}], [{
		key: "getName",
		value: function getName() {
			return "InjectDefaultValueField";
		}
	}]);
	return InjectDefaultValueField;
}(_react.Component)) || _class;

InjectDefaultValueField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			fields: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
			target: _propTypes2.default.string.isRequired,
			source: _propTypes2.default.string.isRequired
		}).isRequired
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object", "array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]).isRequired
};
exports.default = InjectDefaultValueField;