"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _components = require("../components");

var _reactBootstrap = require("react-bootstrap");

var _PanelBody = require("react-bootstrap/lib/PanelBody");

var _PanelBody2 = _interopRequireDefault(_PanelBody);

var _LajiForm = require("../LajiForm");

var _LajiForm2 = _interopRequireDefault(_LajiForm);

var _MapField = require("./MapField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LocalityField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(LocalityField, _Component);

	function LocalityField(props) {
		(0, _classCallCheck3.default)(this, LocalityField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (LocalityField.__proto__ || (0, _getPrototypeOf2.default)(LocalityField)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = {};
		return _this;
	}

	(0, _createClass3.default)(LocalityField, [{
		key: "render",
		value: function render() {
			var _this2 = this;

			var _getUiOptions = (0, _utils.getUiOptions)(this.props.uiSchema),
			    _radius = _getUiOptions.radius,
			    geometry = _getUiOptions.geometry;

			var fields = (0, _keys2.default)(this.props.schema.properties);
			var values = fields.filter(function (s) {
				return !(0, _utils.isEmptyString)(_this2.props.formData[s]);
			}).map(function (f) {
				return _this2.props.formData[f];
			});
			var radius = typeof _radius === "number" ? _radius : geometry ? (0, _MapField.getCenterAndRadiusFromGeometry)(geometry).radius : undefined;
			if (typeof radius === "number") {
				values.push("(" + this.props.formContext.translations.accuracy + ": " + parseInt(radius) + "m)");
			}
			return _react2.default.createElement(
				_reactBootstrap.Row,
				null,
				_react2.default.createElement(
					_reactBootstrap.Col,
					{ xs: 12 },
					_react2.default.createElement(
						_reactBootstrap.Panel,
						{ className: (0, _utils.getUiOptions)(this.props.uiSchema).panelClassName },
						_react2.default.createElement(
							_PanelBody2.default,
							null,
							values.map(function (v, i) {
								return _react2.default.createElement(
									"span",
									{ key: i },
									v,
									i < values.length - 1 ? ", " : ""
								);
							}),
							_react2.default.createElement(_components.GlyphButton, { onClick: this.showEditor, glyph: "pencil", bsStyle: "default", className: "pull-right" })
						)
					)
				),
				this.state.modal && this.renderModal()
			);
		}
	}]);
	return LocalityField;
}(_react.Component)) || _class;

LocalityField.propTypes = {
	uiSchema: _propTypes2.default.object,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this3 = this;

	this.showEditor = function () {
		_this3.setState({ modal: true });
	};

	this.hideEditor = function () {
		_this3.setState({ modal: false });
	};

	this.setFormRef = function (elem) {
		_this3.lajiForm = elem;
	};

	this.renderModal = function () {
		var _props = _this3.props,
		    onChange = _props.onChange,
		    props = (0, _objectWithoutProperties3.default)(_props, ["onChange"]); // eslint-disable-line no-unused-vars

		return _react2.default.createElement(
			_reactBootstrap.Modal,
			{ dialogClassName: "laji-form image-modal", show: true, onHide: _this3.hideEditor },
			_react2.default.createElement(_reactBootstrap.Modal.Header, { closeButton: true }),
			_react2.default.createElement(
				_reactBootstrap.Modal.Body,
				null,
				_react2.default.createElement(_LajiForm2.default, (0, _extends3.default)({
					ref: _this3.setFormRef
				}, props, {
					uiSchema: (0, _utils.getInnerUiSchema)(_this3.props.uiSchema),
					onSubmit: _this3.onSubmit,
					lang: _this3.props.formContext.lang,
					showShortcutButton: false,
					renderSubmit: false,
					validators: {},
					warnings: {},
					apiClient: _this3.props.formContext.apiClient.apiClient,
					uiSchemaContext: _this3.props.formContext.uiSchemaContext
				})),
				_react2.default.createElement(
					_components.Button,
					{ block: true, onClick: _this3.onSubmitClick },
					"OK"
				),
				_react2.default.createElement(
					_components.Button,
					{ block: true, onClick: _this3.hideEditor },
					_this3.props.formContext.translations.Cancel
				)
			)
		);
	};

	this.onSubmitClick = function (e) {
		_this3.lajiForm._onDefaultSubmit(e);
	};

	this.onSubmit = function (_ref) {
		var formData = _ref.formData;

		_this3.props.onChange(formData);
		_this3.hideEditor();
	};
};

exports.default = LocalityField;