"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toArray2 = require("babel-runtime/helpers/toArray");

var _toArray3 = _interopRequireDefault(_toArray2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends3 = require("babel-runtime/helpers/extends");

var _extends4 = _interopRequireDefault(_extends3);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _utils = require("../../utils");

var _MapArrayField = require("./MapArrayField");

var _utils2 = require("react-jsonschema-form/lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LocationChooserField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(LocationChooserField, _Component);

	function LocationChooserField() {
		(0, _classCallCheck3.default)(this, LocationChooserField);
		return (0, _possibleConstructorReturn3.default)(this, (LocationChooserField.__proto__ || (0, _getPrototypeOf2.default)(LocationChooserField)).apply(this, arguments));
	}

	(0, _createClass3.default)(LocationChooserField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var uiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);

			uiSchema = (0, _extends4.default)({}, uiSchema, {
				"ui:buttons": [].concat((0, _toConsumableArray3.default)(uiSchema["ui:buttons"] || []), [_react2.default.createElement(LocationButton, { key: "$" + this.props.idSchema.$id + "-location", that: this })])
			});

			return { uiSchema: uiSchema };
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;
			return _react2.default.createElement(SchemaField, (0, _extends4.default)({}, this.props, this.state));
		}
	}]);
	return LocationChooserField;
}(_react.Component)) || _class;

LocationChooserField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			uiSchema: _propTypes2.default.object,
			taxonField: _propTypes2.default.string,
			geometryField: _propTypes2.default.string,
			strategy: _propTypes2.default.string,
			mapDrawOptions: _propTypes2.default.shape({
				marker: _propTypes2.default.bool,
				polyline: _propTypes2.default.bool,
				rectangle: _propTypes2.default.bool,
				polygon: _propTypes2.default.bool,
				circle: _propTypes2.default.bool
			})
		})
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = LocationChooserField;

var LocationButton = function (_Component2) {
	(0, _inherits3.default)(LocationButton, _Component2);

	function LocationButton(props) {
		(0, _classCallCheck3.default)(this, LocationButton);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (LocationButton.__proto__ || (0, _getPrototypeOf2.default)(LocationButton)).call(this, props));

		_this2.getIdx = function () {
			var that = _this2.props.that;
			var $id = that.props.idSchema.$id;

			var splitted = $id.split("_");
			return parseInt(splitted[splitted.length - 1]);
		};

		_this2.getGeometryField = function () {
			var that = _this2.props.that;

			var _getUiOptions = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions$geometr = _getUiOptions.geometryField,
			    geometryField = _getUiOptions$geometr === undefined ? "geometry" : _getUiOptions$geometr;

			return geometryField;
		};

		_this2.hasCoordinates = function () {
			return (0, _MapArrayField.parseGeometries)(_this2.getGeometry()).length;
		};

		_this2.getGeometry = function () {
			var geometryField = _this2.getGeometryField();
			return (0, _utils.parseJSONPointer)(_this2.props.that.props.formData, geometryField);
		};

		_this2.onMouseEnter = function () {
			var that = _this2.props.that;

			var idx = _this2.getIdx();
			_this2._hovered = true;
			if (typeof idx === "number") {
				new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "startHighlight", { id: (0, _utils.getUUID)(that.props.formData), idx: idx });
			}
		};

		_this2.onMouseLeave = function () {
			var that = _this2.props.that;

			var idx = _this2.getIdx();
			_this2._hovered = false;
			if (typeof idx === "number") {
				new _Context2.default(that.props.formContext.contextId).sendCustomEvent(that.props.idSchema.$id, "endHighlight", { id: (0, _utils.getUUID)(that.props.formData), idx: idx });
			}
		};

		_this2.getUnitDrawFeatureStyle = function () {
			return { color: "#55AEFA" };
		};

		_this2.getDataFeatureStyle = function () {
			return { color: "#aaaaaa", opacity: 0.7 };
		};

		_this2.getData = function () {
			var that = _this2.props.that;

			var _getUiOptions2 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions2$strate = _getUiOptions2.strategy,
			    strategy = _getUiOptions2$strate === undefined ? "unit" : _getUiOptions2$strate;

			switch (strategy) {
				case "unit":
					return _this2.getUnitData();
				case "lolifeUnit":
				case "lolife":
					return _this2.getLolifeData();
			}
		};

		_this2.getUnitData = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;

			var emptyFeatureCollection = { featureCollection: { type: "FeatureCollection", features: [] } };

			var gatheringData = map ? map.getDraw() : emptyFeatureCollection;

			var _ref = map ? map.data.filter(function (i) {
				return i;
			}) || [emptyFeatureCollection] : [emptyFeatureCollection],
			    _ref2 = (0, _toArray3.default)(_ref),
			    unitGeometriesData = _ref2[0],
			    unitGeometryCollectionsData = _ref2.slice(1);

			var idx = _this2.getIdx();

			var geometry = _this2.getGeometry();
			var draw = geometry && geometry.type ? {
				featureCollection: { type: "FeatureCollection", features: [{ type: "Feature", geometry: geometry }] },
				getFeatureStyle: _this2.getUnitDrawFeatureStyle
			} : undefined;

			if (unitGeometriesData && draw) draw.getFeatureStyle = unitGeometriesData.getFeatureStyle;

			return [draw, [{
				featureCollection: gatheringData.featureCollection,
				getFeatureStyle: _this2.getDataFeatureStyle
			}, {
				featureCollection: {
					type: "FeatureCollection",
					features: unitGeometriesData.featureCollection.features.filter(function (feature) {
						return feature.properties.idx !== idx;
					})
				},
				getFeatureStyle: _this2.getDataFeatureStyle
			}].concat((0, _toConsumableArray3.default)(unitGeometryCollectionsData.map(function (data) {
				return {
					featureCollection: {
						type: "FeatureCollection",
						features: data.featureCollection.features.filter(function (feature) {
							return feature.properties.idx !== idx;
						})
					},
					getFeatureStyle: _this2.getDataFeatureStyle
				};
			})))];
		};

		_this2.getLolifeData = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;

			var _getUiOptions3 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions3$strate = _getUiOptions3.strategy,
			    strategy = _getUiOptions3$strate === undefined ? "unit" : _getUiOptions3$strate;

			var draw = void 0;
			if (strategy === "lolife") {
				draw = map.getDraw();
			}
			var id = (0, _utils.getUUID)(that.props.formData);
			var data = map.data.filter(function (item) {
				var isCurrent = item.featureCollection.features[0].properties.id === id;
				if (strategy === "lolifeUnit" && isCurrent) {
					draw = (0, _extends4.default)({}, item, {
						idx: map.drawIdx,
						getPopup: undefined,
						on: undefined,
						getFeatureStyle: _this2.getFeatureStyleWithHighlight(item.getFeatureStyle),
						getDraftStyle: function getDraftStyle() {
							return _this2.getFeatureStyleWithHighlight(item.getFeatureStyle)({ feature: { properties: { id: id } } }, !!"higlight");
						}
					});
				}
				return !isCurrent;
			}).map(function (item) {
				return (0, _extends4.default)({}, item, { getPopup: undefined, on: undefined, getFeatureStyle: _this2.getFeatureStyleWithLowerOpacity(item.getFeatureStyle) });
			});

			if (strategy === "lolifeUnit") {
				data.push(map.getDraw());
			}

			return [draw, data];
		};

		_this2.onClick = function () {
			var that = _this2.props.that;
			var _that$props = that.props,
			    disabled = _that$props.disabled,
			    readonly = _that$props.readonly;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;


			_this2.triggerLayer = undefined;

			var _this2$getData = _this2.getData(),
			    _this2$getData2 = (0, _slicedToArray3.default)(_this2$getData, 2),
			    draw = _this2$getData2[0],
			    data = _this2$getData2[1];

			data = data.map(function (d) {
				return (0, _extends4.default)({}, d, { editable: false });
			});

			var _ref3 = map ? map.getOptions() : { mapOptions: {} },
			    rootElem = _ref3.rootElem,
			    customControls = _ref3.customControls,
			    zoom = _ref3.zoom,
			    center = _ref3.center,
			    mapOptions = (0, _objectWithoutProperties3.default)(_ref3, ["rootElem", "customControls", "zoom", "center"]); // eslint-disable-line no-unused-vars

			var _getUiOptions4 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions4$mapOpt = _getUiOptions4.mapOptions;

			_getUiOptions4$mapOpt = _getUiOptions4$mapOpt === undefined ? {} : _getUiOptions4$mapOpt;
			var _getUiOptions4$mapOpt2 = _getUiOptions4$mapOpt.marker,
			    marker = _getUiOptions4$mapOpt2 === undefined ? true : _getUiOptions4$mapOpt2,
			    _getUiOptions4$mapOpt3 = _getUiOptions4$mapOpt.polyline,
			    polyline = _getUiOptions4$mapOpt3 === undefined ? false : _getUiOptions4$mapOpt3,
			    _getUiOptions4$mapOpt4 = _getUiOptions4$mapOpt.rectangle,
			    rectangle = _getUiOptions4$mapOpt4 === undefined ? false : _getUiOptions4$mapOpt4,
			    _getUiOptions4$mapOpt5 = _getUiOptions4$mapOpt.polygon,
			    polygon = _getUiOptions4$mapOpt5 === undefined ? false : _getUiOptions4$mapOpt5,
			    _getUiOptions4$mapOpt6 = _getUiOptions4$mapOpt.circle,
			    circle = _getUiOptions4$mapOpt6 === undefined ? false : _getUiOptions4$mapOpt6;


			var modalMap = (0, _extends4.default)({}, mapOptions, {
				data: data,
				draw: (0, _extends4.default)({}, draw, {
					marker: marker,
					polyline: polyline,
					rectangle: rectangle,
					polygon: polygon,
					circle: circle,
					onChange: _this2.onChange,
					editable: !readonly && !disabled
				}),
				controls: (0, _extends4.default)({}, mapOptions.controls, {
					draw: (0, _extends4.default)({}, (mapOptions.controls || {}).draw || {}, {
						clear: false,
						delete: false
					})
				}),
				fullscreenable: true,
				zoomToData: draw ? { draw: true } : true,
				clickBeforeZoomAndPan: false,
				onComponentDidMount: _this2.onMapMounted
			});

			if (center) {
				modalMap.center = center;
			}
			if (zoom) {
				modalMap.zoom = zoom;
			}

			_this2.setState({
				modalMap: modalMap
			});
		};

		_this2.getGrey = function () {
			return { opacity: 0.6, color: "#888888" };
		};

		_this2.getFeatureStyle = function () {
			return { color: "#75CEFA" };
		};

		_this2.onChange = function (events) {
			var that = _this2.props.that;

			var _getUiOptions5 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions5$maxSha = _getUiOptions5.maxShapes,
			    maxShapes = _getUiOptions5$maxSha === undefined ? 1 : _getUiOptions5$maxSha;

			var _that = _this2;
			function close() {
				_that.triggerLayer && _that.triggerLayer.disable();
				_that.onHide();
			}

			var geometryField = _this2.getGeometryField();
			var _iteratorNormalCompletion = true;
			var _didIteratorError = false;
			var _iteratorError = undefined;

			try {
				var _loop = function _loop() {
					var event = _step.value;
					var type = event.type;

					var geometryRef = (0, _utils.parseJSONPointer)(that.props.formData, geometryField);

					switch (type) {
						case "create":
							{
								if (geometryRef && geometryRef.type && (maxShapes > 1 || maxShapes === -1)) {
									if (geometryRef.geometries && maxShapes !== -1 && geometryRef.geometries.length >= maxShapes) {
										_this2.setState({ shapeAlert: { label: "tooManyShapes", max: maxShapes } });
										return {
											v: void 0
										};
									}
									var geometries = geometryRef && geometryRef.geometries ? geometryRef.geometries : geometryRef && geometryRef.type ? [geometryRef] : [];
									that.props.onChange((0, _utils.updateFormDataWithJSONPointer)(that.props, [].concat((0, _toConsumableArray3.default)(geometries), [event.feature.geometry]), geometryField));
								} else {
									that.props.onChange((0, _utils.updateFormDataWithJSONPointer)(that.props, event.feature.geometry, geometryField));
								}
								// TODO LajiMap doesn't send a sequence of events containing multiple events if 
								// it sends a create event, but this isn't necessarily true in the future and
								// closing here wouldn't be right.
								if (maxShapes === 1) close();
								break;
							}
						case "delete":
							{
								if (!geometryRef || !geometryRef.type) {
									break;
								}
								that.props.onChange((0, _utils.updateFormDataWithJSONPointer)(that.props, (0, _utils2.getDefaultFormState)((0, _utils.parseSchemaFromFormDataPointer)(that.props.schema, geometryField), undefined, that.props.registry.definitions), geometryField));
								break;
							}
						case "edit":
							{
								if (!geometryRef || !geometryRef.type) {
									break;
								}
								if (geometryRef.type === "GeometryCollection" && geometryRef.geometries) {
									var geometry = (0, _keys2.default)(event.features).reduce(function (geometry, idx) {
										var feature = event.features[idx];
										geometry = (0, _extends4.default)({}, geometry, { geometries: (0, _extends4.default)({}, geometry.geometries, (0, _defineProperty3.default)({}, idx, feature.geometry)) });
										return geometry;
									}, (0, _utils.parseJSONPointer)(that.props.formData, geometryField));
									that.props.onChange((0, _utils.updateFormDataWithJSONPointer)(that.props, geometry, geometryField));
								} else if (geometryRef.type) {
									that.props.onChange((0, _utils.updateFormDataWithJSONPointer)(that.props, event.features[0].geometry, geometryField));
								}
							}
					}

					if (geometryRef && geometryRef.geometries && geometryRef.geometries.length <= maxShapes && type !== "edit") {
						_this2.setState({ shapeAlert: undefined });
					}
				};

				for (var _iterator = (0, _getIterator3.default)(events), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
					var _ret = _loop();

					if ((typeof _ret === "undefined" ? "undefined" : (0, _typeof3.default)(_ret)) === "object") return _ret.v;
				}
			} catch (err) {
				_didIteratorError = true;
				_iteratorError = err;
			} finally {
				try {
					if (!_iteratorNormalCompletion && _iterator.return) {
						_iterator.return();
					}
				} finally {
					if (_didIteratorError) {
						throw _iteratorError;
					}
				}
			}
		};

		_this2.onMapMounted = function (map) {
			var that = _this2.props.that;
			var _that$props2 = that.props,
			    disabled = _that$props2.disabled,
			    readonly = _that$props2.readonly;

			var _getUiOptions6 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions6$presel = _getUiOptions6.preselectMarker,
			    preselectMarker = _getUiOptions6$presel === undefined ? true : _getUiOptions6$presel;

			map.resetDrawUndoStack();
			if (!disabled && !readonly && preselectMarker) {
				_this2.triggerLayer = map.triggerDrawing("marker");
			}
		};

		_this2.getMiniMapData = function () {
			var that = _this2.props.that;

			var _getUiOptions7 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    _getUiOptions7$strate = _getUiOptions7.strategy,
			    strategy = _getUiOptions7$strate === undefined ? "unit" : _getUiOptions7$strate;

			switch (strategy) {
				case "unit":
					return _this2.getUnitMiniMapData();
				case "lolifeUnit":
					return _this2.getLolifeUnitMiniMapData();
				case "lolife":
					return _this2.getLolifeMiniMapData();
			}
		};

		_this2.getUnitMiniMapData = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;

			var geometry = _this2.getGeometry();

			var data = [].concat((0, _toConsumableArray3.default)(map && map.getDraw() ? [(0, _extends4.default)({}, map.getDraw(), {
				getFeatureStyle: _this2.getGrey
			})] : []), (0, _toConsumableArray3.default)(map && map.data && map.data[0] ? [(0, _extends4.default)({}, map.data[0], {
				getFeatureStyle: _this2.getGrey
			})] : []), [{
				geoData: geometry,
				getFeatureStyle: _this2.getFeatureStyle
			}]);
			return [data, { dataIdxs: [data.length - 1] }];
		};

		_this2.getLolifeMiniMapData = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;

			var draw = map.getDraw();
			return [[draw].concat((0, _toConsumableArray3.default)(map.data.map(function (item) {
				return (0, _extends4.default)({}, item, {
					getPopup: undefined,
					on: undefined,
					editable: false,
					getFeatureStyle: item.getFeatureStyle
				});
			}))), { dataIdxs: [draw.idx || 0] }];
		};

		_this2.getLolifeUnitMiniMapData = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			var map = mapContext.map;

			var id = (0, _utils.getUUID)(that.props.formData);
			return [[].concat((0, _toConsumableArray3.default)(map.data.map(function (item) {
				return (0, _extends4.default)({}, item, {
					getPopup: undefined,
					on: undefined,
					editable: false,
					getFeatureStyle: item.getFeatureStyle ? item.featureCollection.features[0].properties.id === id ? _this2.getFeatureStyleWithHighlight(item.getFeatureStyle) : _this2.getFeatureStyleWithLowerOpacity(item.getFeatureStyle) : undefined
				});
			})), [map.getDraw()]), { dataIdxs: [map.data.findIndex(function (d) {
					return d.featureCollection.features[0].properties.id === id;
				})] }];
		};

		_this2.getFeatureStyleWithLowerOpacity = function (getFeatureStyle) {
			return function () {
				var style = getFeatureStyle.apply(undefined, arguments);
				return (0, _MapArrayField.getFeatureStyleWithLowerOpacity)(style);
			};
		};

		_this2.getFeatureStyleWithHighlight = function (getFeatureStyle) {
			return function () {
				var style = getFeatureStyle.apply(undefined, arguments);
				return (0, _MapArrayField.getFeatureStyleWithHighlight)(style);
			};
		};

		_this2.onEntered = function () {
			var that = _this2.props.that;

			var mapContext = new _Context2.default(that.props.formContext.contextId + "_MAP");
			if (!mapContext) {
				return;
			}

			var map = mapContext.map;

			var mapOptions = {};
			if (map) {
				var _map$getOptions = map.getOptions(),
				    rootElem = _map$getOptions.rootElem,
				    zoom = _map$getOptions.zoom,
				    center = _map$getOptions.center,
				    _mapOptions = (0, _objectWithoutProperties3.default)(_map$getOptions, ["rootElem", "zoom", "center"]); //eslint-disable-line no-unused-vars


				mapOptions = _mapOptions;
			}

			var _this2$getMiniMapData = _this2.getMiniMapData(),
			    _this2$getMiniMapData2 = (0, _slicedToArray3.default)(_this2$getMiniMapData, 2),
			    data = _this2$getMiniMapData2[0],
			    zoomToData = _this2$getMiniMapData2[1];

			_this2.setState({
				miniMap: (0, _extends4.default)({}, mapOptions, {
					draw: false,
					controls: false,
					customControls: undefined,
					zoomToData: zoomToData,
					data: data,
					clickBeforeZoomAndPan: false
				})
			});
		};

		_this2.onHide = function () {
			_this2.setState({ modalMap: undefined });
		};

		_this2.onModalMapKeyDown = function (e) {
			if (e.key === "Escape" && !_this2.modalMapRef.map.keyHandler(e.nativeEvent)) {
				_this2.onHide();
			}
		};

		_this2.setMapRef = function (elem) {
			_this2.modalMapRef = elem;
		};

		_this2.setMiniMapRef = function (elem) {
			_this2.miniMapRef = elem;
		};

		_this2.setButtonRef = function (elem) {
			_this2.buttonRef = elem;
		};

		_this2.getButtonElem = function () {
			return (0, _reactDom.findDOMNode)(_this2.buttonRef);
		};

		_this2.renderButton = function () {
			var _this2$props = _this2.props,
			    that = _this2$props.that,
			    _this2$props$glyph = _this2$props.glyph,
			    glyph = _this2$props$glyph === undefined ? "map-marker" : _this2$props$glyph,
			    label = _this2$props.label;

			var id = that.props.idSchema.$id;

			var _getUiOptions8 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    color = _getUiOptions8.color;

			var hasCoordinates = _this2.hasCoordinates();
			var geometryField = _this2.getGeometryField();
			var hasErrors = (0, _utils.parseJSONPointer)((0, _utils.filteredErrors)(that.props.errorSchema), geometryField);

			var bsStyle = hasErrors ? "danger" : hasCoordinates ? "primary" : "default";

			var button = _react2.default.createElement(LocationButtonComp, {
				key: that.props.idSchema.$id + "-location",
				id: that.props.idSchema.$id + "-location",
				bsStyle: bsStyle,
				onMouseEnter: _this2.onMouseEnter,
				onMouseLeave: _this2.onMouseLeave,
				glyph: glyph,
				onClick: _this2.onClick,
				style: hasCoordinates && !hasErrors && color ? { backgroundColor: color } : undefined,
				ref: _this2.setButtonRef
			});

			if (hasErrors) {
				return _react2.default.createElement(
					_react2.default.Fragment,
					null,
					button,
					_react2.default.createElement(
						_reactBootstrap.Overlay,
						{ show: true, container: _this2, target: _this2.getButtonElem, placement: "left" },
						_react2.default.createElement(
							_reactBootstrap.Tooltip,
							{ id: "laji-form-error-container-" + id + "_" + (0, _utils.JSONPointerToId)(geometryField), className: "location-chooser-errors" },
							_react2.default.createElement(
								"ul",
								null,
								hasErrors.__errors.map(function (e, i) {
									return _react2.default.createElement(
										"li",
										{ key: i },
										(0, _utils.formatErrorMessage)(e)
									);
								})
							)
						)
					)
				);
			} else {
				var translations = that.props.formContext.translations;

				var overlay = hasCoordinates ? _react2.default.createElement(
					_reactBootstrap.Popover,
					{ id: id + "-location-peeker", title: translations.ChooseLocation + " (" + translations.below + " " + translations.currentLocation + ")" },
					_react2.default.createElement(_MapArrayField.Map, (0, _extends4.default)({}, _this2.state.miniMap, {
						hidden: !_this2.state.miniMap || _this2.state.modalMap,
						style: { width: 200, height: 200 },
						singleton: true,
						formContext: that.props.formContext,
						bodyAsDialogRoot: false,
						ref: _this2.setMiniMapRef }))
				) : _react2.default.createElement(
					_reactBootstrap.Tooltip,
					{ id: id + "-location-peeker" },
					label || that.props.formContext.translations.ChooseLocation
				);

				return _react2.default.createElement(
					_components.OverlayTrigger,
					{ key: id + "-set-coordinates-" + glyph,
						overlay: overlay,
						placement: "left",
						hoverable: true,
						_context: new _Context2.default(that.props.formContext.contextId),
						onEntered: hasCoordinates ? _this2.onEntered : undefined },
					button
				);
			}
		};

		_this2.state = {};
		return _this2;
	}

	(0, _createClass3.default)(LocationButton, [{
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this._hovered && this.onMouseLeave();
		}
	}, {
		key: "render",
		value: function render() {
			var that = this.props.that;
			var shapeAlert = this.state.shapeAlert;

			var _getUiOptions9 = (0, _utils.getUiOptions)(that.props.uiSchema),
			    taxonField = _getUiOptions9.taxonField,
			    title = _getUiOptions9.title;

			var translations = that.props.formContext.translations;


			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				this.renderButton(),
				this.state.modalMap && _react2.default.createElement(
					_reactBootstrap.Modal,
					{ key: "map-modal", show: true, dialogClassName: "laji-form map-dialog", onHide: this.onHide, keyboard: false, onKeyDown: this.onModalMapKeyDown },
					_react2.default.createElement(
						_reactBootstrap.Modal.Header,
						{ closeButton: true },
						_react2.default.createElement(
							_reactBootstrap.Modal.Title,
							null,
							title || translations.SetLocationToUnit(that.props.formData[taxonField])
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						shapeAlert && _react2.default.createElement(
							_reactBootstrap.Alert,
							{ bsStyle: "danger" },
							translations[shapeAlert.label] + shapeAlert.max
						),
						_react2.default.createElement(_MapArrayField.Map, (0, _extends4.default)({}, this.state.modalMap, { singleton: true, formContext: that.props.formContext, ref: this.setMapRef, bodyAsDialogRoot: false }))
					)
				)
			);
		}
	}]);
	return LocationButton;
}(_react.Component);

var LocationButtonComp = function (_Component3) {
	(0, _inherits3.default)(LocationButtonComp, _Component3);

	function LocationButtonComp() {
		(0, _classCallCheck3.default)(this, LocationButtonComp);
		return (0, _possibleConstructorReturn3.default)(this, (LocationButtonComp.__proto__ || (0, _getPrototypeOf2.default)(LocationButtonComp)).apply(this, arguments));
	}

	(0, _createClass3.default)(LocationButtonComp, [{
		key: "render",
		value: function render() {
			return _react2.default.createElement(_components.GlyphButton, this.props);
		}
	}]);
	return LocationButtonComp;
}(_react.Component);