"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

exports.findSingleGeometry = findSingleGeometry;
exports.getCenterAndRadiusFromGeometry = getCenterAndRadiusFromGeometry;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MapArrayField = require("./MapArrayField");

var _components = require("../components");

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _utils2 = require("laji-map/lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findSingleGeometry(geoJSON) {
	if (!geoJSON) return undefined;
	switch (geoJSON.type) {
		case "FeatureCollection":
			return geoJSON.features.length === 1 ? findSingleGeometry(geoJSON.features[0]) : undefined;
		case "GeometryCollection":
			return geoJSON.geometries.length === 1 ? findSingleGeometry(geoJSON.geometries[0]) : undefined;
		case "Feature":
			return findSingleGeometry(geoJSON.geometry);
		case undefined:
			return undefined;
		default:
			return geoJSON && geoJSON.coordinates ? geoJSON : undefined;
	}
}

function getCenterAndRadiusFromGeometry(geometry) {
	var singleGeometry = findSingleGeometry(geometry);
	if (!singleGeometry) {
		return {};
	}
	var center = void 0,
	    radius = void 0;
	if (singleGeometry && singleGeometry.type === "Point") {
		center = singleGeometry.coordinates.slice(0).reverse();
		radius = singleGeometry.radius;
	} else {
		var bounds = new L.GeoJSON((0, _utils2.anyToFeatureCollection)(geometry)).getBounds();
		center = bounds.getCenter();
		radius = bounds.getSouthWest().distanceTo(bounds.getSouthEast()) / 2;
	}
	return { center: center, radius: radius };
}

var MapField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(MapField, _Component);

	function MapField(props) {
		(0, _classCallCheck3.default)(this, MapField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (MapField.__proto__ || (0, _getPrototypeOf2.default)(MapField)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = { located: false };
		return _this;
	}

	(0, _createClass3.default)(MapField, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var uiSchema = this.props.uiSchema;

			var _getUiOptions = (0, _utils.getUiOptions)(uiSchema),
			    _getUiOptions$mapOpti = _getUiOptions.mapOptions,
			    mapOptions = _getUiOptions$mapOpti === undefined ? {} : _getUiOptions$mapOpti;

			if (mapOptions.singleton) {
				var map = this.getContext().singletonMap;
				if (map && map.getOptions().locate && map.userLocation) {
					this.onLocate(map.userLocation.latlng, map.userLocation.accuracy);
				}
			}
			this.geocode(this.props);

			new _Context2.default(this.props.formContext.contextId).addCustomEventListener(this.props.idSchema.$id, "locate", this.onLocateEventHandler);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			new _Context2.default(this.props.formContext.contextId).removeCustomEventListener(this.props.idSchema.$id, "locate", this.onLocateEventHandler);
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			this.geocode(prevProps);
			this.zoomIfExternalEdit(this.props);
			this._lastFormData = this.props.formData;
			if (this._zoomToDataOnNextTick) {
				this.map.zoomToData();
				this._zoomToDataOnNextTick = undefined;
			}
		}
	}, {
		key: "render",
		value: function render() {
			var TitleField = this.props.registry.fields.TitleField;
			var _props = this.props,
			    uiSchema = _props.uiSchema,
			    formData = _props.formData;

			var _getUiOptions2 = (0, _utils.getUiOptions)(uiSchema),
			    _getUiOptions2$height = _getUiOptions2.height,
			    height = _getUiOptions2$height === undefined ? 400 : _getUiOptions2$height,
			    emptyHelp = _getUiOptions2.emptyHelp,
			    _getUiOptions2$mapOpt = _getUiOptions2.mapOptions,
			    mapOptions = _getUiOptions2$mapOpt === undefined ? {} : _getUiOptions2$mapOpt,
			    _mobileEditor = _getUiOptions2.mobileEditor,
			    data = _getUiOptions2.data;

			var isEmpty = !formData || !formData.geometries || !formData.geometries.length;
			var _mapOptions = (0, _extends3.default)({
				controls: true,
				clickBeforeZoomAndPan: true
			}, mapOptions, this.state.mapOptions || {}, {
				locate: {
					on: this.state.locateOn || false,
					onLocationFound: this.onLocate
				}
			});

			var isSingleton = _mapOptions.singleton;
			var singletonHasLocate = false;
			var singletonRendered = false;
			if (isSingleton) {
				var map = this.getContext().singletonMap;
				if (map) {
					singletonRendered = true;
					singletonHasLocate = map.getOptions().locate;
				}
			}

			if (mapOptions.createOnLocate && !this.state.mapOptions && (!singletonRendered || singletonHasLocate)) {
				_mapOptions.locate.on = true;
			}

			if (_mobileEditor) {
				_mapOptions.controls = false;
				_mapOptions.viewLocked = true;
				_mapOptions.customControls = [{
					text: this.props.formContext.translations.ChooseLocation,
					fn: this.showMobileEditorMap,
					iconCls: "glyphicon glyphicon-pencil"
				}];
			}

			var _props$formContext = this.props.formContext,
			    lang = _props$formContext.lang,
			    topOffset = _props$formContext.topOffset,
			    bottomOffset = _props$formContext.bottomOffset;
			var mobileEditor = this.state.mobileEditor;


			var mobileEditorOptions = (0, _utils.isObject)(mobileEditor) ? mobileEditor : {};
			var geometry = this.getGeometry(this.props);
			if (geometry) {
				var _getCenterAndRadiusFr = getCenterAndRadiusFromGeometry(geometry),
				    center = _getCenterAndRadiusFr.center,
				    radius = _getCenterAndRadiusFr.radius;

				mobileEditorOptions = {
					center: center,
					radius: radius
				};
			}

			if (this.map && this.map.userLocation) {
				mobileEditorOptions.userLocation = this.map.userLocation;
			}

			var extraData = Array.isArray(data) ? data : [data].map(function (geoData) {
				return { geoData: geoData };
			});

			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(TitleField, { title: this.props.schema.title }),
				_react2.default.createElement(
					_components.Affix,
					{ topOffset: topOffset, bottomOffset: bottomOffset },
					_react2.default.createElement(
						"div",
						{ style: { height: height } },
						_react2.default.createElement(_MapArrayField.MapComponent, (0, _extends3.default)({}, _mapOptions, {
							ref: this.setMapRef,
							draw: this.getDrawOptions(this.props),
							data: extraData,
							lang: lang,
							zoomToData: { paddingInMeters: 200 },
							panel: emptyHelp && isEmpty ? { panelTextContent: emptyHelp } : undefined,
							formContext: this.props.formContext,
							onOptionsChanged: this.onOptionsChanged })),
						this.map && this.map.container && (0, _reactDom.createPortal)(this.renderBlocker(), this.map.container)
					)
				),
				this.state.mapRendered && mobileEditor && mobileEditor.visible && _react2.default.createElement(MobileEditorMap, (0, _extends3.default)({}, mobileEditorOptions, {
					options: mobileEditor.options,
					onChange: this.onMobileEditorChange,
					onClose: this.onHideMobileEditorMap,
					map: this.map,
					formContext: this.props.formContext
				}))
			);
		}
	}, {
		key: "renderBlocker",
		value: function renderBlocker() {
			var _getUiOptions3 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    blockBeforeLocation = _getUiOptions3.blockBeforeLocation;

			var geometry = this.getGeometry(this.props);
			if (blockBeforeLocation && !this.state.located && !geometry) {
				return _react2.default.createElement(
					_react2.default.Fragment,
					null,
					_react2.default.createElement("div", { className: "blocker" }),
					_react2.default.createElement(
						"div",
						{ className: "blocker-content" },
						_react2.default.createElement(
							"span",
							null,
							this.props.formContext.translations.SearchingForLocation,
							"..."
						),
						_react2.default.createElement(_reactSpinner2.default, null)
					)
				);
			}
		}
	}]);
	return MapField;
}(_react.Component)) || _class;

MapField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			mapOptions: _propTypes2.default.object,
			height: _propTypes2.default.number,
			emptyHelp: _propTypes2.default.string,
			geometryCollection: _propTypes2.default.boolean
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.onLocateEventHandler = function (geometry) {
		if (geometry) {
			_this2.onLocate({ lat: geometry.coordinates[1], lng: geometry.coordinates[0] }, 100, !!"force");
		} else if (!_this2.getGeometry(_this2.props)) {
			_this2.setState({ locateOn: true });
		}
	};

	this.geocode = function (prevProps) {
		var _getUiOptions4 = (0, _utils.getUiOptions)(_this2.props.uiSchema),
		    area = _getUiOptions4.area;

		if (area instanceof Array) {
			area = area[0];
		}
		var isEmptyAndWasEmpty = [_this2.props, prevProps].every(function (props) {
			var _getDrawOptions = _this2.getDrawOptions(props),
			    geoData = _getDrawOptions.geoData;

			return !geoData || (0, _utils.isObject)(geoData) && (0, _keys2.default)(geoData).length === 0 || geoData.type === "GeometryCollection" && geoData.geometries.length === 0 || geoData.type === "FeatureCollection" && geoData.features.length === 0;
		});
		if (isEmptyAndWasEmpty && area && area.length > 0) {
			_this2.props.formContext.apiClient.fetch("/areas/" + area, undefined, undefined).then(function (result) {
				_this2.map.geocode(result.name, undefined, 8);
			});
		}
	};

	this.zoomIfExternalEdit = function (props) {
		if (!(0, _deepEqual2.default)(_this2._lastFormData, props.formData)) {
			_this2.map.zoomToData();
		}
	};

	this.setMapRef = function (mapComponent) {
		if (mapComponent && mapComponent.refs && mapComponent.refs.map) {
			_this2.map = mapComponent.refs.map.map;
			_this2.setState({ mapRendered: true });
		}
	};

	this.showMobileEditorMap = function () {
		_this2.setState({ mobileEditor: { visible: true, options: (_this2.state.mobileEditor || {}).options || {} } });
	};

	this.getDrawOptions = function (props) {
		var uiSchema = props.uiSchema,
		    disabled = props.disabled,
		    readonly = props.readonly;

		var options = (0, _utils.getUiOptions)(uiSchema);
		var _options$mapOptions = options.mapOptions,
		    mapOptions = _options$mapOptions === undefined ? {} : _options$mapOptions,
		    mobileEditor = options.mobileEditor;

		var drawOptions = (0, _extends3.default)({}, mapOptions.draw || {}, {
			geoData: _this2.getGeometry(props),
			onChange: _this2.onChange,
			editable: !disabled && !readonly
		});
		if (mobileEditor) {
			drawOptions.getFeatureStyle = _this2.getEditWithModalFeatureStyle;
		}
		return drawOptions;
	};

	this.getEditWithModalFeatureStyle = function () {
		return {
			fillOpacity: 0,
			color: "black",
			weight: "2"
		};
	};

	this.getGeometry = function (props) {
		var formData = props.formData;

		return formData && (0, _keys2.default)(formData).length ? formData : undefined;
	};

	this.onOptionsChanged = function (options) {
		_this2.setState({ mapOptions: (0, _extends3.default)({}, _this2.state.mapOptions, options) });
	};

	this.onChange = function (events) {
		var _getUiOptions5 = (0, _utils.getUiOptions)(_this2.props.uiSchema),
		    _getUiOptions5$geomet = _getUiOptions5.geometryCollection,
		    geometryCollection = _getUiOptions5$geomet === undefined ? true : _getUiOptions5$geomet;

		var formData = void 0;
		events.forEach(function (e) {
			switch (e.type) {
				case "create":
					formData = geometryCollection ? {
						type: "GeometryCollection",
						geometries: [e.feature.geometry]
					} : e.feature.geometry;
					break;
				case "edit":
					formData = geometryCollection ? {
						type: "GeometryCollection",
						geometries: [e.features[0].geometry]
					} : e.features[0].geometry;
					break;
				case "delete":
					formData = geometryCollection ? {
						type: "GeometryCollection",
						geometries: []
					} : {};
			}
		});
		_this2._zoomToDataOnNextTick = true;
		_this2.props.onChange(formData);
	};

	this.onMobileEditorChange = function (point) {
		var geometry = _this2.getGeometry(_this2.props);
		var feature = {
			type: "Feature",
			geometry: point
		};
		if (geometry) {
			_this2.onChange([{ type: "edit", features: [feature] }]);
		} else {
			_this2.onChange([{ type: "create", feature: feature }]);
		}
	};

	this.onHideMobileEditorMap = function (options) {
		_this2.setState({ mobileEditor: { visible: false, options: options } });
	};

	this.onLocate = function (latlng, radius, forceShow) {
		var _getUiOptions6 = (0, _utils.getUiOptions)(_this2.props.uiSchema),
		    _getUiOptions6$geomet = _getUiOptions6.geometryCollection,
		    geometryCollection = _getUiOptions6$geomet === undefined ? true : _getUiOptions6$geomet,
		    mobileEditor = _getUiOptions6.mobileEditor,
		    createOnLocate = _getUiOptions6.createOnLocate;

		var isEmpty = !_this2.getGeometry(_this2.props);
		if (!latlng || !isEmpty) {
			_this2.setState({ located: true });
			return;
		}
		if (mobileEditor) {
			if (!_this2.state.located || forceShow) {
				_this2.setState({
					mobileEditor: {
						visible: true,
						center: latlng,
						radius: radius,
						options: (_this2.state.mobileEditor || {}).options || {}
					},
					located: true
				});
			}
			return;
		}
		_this2.setState({ located: true });
		if (createOnLocate) {
			var geometry = { type: "Point", coordinates: [latlng.lng, latlng.lat] };
			_this2.props.onChange(geometryCollection ? { type: "GeometryCollection", geometries: [geometry] } : geometry);
		}
	};
};

exports.default = MapField;

var MobileEditorMap = function (_Component2) {
	(0, _inherits3.default)(MobileEditorMap, _Component2);

	function MobileEditorMap(props) {
		(0, _classCallCheck3.default)(this, MobileEditorMap);

		var _this3 = (0, _possibleConstructorReturn3.default)(this, (MobileEditorMap.__proto__ || (0, _getPrototypeOf2.default)(MobileEditorMap)).call(this, props));

		_initialiseProps2.call(_this3);

		var _this3$props = _this3.props,
		    center = _this3$props.center,
		    radius = _this3$props.radius;


		_this3.state = { mapOptions: _this3.setViewFromCenterAndRadius(center, radius) };
		return _this3;
	}

	(0, _createClass3.default)(MobileEditorMap, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.okButtonElem.focus();
		}
	}, {
		key: "componenWillUnmount",
		value: function componenWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "getCircle",
		value: function getCircle(radiusPixels) {
			return _react2.default.createElement(
				"svg",
				{ width: "100%", height: "100%", style: { position: "absolute", zIndex: 1000, top: 0, pointerEvents: "none" } },
				_react2.default.createElement(
					"defs",
					null,
					_react2.default.createElement(
						"mask",
						{ id: "mask", x: "0", y: "0", width: "100%", height: "100%" },
						_react2.default.createElement("rect", { x: "0", y: "0", width: "100%", height: "100%", fill: "#fff" }),
						_react2.default.createElement("circle", { cx: "50%", cy: "50%", r: radiusPixels })
					)
				),
				_react2.default.createElement("rect", { x: "0", y: "0", width: "100%", height: "100%", mask: "url(#mask)", fillOpacity: "0.2" }),
				_react2.default.createElement("circle", { cx: "50%", cy: "50%", r: radiusPixels, stroke: "black", strokeWidth: "2", fillOpacity: "0" })
			);
		}
	}, {
		key: "render",
		value: function render() {
			var _props$map$getOptions = this.props.map.getOptions(),
			    rootElem = _props$map$getOptions.rootElem,
			    customControls = _props$map$getOptions.customControls,
			    draw = _props$map$getOptions.draw,
			    data = _props$map$getOptions.data,
			    zoomToData = _props$map$getOptions.zoomToData,
			    zoom = _props$map$getOptions.zoom,
			    center = _props$map$getOptions.center,
			    locate = _props$map$getOptions.locate,
			    options = (0, _objectWithoutProperties3.default)(_props$map$getOptions, ["rootElem", "customControls", "draw", "data", "zoomToData", "zoom", "center", "locate"]); // eslint-disable-line no-unused-vars


			var userLocation = this.props.userLocation;


			options = (0, _extends3.default)({}, options, this.props.options || {}, this.state.mapOptions);

			options.locate = {
				on: true,
				userLocation: userLocation,
				onLocationFound: this.onLocate,
				panOnFound: false
			};

			var translations = this.props.formContext.translations;


			return _react2.default.createElement(
				_components.Fullscreen,
				{ onKeyDown: this.onKeyDown, tabIndex: -1, ref: this.setContainerRef, contextId: this.props.formContext.contextId },
				_react2.default.createElement(_MapArrayField.MapComponent, (0, _extends3.default)({}, options, {
					singleton: true,
					clickBeforeZoomAndPan: false,
					viewLocked: false,
					controls: { draw: false },
					ref: this.setMobileEditorMapRef,
					formContext: this.props.formContext })),
				this.state.mapRendered && (0, _reactDom.createPortal)(this.getCircle(this.DEFAULT_RADIUS_PIXELS), this.map.container),
				_react2.default.createElement(
					"div",
					{ className: "floating-buttons-container" },
					_react2.default.createElement(
						_components.Button,
						{ block: true, onClick: this.onChange, ref: this.setOkButtonRef },
						translations.ChooseThisLocation
					),
					_react2.default.createElement(
						_components.Button,
						{ block: true, onClick: this.onClose },
						translations.Cancel
					)
				)
			);
		}
	}]);
	return MobileEditorMap;
}(_react.Component);

var _initialiseProps2 = function _initialiseProps2() {
	var _this4 = this;

	this.DEFAULT_RADIUS_PIXELS = 100;

	this.setMobileEditorMapRef = function (mapComponent) {
		if (mapComponent && mapComponent.refs && mapComponent.refs.map) {
			_this4.map = mapComponent.refs.map.map;
		}

		_this4.setState({ mapRendered: true });
	};

	this.setOkButtonRef = function (elem) {
		_this4.okButtonElem = (0, _reactDom.findDOMNode)(elem);
	};

	this.onChange = function () {
		var map = _this4.map.map;

		var centerLatLng = map.getCenter();
		var centerPoint = map.latLngToContainerPoint(centerLatLng);
		var leftEdgeAsLatLng = map.containerPointToLatLng({ x: centerPoint.x - _this4.DEFAULT_RADIUS_PIXELS, y: centerPoint.y });
		var radius = map.getCenter().distanceTo(leftEdgeAsLatLng);
		_this4.props.onChange({
			type: "Point",
			coordinates: [centerLatLng.lng, centerLatLng.lat],
			radius: radius
		});
		_this4.onClose();
	};

	this.computePadding = function () {
		// If the rendered element wasn't full screen, we couldn't use these as height/width.
		var height = window.innerHeight;
		var width = window.innerWidth;
		var topToCircleEdgePixels = parseInt(height / 2 - _this4.DEFAULT_RADIUS_PIXELS);
		var leftToCircleEdgePixels = parseInt(width / 2 - _this4.DEFAULT_RADIUS_PIXELS);
		var padding = [leftToCircleEdgePixels, topToCircleEdgePixels];
		return padding;
	};

	this.setViewFromCenterAndRadius = function (center, radius) {
		if (center) {
			if (radius) {
				var centerLatLng = L.latLng(center);
				var data = {
					geoData: {
						type: "Point",
						coordinates: [centerLatLng.lng, centerLatLng.lat],
						radius: radius
					},
					getFeatureStyle: _this4.invisibleStyle
				};
				var zoomToData = {
					padding: _this4.computePadding()
				};
				return { data: data, zoomToData: zoomToData };
			}
			return { center: center };
		}
		return {};
	};

	this.invisibleStyle = function () {
		return {
			opacity: 0,
			fillOpacity: 0
		};
	};

	this.onKeyDown = function (_ref) {
		var key = _ref.key;

		if (key === "Escape") {
			_this4.onClose();
		}
	};

	this.onLocate = function (latlng, accuracy) {
		if (_this4.props.center || !_this4.mounted) return;

		var options = _this4.setViewFromCenterAndRadius(latlng, accuracy);
		if (options.data && options.zoomToData) {
			_this4.setState({ mapOptions: { data: options.data } }, function () {
				_this4.map.zoomToData(options.zoomToData);
			});
		} else if (options.center) {
			_this4.map.setCenter(options.center);
		}
	};

	this.onClose = function () {
		_this4.props.onClose(_this4.map.getOptions());
	};
};