"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _utils2 = require("react-jsonschema-form/lib/utils");

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _MapArrayField = require("./MapArrayField");

var _globals = require("laji-map/lib/globals");

var _SelectWidget = require("../widgets/SelectWidget");

var _SelectWidget2 = _interopRequireDefault(_SelectWidget);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PLACES_FETCH_FAIL = "PLACES_FETCH_FAIL";
var PLACE_USE_FAIL = "PLACE_USE_FAIL";
var PLACE_DELETE_FAIL = "PLACE_DELETE_FAIL";

/**
 * Compatible only with gatherings array and gathering object.
 */

var NamedPlaceChooserField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(NamedPlaceChooserField, _Component);

	function NamedPlaceChooserField(props) {
		(0, _classCallCheck3.default)(this, NamedPlaceChooserField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (NamedPlaceChooserField.__proto__ || (0, _getPrototypeOf2.default)(NamedPlaceChooserField)).call(this, props));

		_initialiseProps.call(_this);

		_this.apiClient = props.formContext.apiClient;
		_this.removeIds = {};
		return _this;
	}

	(0, _createClass3.default)(NamedPlaceChooserField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			return { uiSchema: this.getUiSchema(props) };
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this.updatePlaces();
			this.apiClient.onCachePathInvalidation("/named-places", this.updatePlaces);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			this.apiClient.removeOnCachePathInvalidation("/named-places", this.updatePlaces);
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    SchemaField = _props.registry.fields.SchemaField,
			    formContext = _props.formContext;
			var translations = formContext.translations;
			var failed = this.state.failed;

			var onHide = function onHide() {
				return _this2.setState({ show: false });
			};
			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: this.state.uiSchema })),
				this.state.show ? _react2.default.createElement(
					_reactBootstrap.Modal,
					{ dialogClassName: "laji-form map-dialog", show: true, onHide: onHide },
					_react2.default.createElement(
						_reactBootstrap.Modal.Header,
						{ closeButton: true },
						translations.ChooseNamedPlace
					),
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						failed === PLACES_FETCH_FAIL && _react2.default.createElement(
							_reactBootstrap.Alert,
							{ bsStyle: "danger" },
							translations.NamedPlacesUseFail
						),
						_react2.default.createElement(NamedPlaceChooser, { places: this.state.places, failed: failed === PLACES_FETCH_FAIL ? true : false, formContext: formContext, onSelected: this.onPlaceSelected, onDeleted: this.onPlaceDeleted })
					)
				) : null
			);
		}
	}]);
	return NamedPlaceChooserField;
}(_react.Component)) || _class;

NamedPlaceChooserField.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object", "array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array])
};

var _initialiseProps = function _initialiseProps() {
	var _this3 = this;

	this.getUiSchema = function (props) {
		if (_this3.buttonDefinition) {
			var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			var options = (0, _utils.getUiOptions)(innerUiSchema);
			return (0, _extends3.default)({}, innerUiSchema, {
				"ui:options": (0, _extends3.default)({}, options, {
					buttons: [].concat((0, _toConsumableArray3.default)(options.buttons || []), [_this3.buttonDefinition])
				})
			});
		} else {
			return (0, _utils.getInnerUiSchema)(props.uiSchema);
		}
	};

	this.isGatheringsArray = function () {
		return _this3.props.schema.type === "array";
	};

	this.onPlaceSelected = function (place) {
		var getGathering = function getGathering(schema) {
			var whitelist = ["geometry", "country", "administrativeProvince", "biologicalProvince", "municipality", "locality", "localityDescription", "habitat", "habitatDescription"];
			var gathering = (0, _utils2.getDefaultFormState)(schema, undefined, _this3.props.registry.definitions);
			var placeGathering = place.prepopulatedDocument.gatherings[0];
			whitelist.forEach(function (prop) {
				if (prop in placeGathering) {
					gathering[prop] = placeGathering[prop];
				}
			});
			gathering.namedPlaceID = place.id;
			var tmpIdTree = (0, _utils.getRelativeTmpIdTree)(_this3.props.formContext.contextId, _this3.props.idSchema.$id);

			var _addLajiFormIds = (0, _utils.addLajiFormIds)(gathering, tmpIdTree, false),
			    _addLajiFormIds2 = (0, _slicedToArray3.default)(_addLajiFormIds, 1),
			    withLajiFormIds = _addLajiFormIds2[0];

			return withLajiFormIds;
		};

		try {
			var targetId = void 0,
			    gathering = void 0,
			    newFormData = void 0,
			    zoomToData = void 0;
			if (_this3.isGatheringsArray()) {
				gathering = getGathering(_this3.props.schema.items);

				newFormData = [].concat((0, _toConsumableArray3.default)(_this3.props.formData || []), [gathering]);
				_this3.setState({ show: false });
				targetId = _this3.props.idSchema.$id;
				new _Context2.default(_this3.props.formContext.contextId).sendCustomEvent(targetId, "activeIdx", (_this3.props.formData || []).length);
			} else {
				// gathering object
				gathering = getGathering(_this3.props.schema);
				gathering.namedPlaceID = place.id;

				newFormData = (0, _extends3.default)({}, _this3.props.formData, gathering);
				_this3.setState({ show: false });
				var splits = _this3.props.idSchema.$id.split("_");
				splits.pop();
				targetId = splits.join("_");
				zoomToData = true;
			}
			_this3.props.onChange(newFormData);
			if (zoomToData) new _Context2.default(_this3.props.formContext.contextId).sendCustomEvent(targetId, "zoomToData", undefined);
		} catch (e) {
			_this3.setState({ failed: PLACE_USE_FAIL });
		}
	};

	this.onPlaceDeleted = function (place, success) {
		_this3.apiClient.fetchRaw("/named-places/" + place.id, undefined, { method: "DELETE" }).then(function (response) {
			if (response.status === 204) {
				// It takes a while for API to remove the place, so we remove it locally and then invalidate again after some time.
				_this3.removeIds[place.id] = true;
				_this3.apiClient.invalidateCachePath("/named-places");
				_this3.getContext().setTimeout(function () {
					return _this3.apiClient.invalidateCachePath("/named-places");
				}, 2000);
				success();
			}
		}).catch(function () {
			_this3.setState({ failed: PLACE_DELETE_FAIL });
			_this3.props.formContext.notifier.error(_this3.props.formContext.translations.PlaceRemovalFailed);
		});
	};

	this.onButtonClick = function () {
		return function () {
			_this3.setState({ show: true });
		};
	};

	this.updatePlaces = function () {
		_this3.buttonDefinition = undefined;
		_this3.apiClient.fetchCached("/named-places", { includePublic: false, pageSize: 1000 }).then(function (response) {
			if (!_this3.mounted) return;
			var state = { places: response.results.filter(function (p) {
					return !_this3.removeIds[p.id];
				}).sort(function (a, b) {
					if (a.name < b.name) return -1;
					if (a.name > b.name) return 1;
					return 0;
				}) };

			if (response.results && response.results.length) {
				_this3.buttonDefinition = {
					fn: _this3.onButtonClick,
					fnName: "addNamedPlace",
					glyph: "map-marker",
					label: _this3.props.formContext.translations.ChooseFromNamedPlace,
					id: _this3.props.idSchema.$id,
					changesFormData: true
				};
				if (_this3.isGatheringsArray()) {
					_this3.buttonDefinition.rules = { canAdd: true };
				} else {
					_this3.buttonDefinition.position = "top";
				}
				var uiSchema = _this3.getUiSchema(_this3.props);
				state.uiSchema = uiSchema;
			}

			_this3.setState(state);
		}).catch(function () {
			_this3.setState({ failed: PLACES_FETCH_FAIL });
		});
	};
};

exports.default = NamedPlaceChooserField;

var NamedPlaceChooser = function (_Component2) {
	(0, _inherits3.default)(NamedPlaceChooser, _Component2);

	function NamedPlaceChooser(props) {
		(0, _classCallCheck3.default)(this, NamedPlaceChooser);

		var _this4 = (0, _possibleConstructorReturn3.default)(this, (NamedPlaceChooser.__proto__ || (0, _getPrototypeOf2.default)(NamedPlaceChooser)).call(this, props));

		_this4.onPlaceSelected = function (place) {
			_this4.props.onSelected(place);
		};

		_this4.onPlaceDeleted = function (place) {
			var onDelete = function onDelete() {
				if (_this4.popupContainerElem && _this4.popupElem) {
					_this4.popupContainerElem.appendChild((0, _reactDom.findDOMNode)(_this4.popupElem));
				}
				_this4.mapElem.map.map.closePopup();
				_this4.setState({ deleting: false, popupIdx: undefined });
			};
			_this4.setState({ deleting: true });
			_this4.props.onDeleted(place, onDelete);
		};

		_this4.onSelectChange = function (idx) {
			var map = _this4.mapElem.map;

			var layers = _this4.idxToLayer[idx];

			var _layers = (0, _slicedToArray3.default)(layers, 1),
			    layer = _layers[0];

			var bounds = map.getBoundsForLayers(layers);
			var center = bounds.getCenter();
			map.fitBounds(bounds, { animate: false });
			new _Context2.default(_this4.props.formContext.contextId).setImmediate(function () {
				return layer.fire("click", { latlng: center });
			}, 10);
		};

		_this4.onMapChange = function (events) {
			events.some(function (_ref) {
				var type = _ref.type,
				    idx = _ref.idx;

				if (type === "active") {
					_this4.setState({ popupIdx: idx });
					var map = _this4.mapElem.map;

					if (_this4.geometryCollectionData) {
						map.setData();
					}
					_this4.geometryCollectionData = {
						geoData: _this4.props.places[idx].geometry
					};
					map.setData(_this4.geometryCollectionData);
					return true;
				}
			});
		};

		_this4.getFeatureStyle = function (data) {
			var _ref2 = data || {},
			    _ref2$feature = _ref2.feature,
			    feature = _ref2$feature === undefined ? {} : _ref2$feature;

			function getColor(idx) {
				var r = _globals.NORMAL_COLOR.substring(1, 3);
				var g = _globals.NORMAL_COLOR.substring(3, 5);
				var b = _globals.NORMAL_COLOR.substring(5, 7);
				return [r, g, b].reduce(function (rgb, hex) {
					var decimal = parseInt(hex, 16);
					var amount = 40;
					var _decimal = idx % 2 ? decimal : Math.min(decimal + amount, 255);
					return rgb + _decimal.toString(16);
				}, "#");
			}

			var _ref3 = feature.properties || {},
			    idx = _ref3.idx;

			var color = idx === _this4.state.popupIdx ? _globals.ACTIVE_COLOR : getColor(idx);
			return { color: color, fillColor: color };
		};

		_this4.setPopupContainerRef = function (elem) {
			_this4.popupContainerElem = elem;
		};

		_this4.state = {};
		return _this4;
	}

	(0, _createClass3.default)(NamedPlaceChooser, [{
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			var _this5 = this;

			var map = this.mapElem.map;

			this.idxToLayer = map.data.reduce(function (idxToLayer, item) {
				var layerGroup = item.group;
				layerGroup.eachLayer(function (layer) {
					if (!idxToLayer[layer.feature.properties.idx]) {
						idxToLayer[layer.feature.properties.idx] = [];
					}
					idxToLayer[layer.feature.properties.idx].push(layer);
				});
				return idxToLayer;
			}, {});

			if (this.state.popupIdx !== prevState.popupIdx) {
				var prevLayers = this.idxToLayer[prevState.popupIdx] || [];
				var layers = this.idxToLayer[this.state.popupIdx] || [];

				[prevLayers, layers].forEach(function (layers) {
					layers.forEach(function (layer) {
						if (layer) {
							map.setLayerStyle(layer, _this5.getFeatureStyle({ feature: layer.feature }));
						}
					});
				});
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _this6 = this;

			var _props2 = this.props,
			    places = _props2.places,
			    failed = _props2.failed,
			    translations = _props2.formContext.translations;


			var that = this;
			function getPopupRef(elem) {
				that.popupElem = elem;
			}
			function getMapRef(elem) {
				that.mapElem = elem;
			}

			function getPopup(_ref4, callback) {
				var feature = _ref4.feature;
				var idx = feature.properties.idx;

				that.setState({ popupIdx: idx });
				callback((0, _reactDom.findDOMNode)(that.popupElem));
			}

			if (failed) {
				return _react2.default.createElement(
					_reactBootstrap.Alert,
					{ bsStyle: "danger" },
					translations.NamedPlacesFetchFail + " " + translations.TryAgainLater
				);
			} else {
				var enums = (places || []).map(function (place, idx) {
					return { value: idx, label: place.name };
				});
				var pointer = 1;
				var data = (places || []).reduce(function (data, place, i) {
					var geometry = place.geometry;

					var isCollection = false;
					if (geometry.type === "GeometryCollection") {
						isCollection = true;
					}
					if (isCollection) {
						data[pointer] = {
							geoData: { type: "FeatureCollection", features: geometry.geometries.map(function (geom) {
									return { type: "Feature", geometry: geom, properties: { idx: i } };
								}) },
							getFeatureStyle: _this6.getFeatureStyle,
							getPopup: getPopup,
							highlightOnHover: true
						};
						pointer++;
					} else {
						if (!data[0]) data[0] = {
							geoData: { type: "FeatureCollection", features: [] },
							getFeatureStyle: _this6.getFeatureStyle,
							getPopup: getPopup,
							cluster: true,
							highlightOnHover: true
						};
						data[0].geoData.features.push({ type: "Feature", geometry: geometry, properties: { idx: i } });
					}
					return data;
				}, []);

				return _react2.default.createElement(
					"div",
					{ style: { height: "inherit" } },
					_react2.default.createElement(_SelectWidget2.default, {
						disabled: !places,
						options: { enumOptions: enums, placeholder: translations.SelectPlaceFromList + "..." },
						onChange: this.onSelectChange,
						selectOnChange: false,
						schema: {},
						id: "named-place-chooser-select",
						formContext: this.props.formContext }),
					_react2.default.createElement(_MapArrayField.Map, {
						ref: getMapRef,
						data: data,
						markerPopupOffset: 45,
						featurePopupOffset: 5,
						controls: { draw: false },
						lang: this.props.formContext.lang,
						bodyAsDialogRoot: false
					}),
					!places ? _react2.default.createElement(_reactSpinner2.default, null) : null,
					_react2.default.createElement(
						"div",
						{ style: { display: "none" }, ref: this.setPopupContainerRef },
						_react2.default.createElement(Popup, { ref: getPopupRef,
							place: (places || [])[this.state.popupIdx],
							onPlaceSelected: this.onPlaceSelected,
							onPlaceDeleted: this.onPlaceDeleted,
							deleting: this.state.deleting,
							contextId: this.props.formContext.contextId,
							translations: translations })
					)
				);
			}
		}
	}]);
	return NamedPlaceChooser;
}(_react.Component);

var Popup = function (_Component3) {
	(0, _inherits3.default)(Popup, _Component3);

	function Popup() {
		var _ref5;

		var _temp, _this7, _ret;

		(0, _classCallCheck3.default)(this, Popup);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this7 = (0, _possibleConstructorReturn3.default)(this, (_ref5 = Popup.__proto__ || (0, _getPrototypeOf2.default)(Popup)).call.apply(_ref5, [this].concat(args))), _this7), _this7._onPlaceSelected = function () {
			_this7.props.onPlaceSelected(_this7.props.place);
		}, _this7._onPlaceDeleted = function () {
			_this7.props.onPlaceDeleted(_this7.props.place);
		}, _this7.getButtonRef = function (elem) {
			_this7.buttonElem = elem;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this7, _ret);
	}

	(0, _createClass3.default)(Popup, [{
		key: "componentDidUpdate",
		value: function componentDidUpdate() {
			var _this8 = this;

			new _Context2.default(this.props.contextId).setImmediate(function () {
				if (_this8.buttonElem) (0, _reactDom.findDOMNode)(_this8.buttonElem).focus();
			});
		}
	}, {
		key: "render",
		value: function render() {
			var _props3 = this.props,
			    place = _props3.place,
			    translations = _props3.translations,
			    deleting = _props3.deleting;


			return place ? _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(
					"table",
					{ className: "named-place-popup" },
					_react2.default.createElement(
						"tbody",
						null,
						[["Name", "name"], ["Notes", "notes"]].reduce(function (fieldset, _ref6, i) {
							var _ref7 = (0, _slicedToArray3.default)(_ref6, 2),
							    translationKey = _ref7[0],
							    fieldName = _ref7[1];

							if (!(0, _utils.isEmptyString)(place[fieldName])) fieldset.push(_react2.default.createElement(
								"tr",
								{ key: i },
								_react2.default.createElement(
									"td",
									null,
									_react2.default.createElement(
										"b",
										null,
										translations[translationKey],
										": "
									)
								),
								_react2.default.createElement(
									"td",
									null,
									place[fieldName]
								)
							));
							return fieldset;
						}, [])
					)
				),
				_react2.default.createElement(
					_components.Button,
					{ block: true, ref: this.getButtonRef, onClick: this._onPlaceSelected },
					translations.UseThisPlace
				),
				_react2.default.createElement(
					_components.DeleteButton,
					{ block: true,
						onClick: this._onPlaceDeleted,
						disabled: deleting,
						glyphButton: false,
						confirm: true,
						confirmStyle: "browser",
						translations: translations },
					translations.Remove,
					" ",
					deleting && _react2.default.createElement(_reactSpinner2.default, null)
				)
			) : _react2.default.createElement(_reactSpinner2.default, null);
		}
	}]);
	return Popup;
}(_react.Component);

new _Context2.default("SCHEMA_FIELD_WRAPPERS").NamedPlaceChooserField = true;