"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _stringify = require("babel-runtime/core-js/json/stringify");

var _stringify2 = _interopRequireDefault(_stringify);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _MapArrayField = require("./MapArrayField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SAVE = "SAVE",
    FETCH = "FETCH";

/**
 * Compatible only with gathering field.
 */

var NamedPlaceSaverField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(NamedPlaceSaverField, _Component);

	function NamedPlaceSaverField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, NamedPlaceSaverField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = NamedPlaceSaverField.__proto__ || (0, _getPrototypeOf2.default)(NamedPlaceSaverField)).call.apply(_ref, [this].concat(args))), _this), _this.onButtonClick = function () {
			return function () {
				_this.setState({ show: !_this.state.show });
			};
		}, _this.onSave = function (place) {
			_this.setState({ show: false }, function () {
				_this.props.onChange((0, _extends3.default)({}, _this.props.formData, { namedPlaceID: place.id }));
			});
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(NamedPlaceSaverField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			var uiSchema = (0, _extends3.default)({}, innerUiSchema, {
				"ui:options": (0, _extends3.default)({}, (0, _utils.getUiOptions)(innerUiSchema), {
					buttons: [].concat((0, _toConsumableArray3.default)((0, _utils.getUiOptions)(innerUiSchema).buttons || []), [this.getButton(props)])
				})
			});

			return { uiSchema: uiSchema };
		}
	}, {
		key: "getButton",
		value: function getButton(props) {
			return {
				label: props.formContext.translations.SaveNamedPlace,
				fn: this.onButtonClick,
				glyph: "floppy-disk",
				position: "top",
				disabled: !(0, _MapArrayField.parseGeometries)(props.formData.geometry).length
			};
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps, prevState) {
			if (prevState.show !== this.state.show) this.setState(this.getStateFromProps(this.props));
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    SchemaField = _props.registry.fields.SchemaField,
			    formContext = _props.formContext;
			var uiSchema = this.state.uiSchema;

			var onHide = function onHide() {
				return _this2.setState({ show: false });
			};
			return _react2.default.createElement(
				"div",
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: uiSchema })),
				this.state && this.state.show ? _react2.default.createElement(
					_reactBootstrap.Modal,
					{ dialogClassName: "laji-form", show: true, onHide: onHide },
					_react2.default.createElement(
						_reactBootstrap.Modal.Header,
						null,
						_react2.default.createElement(
							_reactBootstrap.Modal.Title,
							null,
							formContext.translations.NamedPlaces
						)
					),
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						_react2.default.createElement(PlaceSaverDialog, { formContext: formContext, onSave: this.onSave, gathering: this.props.formData })
					)
				) : null
			);
		}
	}]);
	return NamedPlaceSaverField;
}(_react.Component)) || _class;

NamedPlaceSaverField.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};
exports.default = NamedPlaceSaverField;

var PlaceSaverDialog = function (_Component2) {
	(0, _inherits3.default)(PlaceSaverDialog, _Component2);

	function PlaceSaverDialog(props) {
		(0, _classCallCheck3.default)(this, PlaceSaverDialog);

		var _this3 = (0, _possibleConstructorReturn3.default)(this, (PlaceSaverDialog.__proto__ || (0, _getPrototypeOf2.default)(PlaceSaverDialog)).call(this, props));

		_initialiseProps.call(_this3);

		var _props$gathering = props.gathering,
		    namedPlaceID = _props$gathering.namedPlaceID,
		    _props$gathering$loca = _props$gathering.locality,
		    locality = _props$gathering$loca === undefined ? "" : _props$gathering$loca;

		_this3.state = { value: locality };
		if (namedPlaceID) {
			_this3.state = { value: "", loading: true };
		}
		_this3.apiClient = props.formContext.apiClient;
		return _this3;
	}

	(0, _createClass3.default)(PlaceSaverDialog, [{
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this4 = this;

			this.mounted = true;

			this.apiClient.fetchCached("/named-places", { includePublic: false, pageSize: 1000 }).then(function (response) {
				if (!_this4.mounted) return;
				var state = {
					places: response.results,
					placeIdsToPlaces: response.results.reduce(function (idsToPlaces, place) {
						idsToPlaces[place.id] = place;
						return idsToPlaces;
					}, {}),
					placeNamesToPlaces: response.results.reduce(function (namesToPlaces, place) {
						if (!namesToPlaces[place.name]) namesToPlaces[place.name] = [];
						namesToPlaces[place.name].push(place);
						return namesToPlaces;
					}, {})
				};

				var namedPlaceID = _this4.props.gathering.namedPlaceID;

				if (namedPlaceID) {
					state.value = state.placeIdsToPlaces[namedPlaceID].name;
					state.loading = false;
				}

				_this4.setState(state, function () {
					if (namedPlaceID) {
						(0, _reactDom.findDOMNode)(_this4.inputRef).focus();
					}
				});
			}).catch(function () {
				_this4.setState({ failed: FETCH });
			});
		}
	}, {
		key: "onSave",
		value: function onSave(place) {
			var _this5 = this;

			place = (0, _extends3.default)({}, place, {
				geometry: place.prepopulatedDocument.gatherings[0].geometry
			});

			new _Context2.default(this.props.formContext.contextId).pushBlockingLoader();
			this.apiClient.fetchRaw("/named-places" + (place.id ? "/" + place.id : ""), undefined, {
				method: place.id ? "PUT" : "POST",
				headers: {
					"accept": "application/json",
					"content-type": "application/json"
				},
				body: (0, _stringify2.default)(place)
			}).then(function (response) {
				new _Context2.default(_this5.props.formContext.contextId).popBlockingLoader();
				_this5.apiClient.invalidateCachePath("/named-places");
				return response.json();
			}).then(this.props.onSave).catch(function () {
				new _Context2.default(_this5.props.formContext.contextId).popBlockingLoader();
				_this5.setState({ failed: SAVE });
			});
		}

		// Hack that fixed autofocus cursor position

	}, {
		key: "render",
		value: function render() {
			var _this6 = this;

			var _state = this.state,
			    value = _state.value,
			    _state$placeNamesToPl = _state.placeNamesToPlaces,
			    placeNamesToPlaces = _state$placeNamesToPl === undefined ? {} : _state$placeNamesToPl,
			    loading = _state.loading;
			var translations = this.props.formContext.translations;

			var existingPlaces = (placeNamesToPlaces[value] || []).filter(function (place) {
				return (place.owners || []).indexOf(_this6.props.formContext.uiSchemaContext.creator) !== -1;
			});

			var getButton = function getButton(onClick, text) {
				return _react2.default.createElement(
					_components.Button,
					{ bsSize: "small", onClick: onClick, disabled: loading || (0, _utils.isEmptyString)(value) },
					text
				);
			};

			return this.state.failed ? _react2.default.createElement(
				_reactBootstrap.Alert,
				{ bsStyle: "danger" },
				translations["NamedPlaces" + (this.state.failed === FETCH ? "Fetch" : "Save") + "Fail"] + " " + translations.TryAgainLater
			) : _react2.default.createElement(
				"div",
				{ className: "place-saver-dialog" },
				_react2.default.createElement(
					_reactBootstrap.Form,
					{ inline: true, onSubmit: this.onSubmit },
					_react2.default.createElement(
						_reactBootstrap.FormGroup,
						null,
						_react2.default.createElement(
							_reactBootstrap.ControlLabel,
							null,
							translations.Name,
							": "
						),
						" ",
						_react2.default.createElement(_reactBootstrap.FormControl, { type: "text", value: value, onChange: this.onInputChange, autoFocus: true, onFocus: this.onFocus, disabled: loading, ref: this.setInputRef }),
						" ",
						!existingPlaces.length ? getButton(this.onSaveNew, translations.Save + " " + translations.new) : null,
						" ",
						this.props.gathering.namedPlaceID ? getButton(this.onOverwriteCurrent, translations.SaveCurrentOverwrite) : null,
						existingPlaces.length === 1 && !this.props.gathering.namedPlaceID ? getButton(this.onOverwriteExisting, translations.SaveExistingOverwrite) : null
					),
					loading ? _react2.default.createElement(
						"div",
						{ className: "pull-right" },
						_react2.default.createElement(_reactSpinner2.default, null)
					) : null
				),
				!this.props.gathering.namedPlaceID && existingPlaces.length ? _react2.default.createElement(
					_reactBootstrap.Alert,
					{ bsStyle: "warning" },
					translations.Warning + ": " + translations.UsedNamedPlaceName + "." + (existingPlaces.length > 1 ? " " + translations.UsedNamedPlaceNameMultiple + "." : "")
				) : null,
				existingPlaces.length > 1 ? _react2.default.createElement(
					_reactBootstrap.FormGroup,
					null,
					_react2.default.createElement(
						_reactBootstrap.Panel,
						{ header: translations.ClickPlaceToOverwrite },
						_react2.default.createElement(
							_reactBootstrap.ListGroup,
							{ fill: "fill" },
							existingPlaces.map(function (place) {
								return _react2.default.createElement(
									_reactBootstrap.ListGroupItem,
									{ header: place.name, key: place.id, onClick: loading ? undefined : _this6.onOverwriteSelected(place), disabled: loading },
									place.notes
								);
							})
						)
					)
				) : null
			);
		}
	}]);
	return PlaceSaverDialog;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this7 = this;

	this.onInputChange = function (_ref2) {
		var value = _ref2.target.value;

		_this7.setState({ value: value });
	};

	this.getGathering = function () {
		return ["geometry", "country", "administrativeProvince", "biologicalProvince", "municipality", "locality", "localityDescription", "habitat", "habitatDescription", "coordinateRadius"].reduce(function (gathering, key) {
			gathering[key] = _this7.props.gathering[key];
			return gathering;
		}, {});
	};

	this.onSaveNew = function (e) {
		e.preventDefault();

		var _getGathering = _this7.getGathering(),
		    namedPlaceID = _getGathering.namedPlaceID,
		    gathering = (0, _objectWithoutProperties3.default)(_getGathering, ["namedPlaceID"]); //eslint-disable-line no-unused-vars


		_this7.onSave({
			name: _this7.state.value,
			prepopulatedDocument: { gatherings: [gathering] }
		});
	};

	this.onOverwriteCurrent = function () {
		var namedPlaceID = _this7.props.gathering.namedPlaceID;

		var gathering = _this7.getGathering(); //eslint-disable-line no-unused-vars
		_this7.onSave((0, _extends3.default)({}, _this7.state.placeIdsToPlaces[namedPlaceID], {
			name: _this7.state.value,
			prepopulatedDocument: { gatherings: [gathering] }
		}));
	};

	this.onOverwriteSelected = function (place) {
		return function () {
			var gathering = _this7.getGathering(); //eslint-disable-line no-unused-vars
			_this7.onSave((0, _extends3.default)({}, place, {
				name: _this7.state.value,
				prepopulatedDocument: { gatherings: [gathering] }
			}));
		};
	};

	this.onOverwriteExisting = function () {
		_this7.onOverwriteSelected(_this7.state.placeNamesToPlaces[_this7.state.value])();
	};

	this.onFocus = function (e) {
		var val = e.target.value;
		e.target.value = "";
		e.target.value = val;
	};

	this.onSubmit = function (e) {
		e.preventDefault();
	};

	this.setInputRef = function (elem) {
		_this7.inputRef = elem;
	};
};

new _Context2.default("SCHEMA_FIELD_WRAPPERS").NamedPlaceSaverField = true;