"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var specialRules = {
	legEditors: {
		filterProperties: function filterProperties(_ref) {
			var properties = _ref.properties,
			    formData = _ref.formData,
			    uiSchemaContext = _ref.uiSchemaContext;

			if (!uiSchemaContext) return properties;
			var creator = uiSchemaContext.creator;


			return !formData || formData.some(function (item) {
				return item && item.leg && item.leg.match(/MA\.\d+/) && item.leg !== creator;
			}) ? properties : properties.filter(function (field) {
				return field !== "editors";
			});
		}
	}
};

var specialRulesPropTypes = _propTypes2.default.oneOf(["legEditors"]);

var TableField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(TableField, _Component);

	function TableField() {
		(0, _classCallCheck3.default)(this, TableField);
		return (0, _possibleConstructorReturn3.default)(this, (TableField.__proto__ || (0, _getPrototypeOf2.default)(TableField)).apply(this, arguments));
	}

	(0, _createClass3.default)(TableField, [{
		key: "render",
		value: function render() {
			var _props = this.props,
			    schema = _props.schema,
			    _props$uiSchema = _props.uiSchema,
			    uiSchema = _props$uiSchema === undefined ? {} : _props$uiSchema,
			    formData = _props.formData,
			    ArrayField = _props.registry.fields.ArrayField,
			    formContext = _props.formContext;
			var uiSchemaContext = formContext.uiSchemaContext;


			var schemaProps = schema.additionalItems ? schema.additionalItems.properties : schema.items.properties;
			var options = (0, _utils.getUiOptions)(uiSchema);

			var schemaPropsArray = (0, _keys2.default)(schemaProps);
			var optionsSpecialRules = options.specialRules;
			if (optionsSpecialRules) {
				(Array.isArray(optionsSpecialRules) ? optionsSpecialRules : [optionsSpecialRules]).forEach(function (specialRule) {
					schemaPropsArray = specialRules[specialRule].filterProperties({
						properties: schemaPropsArray, uiSchema: uiSchema, uiSchemaContext: uiSchemaContext, formData: formData
					});
				});
			}

			var schemaLength = schemaPropsArray.filter(function (col) {
				return !(0, _utils.isHidden)(uiSchema.items, col);
			}).length;
			var defaultCol = parseInt(12 / schemaLength);
			var defaultWrapperCol = parseInt(12 / (1 + ((0, _keys2.default)(schemaProps).filter(function (col) {
				return !(0, _utils.isHidden)(uiSchema.items, col);
			}).length - schemaLength)));

			var cols = { xs: undefined, sm: undefined, md: undefined, lg: undefined };
			var wrapperCols = (0, _assign2.default)({}, cols);
			(0, _keys2.default)(cols).forEach(function (col) {
				cols[col] = options[col] ? Math.min(options[col], defaultCol) : defaultCol;
				wrapperCols[col] = options[col] ? Math.min(options[col], defaultWrapperCol) : defaultWrapperCol;
			});

			var itemsSchema = schemaPropsArray.reduce(function (constructedSchema, prop) {
				constructedSchema.properties[prop] = schema.items.properties[prop];
				return constructedSchema;
			}, (0, _extends3.default)({}, schema.items, { properties: {} }));

			var itemsUiSchema = {
				"ui:field": "GridLayoutField",
				"ui:options": (0, _extends3.default)({}, cols, { label: false })
			};

			var _uiSchema = uiSchema;

			if (uiSchema.items) {
				if (uiSchema.items.uiSchema) {
					_uiSchema = (0, _extends3.default)({}, _uiSchema, {
						items: (0, _utils.updateTailUiSchema)(uiSchema.items, { $merge: { uiSchema: itemsUiSchema } })
					});
				} else if (uiSchema.items["ui:field"] || uiSchema.items["ui:functions"]) {
					_uiSchema = (0, _extends3.default)({}, _uiSchema, {
						items: (0, _extends3.default)({}, _uiSchema.items, {
							uiSchema: itemsUiSchema
						})
					});
				} else {
					_uiSchema = (0, _extends3.default)({}, _uiSchema, { items: (0, _extends3.default)({}, uiSchema.items || {}, itemsUiSchema, { "ui:options": (0, _extends3.default)({}, (0, _utils.getUiOptions)(uiSchema.items), (0, _utils.getUiOptions)(itemsUiSchema)) }) });
				}
			}

			var _formContext = (0, _extends3.default)({}, formContext, {
				cols: cols,
				wrapperCols: wrapperCols,
				schemaPropsArray: schemaPropsArray
			});
			return _react2.default.createElement(ArrayField, (0, _extends3.default)({}, this.props, {
				schema: (0, _extends3.default)({}, schema, {
					items: itemsSchema
				}),
				uiSchema: _uiSchema,
				registry: (0, _extends3.default)({}, this.props.registry, {
					ArrayFieldTemplate: TableArrayFieldTemplate,
					formContext: _formContext
				}),
				formContext: _formContext
			}));
		}
	}]);
	return TableField;
}(_react.Component)) || _class;

TableField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			specialRules: _propTypes2.default.oneOfType([specialRulesPropTypes, _propTypes2.default.arrayOf(specialRulesPropTypes)])
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"]),
		items: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array])
	}).isRequired
};
exports.default = TableField;

var TableArrayFieldTemplate = (0, _ArrayFieldTemplate.handlesArrayKeys)(_class2 = function (_Component2) {
	(0, _inherits3.default)(TableArrayFieldTemplate, _Component2);

	function TableArrayFieldTemplate() {
		(0, _classCallCheck3.default)(this, TableArrayFieldTemplate);
		return (0, _possibleConstructorReturn3.default)(this, (TableArrayFieldTemplate.__proto__ || (0, _getPrototypeOf2.default)(TableArrayFieldTemplate)).apply(this, arguments));
	}

	(0, _createClass3.default)(TableArrayFieldTemplate, [{
		key: "render",
		value: function render() {
			var _this3 = this;

			var props = this.props;
			var schema = props.schema,
			    uiSchema = props.uiSchema,
			    _props$formContext = props.formContext,
			    cols = _props$formContext.cols,
			    wrapperCols = _props$formContext.wrapperCols,
			    schemaPropsArray = _props$formContext.schemaPropsArray,
			    idSchema = props.idSchema,
			    readonly = props.readonly,
			    disabled = props.disabled;

			var schemaProps = schema.additionalItems ? schema.additionalItems.properties : schema.items.properties;
			var Label = this.props.formContext.Label;

			var labels = schemaPropsArray.filter(function (col) {
				return !(0, _utils.isHidden)(uiSchema.items, col);
			}).map(function (propName) {
				var propUiSchema = uiSchema && uiSchema.items && uiSchema.items[propName] || {};
				return _react2.default.createElement(
					_reactBootstrap.Col,
					(0, _extends3.default)({}, cols, { key: propName + "-label" }),
					_react2.default.createElement(Label, {
						label: schemaProps[propName].hasOwnProperty("title") ? schemaProps[propName].title : propName,
						disabled: false,
						id: idSchema[propName].$id,
						required: schema.items.required && schema.items.required.indexOf(propName) > -1 || propUiSchema["ui:required"],
						help: propUiSchema["ui:help"],
						helpPlacement: propUiSchema["ui:helpPlacement"] })
				);
			});

			var options = (0, _utils.getUiOptions)(props.uiSchema);
			var confirmDelete = options.confirmDelete,
			    deleteCorner = options.deleteCorner,
			    _options$removable = options.removable,
			    removable = _options$removable === undefined ? true : _options$removable,
			    _options$nonRemovable = options.nonRemovables,
			    nonRemovables = _options$nonRemovable === undefined ? [] : _options$nonRemovable,
			    buttons = options.buttons,
			    deleteHelp = options["ui:deleteHelp"];

			if (!this.deleteButtonRefs) this.deleteButtonRefs = [];

			var getRefFor = function getRefFor(i) {
				return function (elem) {
					_this3.deleteButtonRefs[i] = elem;
				};
			};

			return _react2.default.createElement(
				"div",
				{ className: "table-field" },
				_react2.default.createElement(
					_reactBootstrap.Row,
					null,
					_react2.default.createElement(
						"div",
						{ className: "laji-form-field-template-item" },
						_react2.default.createElement(
							"div",
							{ className: "laji-form-field-template-schema" },
							labels
						),
						_react2.default.createElement("div", { className: "laji-form-field-template-buttons" })
					)
				),
				props.items.map(function (item, i) {
					var deleteButton = _react2.default.createElement(_components.DeleteButton, { ref: getRefFor(i),
						disabled: readonly || disabled,
						onClick: (0, _ArrayFieldTemplate.onDelete)(item, props),
						confirm: confirmDelete,
						corner: deleteCorner,
						tooltip: deleteHelp,
						translations: props.formContext.translations });
					return _react2.default.createElement(
						_reactBootstrap.Row,
						{ key: item.index },
						_react2.default.createElement(
							_reactBootstrap.Col,
							wrapperCols,
							_react2.default.createElement(
								"div",
								{ key: item.index, className: "laji-form-field-template-item keep-vertical" },
								_react2.default.createElement(
									"div",
									{ className: "laji-form-field-template-schema" },
									item.children
								),
								item.hasRemove && !(nonRemovables.indexOf(item.index) !== -1) && removable && deleteButton
							)
						)
					);
				}),
				(0, _ArrayFieldTemplate.getButtonElems)(buttons, props)
			);
		}
	}]);
	return TableArrayFieldTemplate;
}(_react.Component)) || _class2;