"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.TagInputComponent = exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TagArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(TagArrayField, _Component);

	function TagArrayField() {
		(0, _classCallCheck3.default)(this, TagArrayField);
		return (0, _possibleConstructorReturn3.default)(this, (TagArrayField.__proto__ || (0, _getPrototypeOf2.default)(TagArrayField)).apply(this, arguments));
	}

	(0, _createClass3.default)(TagArrayField, [{
		key: "render",
		value: function render() {
			var Label = this.props.formContext.Label;

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(Label, { label: this.props.schema.title, id: this.props.idSchema.$id }),
				_react2.default.createElement(TagInputComponent, (0, _extends3.default)({}, this.props, { id: this.props.idSchema.$id, tags: this.props.formData }))
			);
		}
	}]);
	return TagArrayField;
}(_react.Component)) || _class;

TagArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			separatorKeys: _propTypes2.default.arrayOf(_propTypes2.default.string)
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array
};
exports.default = TagArrayField;

var TagInputComponent = exports.TagInputComponent = function (_Component2) {
	(0, _inherits3.default)(TagInputComponent, _Component2);

	function TagInputComponent(props) {
		(0, _classCallCheck3.default)(this, TagInputComponent);

		var _this2 = (0, _possibleConstructorReturn3.default)(this, (TagInputComponent.__proto__ || (0, _getPrototypeOf2.default)(TagInputComponent)).call(this, props));

		_this2.getStateFromProps = function (_ref) {
			var value = _ref.value;

			return { value: value };
		};

		_this2.onKeyDown = function (e) {
			var value = _this2.state.value;
			var _this2$props$tags = _this2.props.tags,
			    tags = _this2$props$tags === undefined ? [] : _this2$props$tags;

			var _getUiOptions = (0, _utils.getUiOptions)(_this2.props.uiSchema),
			    _getUiOptions$separat = _getUiOptions.separatorKeys,
			    separatorKeys = _getUiOptions$separat === undefined ? ["Enter"] : _getUiOptions$separat;

			if (separatorKeys.indexOf(e.key) !== -1 && !(0, _utils.isEmptyString)(value)) {
				_this2.props.onChange([].concat((0, _toConsumableArray3.default)(tags), [value]), "enter");
				e.stopPropagation();
				e.preventDefault();
			} else if (e.key === "Backspace" && (0, _utils.isEmptyString)(value) && tags.length) {
				_this2.onRemove(tags.length - 1)();
			}
			(0, _utils.triggerParentComponent)("onKeyDown", e, _this2.props);
		};

		_this2.onRemove = function (idx) {
			return function () {
				var tags = [].concat((0, _toConsumableArray3.default)(_this2.props.tags || []));
				tags.splice(idx, 1);
				_this2.props.onChange(tags, "remove");
			};
		};

		_this2.onFocus = function (e) {
			_this2.setState({ focused: true }, function () {
				(0, _utils.triggerParentComponent)("onFocus", e, _this2.props);
			});
		};

		_this2.onBlur = function (e) {
			_this2.setState({ focused: false });
			(0, _utils.triggerParentComponent)("onBlur", e, _this2.props);
			if (!(0, _utils.isEmptyString)(_this2.state.value)) {
				_this2.props.onChange([].concat((0, _toConsumableArray3.default)(_this2.props.tags || []), [_this2.state.value]), "blur");
			}
		};

		_this2.setInputRef = function (ref) {
			_this2.inputRef = ref;
		};

		_this2.onClick = function () {
			(0, _reactDom.findDOMNode)(_this2.inputRef).focus();
		};

		_this2.onInputChange = function (e) {
			var onInputChange = _this2.props.onInputChange;

			onInputChange && e.persist();
			var value = e.target.value;

			var _getUiOptions2 = (0, _utils.getUiOptions)(_this2.props.uiSchema),
			    _getUiOptions2$separa = _getUiOptions2.separatorKeys,
			    separatorKeys = _getUiOptions2$separa === undefined ? [] : _getUiOptions2$separa;

			var splitted = separatorKeys.reduce(function (splitted, separator) {
				return splitted.reduce(function (splitted, i) {
					return i.split(separator);
				}, splitted);
			}, [value]);
			_this2.setState({ value: value }, function () {
				onInputChange && _this2.props.onInputChange(e);
				if (splitted.length > 1) {
					_this2.props.onChange([].concat((0, _toConsumableArray3.default)(_this2.props.tags || []), (0, _toConsumableArray3.default)(splitted)));
				}
			});
		};

		_this2.state = _this2.getStateFromProps(props);
		return _this2;
	}

	(0, _createClass3.default)(TagInputComponent, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "componentDidUpdate",
		value: function componentDidUpdate(prevProps) {
			if (!(0, _deepEqual2.default)(prevProps.formData, this.props.formData)) {
				new _Context2.default(this.props.formContext.contextId).sendCustomEvent(this.props.idSchema.$id, "resize");
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    _props$tags = _props.tags,
			    tags = _props$tags === undefined ? [] : _props$tags,
			    InputComponent = _props.InputComponent,
			    readonly = _props.readonly,
			    disabled = _props.disabled;

			tags = tags.filter(function (s) {
				return !(0, _utils.isEmptyString)(s);
			});
			var _state$value = this.state.value,
			    value = _state$value === undefined ? "" : _state$value;


			var inputProps = (0, _extends3.default)({
				type: "text",
				className: "rw-input",
				ref: this.setInputRef,
				value: value,
				onChange: this.onInputChange,
				id: this.props.id
			}, this.props.inputProps, {
				onFocus: this.onFocus,
				onBlur: this.onBlur,
				onKeyDown: this.onKeyDown
			});

			return _react2.default.createElement(
				"div",
				{ className: "rw-multiselect rw-widget" + (this.state.focused ? " rw-state-focus" : "") + (readonly || disabled ? " rw-state-disabled" : ""),
					onClick: this.onClick },
				_react2.default.createElement(
					"div",
					{ className: "rw-multiselect-wrapper" },
					_react2.default.createElement(
						"ul",
						{ className: "rw-multiselect-taglist" },
						tags.map(function (item, idx) {
							return _react2.default.createElement(
								"li",
								{ key: idx },
								item,
								_react2.default.createElement(
									"span",
									{ className: "rw-tag-btn", onClick: _this3.onRemove(idx) },
									"\xD7"
								)
							);
						})
					),
					InputComponent ? _react2.default.createElement(InputComponent, inputProps) : _react2.default.createElement("input", (0, _extends3.default)({}, inputProps, { disabled: disabled || readonly }))
				)
			);
		}
	}]);
	return TagInputComponent;
}(_react.Component);