"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _components = require("../components");

var _reactBootstrap = require("react-bootstrap");

var _utils = require("../../utils");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TitleField = function TitleField(_ref) {
	var title = _ref.title,
	    className = _ref.className,
	    buttons = _ref.buttons,
	    help = _ref.help,
	    id = _ref.id,
	    formData = _ref.formData,
	    _ref$titleFormatters = _ref.titleFormatters,
	    titleFormatters = _ref$titleFormatters === undefined ? [] : _ref$titleFormatters,
	    style = _ref.style;

	var renderedFormatters = titleFormatters.map(function (titleFormatter) {
		var renderer = titleFormatter.renderer;

		return _titleFormatters[renderer]((0, _extends3.default)({}, titleFormatter, { formData: formData }));
	}).filter(function (i) {
		return i;
	});

	if (renderedFormatters.length === 0 && (0, _utils.isEmptyString)(title)) return null;

	var helpComponent = help ? _react2.default.createElement(_components.Help, null) : null;

	var titleContent = _react2.default.createElement(
		"span",
		null,
		_react2.default.createElement(
			"span",
			null,
			renderedFormatters
		),
		" ",
		_react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: title } }),
		" ",
		helpComponent,
		" ",
		buttons
	);

	var Legend = function Legend(_ref2) {
		var children = _ref2.children,
		    props = (0, _objectWithoutProperties3.default)(_ref2, ["children"]);
		return _react2.default.createElement(
			"legend",
			(0, _extends3.default)({ className: className, style: style }, props),
			children
		);
	};

	if (!help) return _react2.default.createElement(
		Legend,
		null,
		titleContent
	);

	var tooltipElem = _react2.default.createElement(
		_reactBootstrap.Tooltip,
		{ id: id + "-tooltip" },
		_react2.default.createElement(
			"span",
			null,
			_react2.default.createElement("strong", { dangerouslySetInnerHTML: { __html: title } }),
			_react2.default.createElement("br", null),
			_react2.default.createElement("span", { dangerouslySetInnerHTML: { __html: help } })
		)
	);

	return _react2.default.createElement(
		Legend,
		null,
		_react2.default.createElement(
			_reactBootstrap.OverlayTrigger,
			{ placement: "right", overlay: tooltipElem },
			titleContent
		)
	);
};

exports.default = TitleField;


var _titleFormatters = {
	informalTaxonGroup: function informalTaxonGroup(_ref3) {
		var formData = _ref3.formData,
		    value = _ref3.value,
		    renderer = _ref3.renderer;

		var informalTaxonGroup = (0, _utils.parseJSONPointer)(formData, value, !!"safely");

		var _ref4 = new _Context2.default(),
		    _ref4$informalTaxonGr = _ref4.informalTaxonGroupsById,
		    informalTaxonGroupsById = _ref4$informalTaxonGr === undefined ? {} : _ref4$informalTaxonGr;

		var name = informalTaxonGroupsById[informalTaxonGroup] ? informalTaxonGroupsById[informalTaxonGroup].name : "";
		return informalTaxonGroup ? _react2.default.createElement(
			"span",
			{ key: renderer },
			_react2.default.createElement("div", { className: "informal-group-image " + informalTaxonGroup }),
			" ",
			name
		) : undefined;
	}
};