"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ToggleAdditionalArrayFieldsField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(ToggleAdditionalArrayFieldsField, _Component);

	function ToggleAdditionalArrayFieldsField(props) {
		(0, _classCallCheck3.default)(this, ToggleAdditionalArrayFieldsField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (ToggleAdditionalArrayFieldsField.__proto__ || (0, _getPrototypeOf2.default)(ToggleAdditionalArrayFieldsField)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = (0, _extends3.default)({ visible: _this.getInitialVisible(props) }, _this.getStateFromProps(props));
		return _this;
	}

	(0, _createClass3.default)(ToggleAdditionalArrayFieldsField, [{
		key: "getInitialVisible",
		value: function getInitialVisible(props) {
			var _getUiOptions = (0, _utils.getUiOptions)(props.uiSchema),
			    additionalFields = _getUiOptions.additionalFields;

			var context = new _Context2.default(props.formContext.contextId);
			var visible = context[this.getTogglePersistenceContextKey(props)] || false;

			if (!visible) {
				var _iteratorNormalCompletion = true;
				var _didIteratorError = false;
				var _iteratorError = undefined;

				try {
					for (var _iterator = (0, _getIterator3.default)(props.formData), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
						var data = _step.value;
						var _iteratorNormalCompletion2 = true;
						var _didIteratorError2 = false;
						var _iteratorError2 = undefined;

						try {
							for (var _iterator2 = (0, _getIterator3.default)(additionalFields), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
								var field = _step2.value;

								if (!(0, _utils.isDefaultData)((0, _utils.parseJSONPointer)(data, field), (0, _utils.parseSchemaFromFormDataPointer)(props.schema, field))) {
									visible = true;
									break;
								}
							}
						} catch (err) {
							_didIteratorError2 = true;
							_iteratorError2 = err;
						} finally {
							try {
								if (!_iteratorNormalCompletion2 && _iterator2.return) {
									_iterator2.return();
								}
							} finally {
								if (_didIteratorError2) {
									throw _iteratorError2;
								}
							}
						}
					}
				} catch (err) {
					_didIteratorError = true;
					_iteratorError = err;
				} finally {
					try {
						if (!_iteratorNormalCompletion && _iterator.return) {
							_iterator.return();
						}
					} finally {
						if (_didIteratorError) {
							throw _iteratorError;
						}
					}
				}
			}

			return visible;
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var innerUiSchema = (0, _utils.getInnerUiSchema)(props.uiSchema);
			return { uiSchema: innerUiSchema };
		}
	}, {
		key: "render",
		value: function render() {
			var CheckboxWidget = this.props.registry.widgets.CheckboxWidget;
			var SchemaField = this.props.registry.fields.SchemaField;


			var shouldShow = this.state.visible;

			var _getUiOptions2 = (0, _utils.getUiOptions)(this.props.uiSchema),
			    additionalFields = _getUiOptions2.additionalFields,
			    toggleLabel = _getUiOptions2.toggleLabel,
			    toggleClassName = _getUiOptions2.toggleClassName,
			    toggleHelp = _getUiOptions2.toggleHelp;

			var _uiSchema = this.state.uiSchema;

			if (!shouldShow) {
				(additionalFields || []).forEach(function (field) {
					_uiSchema = (0, _utils.updateSafelyWithJSONPointer)(_uiSchema, { "ui:field": "HiddenField" }, "items/" + field);
				});
			}

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: _uiSchema })),
				_react2.default.createElement(
					"div",
					{ className: toggleClassName },
					_react2.default.createElement(CheckboxWidget, (0, _extends3.default)({}, this.props, {
						id: this.props.idSchema.$id + "_toggle",
						schema: { type: "boolean" },
						value: shouldShow,
						onChange: this.toggleVisibility,
						label: toggleLabel || "",
						options: { allowUndefined: false, help: toggleHelp },
						required: false
					}))
				)
			);
		}
	}]);
	return ToggleAdditionalArrayFieldsField;
}(_react.Component)) || _class;

ToggleAdditionalArrayFieldsField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			additionalFields: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
			toggleLabel: _propTypes2.default.string,
			toggleClassName: _propTypes2.default.string,
			toggleHelp: _propTypes2.default.string
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.oneOfType([_propTypes2.default.array]).isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getTogglePersistenceContextKey = function (props) {
		return "$additional_toggle_persistence_" + props.idSchema.$id;
	};

	this.toggleVisibility = function () {
		var visible = !_this2.state.visible;
		var context = new _Context2.default(_this2.props.formContext.contextId);
		context[_this2.getTogglePersistenceContextKey(_this2.props)] = visible;
		_this2.setState({ visible: visible });
	};
};

exports.default = ToggleAdditionalArrayFieldsField;