"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _utils2 = require("../../utils");

var _VirtualSchemaField = require("../VirtualSchemaField");

var _VirtualSchemaField2 = _interopRequireDefault(_VirtualSchemaField);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var UiFieldMapperArrayField = (0, _VirtualSchemaField2.default)(_class = function (_Component) {
	(0, _inherits3.default)(UiFieldMapperArrayField, _Component);
	(0, _createClass3.default)(UiFieldMapperArrayField, null, [{
		key: "getName",
		value: function getName() {
			return "UiFieldMapperArrayField";
		}
	}]);

	function UiFieldMapperArrayField(props) {
		(0, _classCallCheck3.default)(this, UiFieldMapperArrayField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (UiFieldMapperArrayField.__proto__ || (0, _getPrototypeOf2.default)(UiFieldMapperArrayField)).call(this, props));

		_initialiseProps.call(_this);

		_this.childProps = [];
		_this.functionOutputProps = [];
		_this.updateChildProps(props);
		return _this;
	}

	(0, _createClass3.default)(UiFieldMapperArrayField, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.updateChildProps(props);
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props, origProps) {
			var _this2 = this;

			var templateOutput = this.functionOutputProps && this.functionOutputProps.length ? this.functionOutputProps[0] : this.getFunctionOutputForIdx(origProps, undefined);

			var addBaseErrors = function addBaseErrors(errorSchema) {
				return (props.errorSchema || {}).__errors ? (0, _extends3.default)({}, errorSchema, { __errors: props.errorSchema.__errors }) : errorSchema;
			};

			var schema = (0, _extends3.default)({}, props.schema, { items: templateOutput.schema });
			var state = (0, _extends3.default)({}, props, {
				schema: schema,
				uiSchema: (0, _extends3.default)({}, props.uiSchema, { items: (0, _extends3.default)({}, props.uiSchema.items, templateOutput.uiSchema) }),
				formData: (props.formData || []).map(function (item, idx) {
					return _this2.functionOutputProps[idx].formData;
				}),
				idSchema: templateOutput.idSchema,
				errorSchema: addBaseErrors((0, _keys2.default)(props.errorSchema || {}).reduce(function (errorSchema, idx) {
					if (!_this2.functionOutputProps[idx]) return errorSchema;
					errorSchema[idx] = _this2.functionOutputProps[idx].errorSchema;
					return errorSchema;
				}, {})),
				formContext: templateOutput.formContext
			});

			return state;
		}
	}, {
		key: "onChange",
		value: function onChange(formData) {
			var _this3 = this;

			this.props.onChange(formData.map(function (item, idx) {
				if (!(0, _utils.deepEquals)(item, (_this3.props.formData || [])[idx])) {
					var output = _this3.functionOutputProps[idx] || _this3.getFunctionOutputForIdx(_this3.props, idx);
					output.onChange(item); // Will trigger child instance onChange, which will set this.tmpItemFormData.
					return _this3.tmpItemFormData;
				}
				return item;
			}));
		}
	}]);
	return UiFieldMapperArrayField;
}(_react.Component)) || _class;

UiFieldMapperArrayField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			functions: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.shape({
				"ui:field": _propTypes2.default.string.isRequired,
				"ui:options": _propTypes2.default.object
			})), _propTypes2.default.shape({
				"ui:field": _propTypes2.default.string.isRequired,
				"ui:options": _propTypes2.default.object
			})])
		}),
		uiSchema: _propTypes2.default.object
	}).isRequired,
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this4 = this;

	this.updateChildProps = function (props) {
		(props.formData || []).forEach(function (item, idx) {
			var currentFieldProps = _this4.childProps[idx];
			var nextFieldProps = _this4.getFieldPropsForIdx(props, idx);
			if (!(0, _utils.deepEquals)([currentFieldProps, nextFieldProps])) {
				_this4.functionOutputProps[idx] = _this4.applyFunctionsToChildProps(props, nextFieldProps);
				_this4.childProps[idx] = nextFieldProps;
			}
		});
	};

	this.getFieldPropsForIdx = function (props, idx) {
		return (0, _extends3.default)({}, props, {
			schema: props.schema.items,
			uiSchema: (props.uiSchema.uiSchema || props.uiSchema).items,
			idSchema: props.idSchema,
			formData: (props.formData || [])[idx],
			errorSchema: (props.errorSchema || {})[idx] || {},
			onChange: function onChange(formData) {
				_this4.tmpItemFormData = formData;
			}
		});
	};

	this.applyFunctionsToChildProps = function (props, childProps) {
		var _getUiOptions = (0, _utils2.getUiOptions)(props.uiSchema),
		    functions = _getUiOptions.functions;

		return (Array.isArray(functions) ? functions : [functions]).reduce(function (_props, _ref) {
			var uiField = _ref["ui:field"],
			    uiOptions = _ref["ui:options"];

			var _ref2 = _props.uiSchema || {},
			    uiFunctions = _ref2["ui:functions"],
			    uiSchema = _ref2.uiSchema,
			    origUiField = _ref2["ui:field"],
			    origUiOptions = _ref2["ui:options"],
			    origUiSettings = _ref2["ui:settings"],
			    _propsUiSchema = (0, _objectWithoutProperties3.default)(_ref2, ["ui:functions", "uiSchema", "ui:field", "ui:options", "ui:settings"]);

			_props = (0, _extends3.default)({}, _props, {
				uiSchema: (0, _extends3.default)({}, _propsUiSchema, {
					"ui:field": uiField,
					"ui:options": uiOptions
				})
			});

			var _ref3 = new props.registry.fields[uiField](_props),
			    _ref3$state = _ref3.state,
			    state = _ref3$state === undefined ? {} : _ref3$state;

			return (0, _extends3.default)({}, _props, state, {
				uiSchema: (0, _extends3.default)({}, _props.uiSchema, state.uiSchema, {
					"ui:functions": uiFunctions,
					"ui:field": origUiField,
					"ui:options": origUiOptions,
					"ui:settings": origUiSettings,
					uiSchema: uiSchema
				})
			});
		}, childProps);
	};

	this.getFunctionOutputForIdx = function (props, idx) {
		return _this4.applyFunctionsToChildProps(props, _this4.getFieldPropsForIdx(props, idx));
	};
};

exports.default = UiFieldMapperArrayField;