"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _utils = require("react-jsonschema-form/lib/utils");

var _utils2 = require("../../utils");

var _components = require("../components");

var _reactBootstrap = require("react-bootstrap");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _TagArrayField = require("./TagArrayField");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Compatible only with unit array.
 */
var UnitListShorthandArrayField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(UnitListShorthandArrayField, _Component);

	function UnitListShorthandArrayField() {
		var _ref;

		var _temp, _this, _ret;

		(0, _classCallCheck3.default)(this, UnitListShorthandArrayField);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = UnitListShorthandArrayField.__proto__ || (0, _getPrototypeOf2.default)(UnitListShorthandArrayField)).call.apply(_ref, [this].concat(args))), _this), _this.onButtonClick = function () {
			return function () {
				_this.setState({ show: !_this.state.show });
			};
		}, _this.onHide = function () {
			_this.setState({ show: false, value: "" });
		}, _this.onTagFieldChange = function (tags) {
			_this.setState({ value: tags.join(",") });
		}, _this.onSubmit = function () {
			var value = _this.state.value + ((0, _utils2.isEmptyString)(_this.tagRef.state.value) ? "" : "," + _this.tagRef.state.value);

			_this.onHide();
			var _this$props$formConte = _this.props.formContext,
			    translations = _this$props$formConte.translations,
			    contextId = _this$props$formConte.contextId,
			    notifier = _this$props$formConte.notifier,
			    apiClient = _this$props$formConte.apiClient;

			var context = new _Context2.default(contextId);
			context.pushBlockingLoader();
			apiClient.fetch("/autocomplete/unit", { q: value, list: true, includePayload: true }).then(function (_ref2) {
				var _ref2$payload = _ref2.payload,
				    units = _ref2$payload.units,
				    nonMatchingCount = _ref2$payload.nonMatchingCount;

				units = units.map(function (unit) {
					unit = (0, _utils.getDefaultFormState)(_this.props.schema.items, unit, _this.props.registry.definitions);
					unit = (0, _utils2.bringRemoteFormData)(unit, _this.props.formContext);
					return unit;
				});
				var formData = _this.props.formData;
				var last = formData[formData.length - 1];
				if ((0, _utils2.isDefaultData)(last, _this.props.schema.items, _this.props.registry.definitions)) {
					formData.pop();
				}
				_this.props.onChange([].concat((0, _toConsumableArray3.default)(formData), (0, _toConsumableArray3.default)(units)));

				nonMatchingCount ? notifier.warning(translations.UnitListShorthandWarning + " " + nonMatchingCount) : notifier.success(translations.UnitListShorthandSuccess);
				context.popBlockingLoader();
			});
		}, _this.onKeyDown = function (e) {
			if (e.key === "Enter") {
				_this.onSubmit(e);
			}
		}, _this.setTagArrayRef = function (ref) {
			_this.tagRef = ref;
		}, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
	}

	(0, _createClass3.default)(UnitListShorthandArrayField, [{
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var buttonDefinition = {
				fn: this.onButtonClick,
				fnName: "addUnitList",
				glyph: "align-justify",
				label: this.props.formContext.translations.AddUnitList,
				id: this.props.idSchema.$id,
				changesFormData: true,
				rules: {
					canAdd: true
				}
			};

			var innerUiSchema = (0, _utils2.getInnerUiSchema)(props.uiSchema);
			var options = (0, _utils2.getUiOptions)(innerUiSchema);
			var uiSchema = (0, _extends3.default)({}, innerUiSchema, {
				"ui:options": (0, _extends3.default)({}, options, {
					buttons: [].concat((0, _toConsumableArray3.default)(options.buttons || []), [buttonDefinition])
				})
			});

			return { uiSchema: uiSchema };
		}
	}, {
		key: "render",
		value: function render() {
			var SchemaField = this.props.registry.fields.SchemaField;


			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				_react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: this.state.uiSchema })),
				this.state.show && _react2.default.createElement(
					_reactBootstrap.Modal,
					{ show: true, onHide: this.onHide },
					_react2.default.createElement(
						_reactBootstrap.Modal.Body,
						null,
						_react2.default.createElement(_TagArrayField.TagInputComponent, {
							tags: (0, _utils2.isEmptyString)(this.state.value) ? [] : this.state.value.split(",").filter(function (s) {
								return !(0, _utils2.isEmptyString)(s);
							}),
							onChange: this.onTagFieldChange,
							schema: {},
							idSchema: {},
							uiSchema: { "ui:options": { separatorKeys: [","] } },
							inputProps: { autoFocus: true },
							onKeyDown: this.onKeyDown,
							ref: this.setTagArrayRef
						}),
						_react2.default.createElement(
							"span",
							{ className: "text-muted" },
							_react2.default.createElement(
								"i",
								null,
								this.props.formContext.translations.UnitListShorthandHelp
							)
						),
						_react2.default.createElement("br", null),
						_react2.default.createElement(
							_components.Button,
							{ type: "submit", disabled: (0, _utils2.isEmptyString)(this.state.value), onClick: this.onSubmit },
							this.props.formContext.translations.Add
						)
					)
				)
			);
		}
	}]);
	return UnitListShorthandArrayField;
}(_react.Component)) || _class;

UnitListShorthandArrayField.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["array"])
	}).isRequired,
	formData: _propTypes2.default.array.isRequired
};
exports.default = UnitListShorthandArrayField;