"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty2 = require("babel-runtime/helpers/defineProperty");

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class, _class2;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("react-jsonschema-form/lib/utils");

var _utils2 = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _components = require("../components");

var _reactBootstrap = require("react-bootstrap");

var _AutosuggestWidget = require("../widgets/AutosuggestWidget");

var _ArrayFieldTemplate = require("../ArrayFieldTemplate");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LINE_TRANSECT_IDS = ["MHL.1", "MHL.27", "MHL.28"];

var UnitShorthandField = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(UnitShorthandField, _Component);

	function UnitShorthandField(props) {
		(0, _classCallCheck3.default)(this, UnitShorthandField);

		var _this = (0, _possibleConstructorReturn3.default)(this, (UnitShorthandField.__proto__ || (0, _getPrototypeOf2.default)(UnitShorthandField)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = { showSchema: (0, _utils2.getUiOptions)(props.uiSchema).showSchema };
		_this.state = (0, _extends3.default)({}, _this.state, _this.getStateFromProps(props));
		return _this;
	}

	(0, _createClass3.default)(UnitShorthandField, [{
		key: "componentDidUpdate",
		value: function componentDidUpdate() {
			if (this.onNextTick) {
				this.onNextTick();
				this.onNextTick = undefined;
			}
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    uiSchema = _props.uiSchema,
			    formContext = _props.formContext,
			    disabled = _props.disabled,
			    readonly = _props.readonly;
			var SchemaField = this.props.registry.fields.SchemaField;

			var shorthandFieldName = (0, _utils2.getUiOptions)(this.props.uiSchema).shorthandField;
			var toggleButton = this.getToggleButton();

			var tailUiSchema = (0, _utils2.getNestedTailUiSchema)(uiSchema);
			var help = tailUiSchema && tailUiSchema[shorthandFieldName] && tailUiSchema[shorthandFieldName]["ui:belowHelp"];
			var uiSchemaWithoutHelp = (0, _utils2.isEmptyString)(help) ? uiSchema : (0, _utils2.updateTailUiSchema)(uiSchema, (0, _defineProperty3.default)({}, shorthandFieldName, { "ui:belowHelp": { $set: undefined } }));

			var id = shorthandFieldName && this.props.idSchema[shorthandFieldName] ? this.props.idSchema[shorthandFieldName].$id : this.props.idSchema.$id + "_shortHandField";

			var innerUiSchema = undefined;
			if (this.state.showSchema) {
				innerUiSchema = (0, _utils2.getInnerUiSchema)((0, _extends3.default)({}, uiSchemaWithoutHelp));
				var innerOptions = (0, _utils2.getUiOptions)(innerUiSchema);
				innerUiSchema = (0, _extends3.default)({}, innerUiSchema, { "ui:options": (0, _extends3.default)({}, innerOptions, { buttons: [].concat((0, _toConsumableArray3.default)(innerOptions.buttons || []), [toggleButton]) }) });
			}

			return !this.state.showSchema ? _react2.default.createElement(
				"div",
				{ className: "laji-form-field-template-item", id: "_laji-form_" + id },
				_react2.default.createElement(CodeReader, { translations: this.props.formContext.translations,
					onChange: this.onCodeChange,
					value: this.props.formData[shorthandFieldName],
					formID: (0, _utils2.getUiOptions)(this.props.uiSchema).formID || formContext.formID || formContext.uiSchemaContext.formID,
					help: help,
					id: id,
					formContext: formContext,
					disabled: disabled,
					readonly: readonly,
					className: "laji-form-field-template-schema" }),
				_react2.default.createElement(
					"div",
					{ className: "laji-form-field-template-buttons" },
					(0, _ArrayFieldTemplate.getButton)(toggleButton)
				)
			) : _react2.default.createElement(SchemaField, (0, _extends3.default)({}, this.props, { uiSchema: innerUiSchema }));
		}
	}]);
	return UnitShorthandField;
}(_react.Component)) || _class;

UnitShorthandField.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			shorthandField: _propTypes2.default.string,
			formID: _propTypes2.default.string,
			showSchema: _propTypes2.default.bool,
			persistenceKey: _propTypes2.default.string
		}).isRequired,
		uiSchema: _propTypes2.default.object
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["object"])
	}).isRequired,
	formData: _propTypes2.default.object.isRequired
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getStateFromProps = function (props) {
		var _getUiOptions = (0, _utils2.getUiOptions)(props.uiSchema),
		    persistenceKey = _getUiOptions.persistenceKey;

		var showSchema = undefined;
		if (persistenceKey) {
			var persistingContainer = new _Context2.default(_this2.props.formContext.contextId + "_UNIT_SHORTHAND_FIELD_PERSISTENCE_" + persistenceKey);
			if (persistingContainer && "value" in persistingContainer) {
				showSchema = persistingContainer.value;
			} else {
				showSchema = _this2.shouldShowSchema(props);
			}
		} else {
			showSchema = _this2.shouldShowSchema(props);
		}

		return { showSchema: showSchema };
	};

	this.componentWillReceiveProps = function (props) {
		_this2.setState(_this2.getStateFromProps(props));
	};

	this.shouldShowSchema = function (props) {
		var showSchema = _this2.state.showSchema;


		if (_this2.state.showSchema === undefined && !(0, _utils2.formDataIsEmpty)(props)) {
			showSchema = true;
		}
		return showSchema;
	};

	this.onToggleButtonClick = function () {
		return function () {
			var _getUiOptions2 = (0, _utils2.getUiOptions)(_this2.props.uiSchema),
			    persistenceKey = _getUiOptions2.persistenceKey;

			_this2.setState({ showSchema: !_this2.state.showSchema }, function () {
				(0, _utils2.focusById)(_this2.props.formContext, _this2.props.idSchema.$id);
				new _Context2.default(_this2.props.formContext.contextId + "_UNIT_SHORTHAND_FIELD_PERSISTENCE_" + persistenceKey).value = _this2.state.showSchema;
			});
		};
	};

	this.getToggleButton = function () {
		return {
			glyph: "resize-small",
			fn: _this2.onToggleButtonClick,
			tooltip: _this2.props.formContext.translations[_this2.state.showSchema ? "OpenShorthand" : "CloseShorthand"],
			tooltipPlacement: "left",
			bsStyle: _this2.state.showSchema ? "default" : "primary"
		};
	};

	this.onCodeChange = function () {
		var formData = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var _getUiOptions3 = (0, _utils2.getUiOptions)(_this2.props.uiSchema),
		    autocopy = _getUiOptions3.autocopy,
		    autofocus = _getUiOptions3.autofocus;

		if (!autofocus) _this2.getContext().idToFocus = _this2.props.idSchema.$id;
		_this2.onNextTick = function () {
			if (autocopy) {
				new _Context2.default(_this2.props.formContext.contextId).sendCustomEvent(_this2.props.idSchema.$id, "copy");
			} else if (autofocus) {
				new _Context2.default(_this2.props.formContext.contextId).sendCustomEvent(_this2.props.idSchema.$id, "focus", "last");
			}
			_this2.setState({ showSchema: true });
		};
		_this2.props.onChange((0, _utils.getDefaultFormState)(_this2.props.schema, (0, _extends3.default)({}, _this2.props.formData, formData), _this2.props.registry.definitions));
	};
};

exports.default = UnitShorthandField;

var CodeReader = (0, _BaseComponent2.default)(_class2 = function (_Component2) {
	(0, _inherits3.default)(CodeReader, _Component2);

	function CodeReader(props) {
		(0, _classCallCheck3.default)(this, CodeReader);

		var _this3 = (0, _possibleConstructorReturn3.default)(this, (CodeReader.__proto__ || (0, _getPrototypeOf2.default)(CodeReader)).call(this, props));

		_initialiseProps2.call(_this3);

		_this3.state = { value: "" };
		_this3.state = _this3.getStateFromProps(props);
		_this3.apiClient = props.formContext.apiClient;
		return _this3;
	}

	(0, _createClass3.default)(CodeReader, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var _props2 = this.props,
			    translations = _props2.translations,
			    readonly = _props2.readonly,
			    disabled = _props2.disabled;


			var validationState = "default";
			if (this.state.failed === true) validationState = "warning";else if (!(0, _utils2.isEmptyString)(this.props.value) && this.props.value === this.state.value) validationState = "success";

			var _props3 = this.props,
			    formID = _props3.formID,
			    formContext = _props3.formContext;


			var inputElem = LINE_TRANSECT_IDS.indexOf(formID) !== -1 ? _react2.default.createElement(_components.FetcherInput, {
				id: this.props.id,
				loading: this.state.loading,
				value: this.state.value,
				validationState: validationState,
				onChange: this.onFetcherInputChange,
				onBlur: this.getCode,
				onKeyDown: this.onKeyDown,
				readonly: readonly,
				disabled: disabled
			}) : _react2.default.createElement(
				"div",
				{ className: "unit-shorthand" },
				_react2.default.createElement(_AutosuggestWidget.Autosuggest, {
					autosuggestField: "unit",
					query: {
						formID: formID,
						includeNonMatching: true
					},
					onSuggestionSelected: this.onSuggestionSelected,
					renderSuggestion: this.renderSuggestion,
					onChange: this.onAutosuggestChange,
					formContext: formContext,
					allowNonsuggestedValue: false
				})
			);

			return _react2.default.createElement(
				_reactBootstrap.FormGroup,
				{ validationState: this.state.failed ? "error" : undefined },
				inputElem,
				this.state.failed ? _react2.default.createElement(
					_reactBootstrap.HelpBlock,
					null,
					translations.InvalidUnitCode
				) : null,
				_react2.default.createElement("div", { className: "small text-muted", dangerouslySetInnerHTML: { __html: this.props.help } })
			);
		}
	}]);
	return CodeReader;
}(_react.Component)) || _class2;

var _initialiseProps2 = function _initialiseProps2() {
	var _this4 = this;

	this.getStateFromProps = function (props) {
		var state = _this4.state;
		if (_this4.state.value === "" && !(0, _utils2.isEmptyString)(props.value)) {
			state.value = props.value;
		}
		return state;
	};

	this.onKeyDown = function (e) {
		if (e.key === "Enter") {
			_this4.getCode();
		}
	};

	this.onFetcherInputChange = function (_ref) {
		var value = _ref.target.value;

		if (_this4.mounted) _this4.setState({ value: value });
	};

	this.onAutosuggestChange = function (formData) {
		_this4.props.onChange(formData);
	};

	this.onSuggestionSelected = function (_ref2) {
		var unit = _ref2.payload.unit;
		var formContext = _this4.props.formContext;

		unit = (0, _utils2.bringRemoteFormData)(unit, formContext);
		_this4.props.onChange(unit);
	};

	this.renderSuggestion = function (suggestion) {
		var translations = _this4.props.translations;

		return suggestion.payload.isNonMatching ? _react2.default.createElement(
			"span",
			{ className: "text-muted" },
			suggestion.value,
			" ",
			_react2.default.createElement(
				"i",
				null,
				"(",
				translations.unknownSpeciesName,
				")"
			)
		) : suggestion.value;
	};

	this.getCode = function () {
		var value = _this4.state.value;

		if (!(0, _utils2.isEmptyString)(_this4.props.value) && (0, _utils2.isEmptyString)(value) && (!_this4.value || _this4.value.length < 3)) {
			_this4.mounted && _this4.setState({ loading: true });
			_this4.mounted && _this4.setState({ failed: false, loading: false }, function () {
				(0, _utils2.isEmptyString)(_this4.value) && _this4.props.onChange(undefined);
			});
		} else if (value.length >= 3) {
			_this4.mounted && _this4.setState({ loading: true });

			_this4.apiClient.fetchCached("/autocomplete/unit", { q: value, formID: _this4.props.formID, includePayload: true }).then(function (response) {
				_this4.props.onChange(response.payload.unit);
			}).catch(function () {
				_this4.mounted && _this4.setState({ failed: true, loading: false });
			});
		}
	};
};