"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.anyToBoolean = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var anyToBoolean = exports.anyToBoolean = function anyToBoolean(widget) {
	return function (props) {
		var options = (0, _utils.getUiOptions)(widget ? props : props.uiSchema);
		var trueValue = options.trueValue,
		    falseValue = options.falseValue,
		    _options$allowUndefin = options.allowUndefined,
		    allowUndefined = _options$allowUndefin === undefined ? true : _options$allowUndefin;

		var schema = (0, _extends3.default)({}, props.schema, { type: "boolean", title: allowUndefined ? "" : props.schema.title });
		var id = widget ? props.id : props.idSchema.$id;
		var value = (0, _utils.formDataEquals)(props[widget ? "value" : "formData"], trueValue, props.formContext, id) ? true : (0, _utils.formDataEquals)(props[widget ? "value" : "formData"], falseValue, props.formContext, id) ? false : undefined;

		var onChange = function onChange(value) {
			var newValue = value === undefined ? undefined : value === true ? trueValue : falseValue;
			props.onChange(newValue);
		};

		var CheckboxWidget = props.registry.widgets.CheckboxWidget;
		var SchemaField = props.registry.fields.SchemaField;


		return widget ? _react2.default.createElement(CheckboxWidget, (0, _extends3.default)({}, props, {
			id: props.id,
			schema: schema,
			value: value,
			onChange: onChange,
			label: "",
			options: options
		})) : _react2.default.createElement(SchemaField, (0, _extends3.default)({}, props, {
			schema: schema,
			uiSchema: (0, _utils.getInnerUiSchema)(props.uiSchema),
			formData: value,
			onChange: onChange,
			label: "",
			options: options
		}));
	};
};

var _anyToBoolean = anyToBoolean(!!"widget");
var valuePropType = _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]);
_anyToBoolean.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			trueValue: valuePropType.isRequired,
			falseValue: valuePropType.isRequired,
			allowUndefined: _propTypes2.default.bool
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string", "number", "boolean"])
	}).isRequired,
	formData: valuePropType
};
exports.default = _anyToBoolean;