"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _BaseInput2 = require("react-jsonschema-form/lib/components/widgets/BaseInput");

var _BaseInput3 = _interopRequireDefault(_BaseInput2);

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _BaseInput = function (_Component) {
	(0, _inherits3.default)(_BaseInput, _Component);

	function _BaseInput(props) {
		(0, _classCallCheck3.default)(this, _BaseInput);

		var _this = (0, _possibleConstructorReturn3.default)(this, (_BaseInput.__proto__ || (0, _getPrototypeOf2.default)(_BaseInput)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = _this.getStateFromProps(props);
		return _this;
	}

	(0, _createClass3.default)(_BaseInput, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    formatValue = _props.formatValue,
			    props = (0, _objectWithoutProperties3.default)(_props, ["formatValue"]);

			var options = props.schema.type === "number" || props.schema.type === "integer" ? (0, _extends3.default)({}, props.options, { inputType: "text" }) : props.options;
			return _react2.default.createElement(_BaseInput3.default, (0, _extends3.default)({}, props, this.state, { onChange: this.onChange, onFocus: this.onFocus, onBlur: this.onBlur, options: options }));
		}
	}]);
	return _BaseInput;
}(_react.Component);

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getStateFromProps = function (props) {
		return (0, _extends3.default)({ value: props.value }, (0, _utils.getUiOptions)(props).inputOptions);
	};

	this.onChange = function (value) {
		if (_this2.props.formatValue) value = _this2.props.formatValue(value);

		var type = _this2.props.schema.type;
		// Accept only integers
		if (type === "integer") {
			value = value ? value.replace(/[^0-9\-]/g, "") : value;
			value = value ? value.replace(/(.+)-/g, "$1") : value;
		}
		// Accept integers or floats
		if (type === "number") {
			value = value ? value.replace(/[^0-9.\-]/g, "") : value;
			value = value ? value.replace(/(\..*)\./g, "$1") : value;
			value = value ? value.replace(/(.+)-/g, "$1") : value;
		}

		_this2.setState({ value: value }, function () {
			if (!_this2.focused) {
				_this2.props.onChange(value);
			} else {
				if (_this2.timeout) clearTimeout(_this2.timeout);
				_this2.timeout = new _Context2.default(_this2.props.formContext.contextId).setTimeout(function () {
					_this2.props.onChange(value);
				}, 1000);
			}
		});
	};

	this.onFocus = function (e) {
		_this2.focused = true;
		_this2.props.onFocus && _this2.props.onFocus(e);
	};

	this.onBlur = function (e) {
		_this2.focused = false;
		if (_this2.state.value !== _this2.props.value) {
			_this2.props.onChange(_this2.state.value);
		}
		if (_this2.timeout) clearTimeout(_this2.timeout);
		_this2.props.onBlur && _this2.props.onBlur(e);
	};
};

exports.default = _BaseInput;