"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DateTimePicker = require("react-widgets/lib/DateTimePicker");

var _DateTimePicker2 = _interopRequireDefault(_DateTimePicker);

var _moment = require("moment");

var _moment2 = _interopRequireDefault(_moment);

var _moment3 = require("react-widgets/lib/localizers/moment");

var _moment4 = _interopRequireDefault(_moment3);

var _localizers = require("react-widgets/lib/util/localizers");

var _reactBootstrap = require("react-bootstrap");

var _utils = require("../../utils");

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DATE_TIME_SEPARATOR = ", ";

var DateTimeWidget = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(DateTimeWidget, _Component);

	function DateTimeWidget(props) {
		(0, _classCallCheck3.default)(this, DateTimeWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (DateTimeWidget.__proto__ || (0, _getPrototypeOf2.default)(DateTimeWidget)).call(this, props));

		_this.focus = function () {
			_this.dateTimePickerRef.focus();
		};

		_this.parse = function (value) {
			if (!value) return undefined;
			var hasTime = value.indexOf(DATE_TIME_SEPARATOR) !== -1 || _this.state.time && !_this.state.calendar;
			var momentValue = (0, _moment2.default)(value, _this.state.format);
			var isoValue = undefined;
			if (hasTime) {
				isoValue = momentValue.toISOString();
			} else {
				isoValue = momentValue.format("YYYY-MM-DD");
			}
			_this.timeWritten = hasTime;
			return (0, _moment2.default)(isoValue).toDate();
		};

		_this.onChange = function (value) {
			_this.props.onChange(value, !!"force");
		};

		_this.onToggle = function (p) {
			if (p !== false) _this.toggle = p; //"time" or "calendar"
		};

		_this.setRef = function (elem) {
			_this.dateTimePickerRef = elem;
		};

		_this.setContainerRef = function (elem) {
			_this.containerRef = elem;
		};

		_this.onTextWidgetFocus = function () {
			_this.setState({ textInputFocused: true }, _this.focus);
		};

		_this.onBlur = function () {
			!(0, _utils.isDescendant)((0, _reactDom.findDOMNode)(_this.containerRef), document.activeElement) && _this.setState({ textInputFocused: false });
		};

		_this.getDateWithCurrentTime = function (date) {
			var value = _this.props.value;

			var time = value !== undefined && value !== null ? value.split("T")[1] : false;
			return time ? date + "T" + time : date;
		};

		_this.setToday = function () {
			_this.onChange(_this.getDateWithCurrentTime((0, _moment2.default)().format("YYYY-MM-DD")));
		};

		_this.setYesterday = function () {
			_this.onChange(_this.getDateWithCurrentTime((0, _moment2.default)().subtract(1, "d").format("YYYY-MM-DD")));
		};

		(0, _moment4.default)(_moment2.default);
		return _this;
	}

	(0, _createClass3.default)(DateTimeWidget, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.getContext().addFocusHandler(this.props.id, this.focus);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.getContext().removeFocusHandler(this.props.id, this.focus);
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var lang = props.formContext.lang;

			var localeFormats = (0, _moment2.default)().locale(lang === "sv" ? "fi" : lang)._locale._longDateFormat;
			var translations = props.formContext.translations;


			var dateFormat = "";
			var timeFormat = "";
			var placeholder = "";
			if (props.calendar) {
				dateFormat += translations.DateLocale;
				placeholder += translations.datePlaceholderDay;
			}
			if (props.time) {
				if (placeholder) placeholder += DATE_TIME_SEPARATOR;
				placeholder += translations.timePlaceholderDay;
				timeFormat = localeFormats.LT;
			}

			var inputFormat = dateFormat;
			var format = "" + dateFormat + (dateFormat ? DATE_TIME_SEPARATOR : "") + timeFormat;

			if (props.value) {
				var splitted = props.value.split("T");
				var hasTime = splitted.length > 1 && splitted[1] !== "";
				if (hasTime) {
					inputFormat = format;
				}
			}

			var state = {
				dateFormat: dateFormat,
				timeFormat: timeFormat,
				format: format,
				inputFormat: inputFormat,
				placeholder: placeholder
			};

			["value", "disabled", "time", "calendar"].forEach(function (prop) {
				if (props.hasOwnProperty(prop)) state[prop] = props[prop];
			});

			return state;
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    value = _props.value,
			    readonly = _props.readonly,
			    disabled = _props.disabled;
			var translations = this.props.formContext.translations;

			var momentValue = (0, _moment2.default)(value);

			if (!this.state.textInputFocused && value !== null && !momentValue.isValid()) {
				var TextWidget = this.props.registry.widgets.TextWidget;

				return _react2.default.createElement(TextWidget, (0, _extends3.default)({}, this.props, { onFocus: this.onTextWidgetFocus }));
			}

			var onChange = function onChange(value) {
				var momentValue = (0, _moment2.default)(value);
				var formattedValue = momentValue.format("YYYY-MM-DDTHH:mm");
				if (value !== null && !momentValue.isValid()) {
					formattedValue = _this2.props.value;
				} else if (!_this2.toggle && !_this2.timeWritten || _this2.toggle === "calendar" && (!_this2.props.value || !(_this2.props.value.indexOf("T") !== -1))) {
					formattedValue = momentValue.format("YYYY-MM-DD");
				}
				_this2.onChange(!value ? undefined : formattedValue);
				_this2.toggle = undefined;
				_this2.timeWritten = false;
			};

			var options = (0, _utils.getUiOptions)(this.props);
			var showTimeList = options.showTimeList !== undefined ? options.showTimeList : true;

			var datePicker = _react2.default.createElement(_DateTimePicker2.default, {
				ref: this.setRef,
				calendar: this.state.calendar,
				time: this.state.time && showTimeList,
				format: this.state.inputFormat,
				timeFormat: this.state.timeFormat,
				placeholder: this.state.placeholder,
				onToggle: this.onToggle,
				onChange: onChange,
				value: value && momentValue.isValid() ? momentValue.toDate() : null,
				parse: this.parse,
				disabled: readonly || disabled,
				culture: this.props.formContext.lang,
				messages: {
					calendarButton: translations.ChooseDate,
					timeButton: translations.ChooseTime
				},
				onBlur: this.onBlur
			});

			var showButtons = options.showButtons;


			return showButtons ? _react2.default.createElement(
				"div",
				{ className: "date-widget", ref: this.setContainerRef },
				_react2.default.createElement(
					"div",
					{ className: "date-picker" },
					datePicker
				),
				_react2.default.createElement(
					_reactBootstrap.ButtonGroup,
					null,
					_react2.default.createElement(
						_reactBootstrap.Button,
						{ className: "today", onClick: this.setToday, disabled: readonly || disabled },
						translations.Today
					),
					_react2.default.createElement(
						_reactBootstrap.Button,
						{ className: "today", onClick: this.setYesterday, disabled: readonly || disabled },
						translations.Yesterday
					)
				)
			) : datePicker;
		}
	}, {
		key: "formatValue",
		value: function formatValue(value, options, props) {
			if (!value) return value;

			var _DateTimeWidget$proto = DateTimeWidget.prototype.getStateFromProps((0, _extends3.default)({}, props, { calendar: true, time: true, value: value })),
			    format = _DateTimeWidget$proto.inputFormat;

			return _localizers.date.format(value, format, props.formContext.lang);
		}
	}]);
	return DateTimeWidget;
}(_react.Component)) || _class;

DateTimeWidget.propTypes = {
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			showButtons: _propTypes2.default.bool,
			showTimeList: _propTypes2.default.bool
		})
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};
DateTimeWidget.defaultProps = {
	type: "text",
	readonly: false,
	disabled: false,
	required: false,
	calendar: true,
	time: true
};
exports.default = DateTimeWidget;