"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.InformalTaxonGroupChooser = exports.default = undefined;

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _class;

exports.getInformalGroups = getInformalGroups;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require("react-bootstrap");

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _reactSpinner = require("react-spinner");

var _reactSpinner2 = _interopRequireDefault(_reactSpinner);

var _BaseComponent = require("../BaseComponent");

var _BaseComponent2 = _interopRequireDefault(_BaseComponent);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var InformalTaxonGroupChooserWidget = (0, _BaseComponent2.default)(_class = function (_Component) {
	(0, _inherits3.default)(InformalTaxonGroupChooserWidget, _Component);

	function InformalTaxonGroupChooserWidget(props) {
		(0, _classCallCheck3.default)(this, InformalTaxonGroupChooserWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (InformalTaxonGroupChooserWidget.__proto__ || (0, _getPrototypeOf2.default)(InformalTaxonGroupChooserWidget)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = {};
		return _this;
	}

	(0, _createClass3.default)(InformalTaxonGroupChooserWidget, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this2 = this;

			this.mounted = true;
			getInformalGroups(this.props.formContext.apiClient).then(function (state) {
				if (!_this2.mounted) return;
				_this2.setState(state);
			});
			this.componentWillReceiveProps(this.props);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			var _this3 = this;

			if (props.value !== this.state.informalTaxonGroup) {
				if (!props.value) this.setState({ name: undefined });
				getInformalGroups(props.formContext.apiClient).then(function (_ref) {
					var informalTaxonGroupsById = _ref.informalTaxonGroupsById;

					if (!_this3.mounted) return;
					_this3.setState({ informalTaxonGroup: informalTaxonGroupsById[_this3.props.value] });
				});
			}
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var imageID = this.props.value;
			var _props = this.props,
			    disabled = _props.disabled,
			    readonly = _props.readonly;

			var _getDefaultOptions = this.getDefaultOptions(this.props),
			    button = _getDefaultOptions.button,
			    rootOnly = _getDefaultOptions.rootOnly,
			    grid = _getDefaultOptions.grid;

			var _state$informalTaxonG = this.state.informalTaxonGroupsById,
			    informalTaxonGroupsById = _state$informalTaxonG === undefined ? {} : _state$informalTaxonG;

			if (informalTaxonGroupsById[this.props.value] && informalTaxonGroupsById[this.props.value].parent) {
				imageID = informalTaxonGroupsById[this.props.value].parent.id;
			}
			var InformalTaxonGroupChooserComponent = _react2.default.createElement(InformalTaxonGroupChooser, {
				modal: button,
				onHide: this.hide,
				activeId: this.props.value,
				onSelected: this.onSelected,
				formContext: this.props.formContext,
				lang: this.props.formContext.lang,
				rootOnly: rootOnly,
				grid: grid
			});

			if (button) {
				var title = !this.props.value ? _react2.default.createElement(
					"div",
					{ className: "informal-group-chooser-button-content" },
					_react2.default.createElement(
						"span",
						null,
						this.props.formContext.translations.PickInformalTaxonGroup
					)
				) : _react2.default.createElement(
					"div",
					{ className: "informal-group-chooser-button-content" },
					_react2.default.createElement("div", { className: "informal-group-image " + imageID }),
					this.state.informalTaxonGroup ? _react2.default.createElement(
						"span",
						null,
						this.state.informalTaxonGroup.name
					) : _react2.default.createElement(_reactSpinner2.default, null),
					_react2.default.createElement(
						"div",
						{ className: "close", onClick: this.onClear },
						"\xD7"
					)
				);
				return _react2.default.createElement(
					_components.TooltipComponent,
					{ tooltip: this.state.informalTaxonGroup && this.state.informalTaxonGroup.name },
					_react2.default.createElement(
						"div",
						{ className: "informal-taxon-groups-list" },
						_react2.default.createElement(
							_reactBootstrap.Button,
							{ onClick: this.show, disabled: disabled || readonly },
							title
						),
						this.state.show && InformalTaxonGroupChooserComponent
					)
				);
			} else {
				return InformalTaxonGroupChooserComponent;
			}
		}
	}]);
	return InformalTaxonGroupChooserWidget;
}(_react.Component)) || _class;

InformalTaxonGroupChooserWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};

var _initialiseProps = function _initialiseProps() {
	var _this4 = this;

	this.getDefaultOptions = function (props) {
		var _getUiOptions = (0, _utils.getUiOptions)(props),
		    _getUiOptions$button = _getUiOptions.button,
		    button = _getUiOptions$button === undefined ? true : _getUiOptions$button,
		    _getUiOptions$rootOnl = _getUiOptions.rootOnly,
		    rootOnly = _getUiOptions$rootOnl === undefined ? false : _getUiOptions$rootOnl,
		    _getUiOptions$grid = _getUiOptions.grid,
		    grid = _getUiOptions$grid === undefined ? { lg: 1, md: 2, sm: 3, xs: 12 } : _getUiOptions$grid;

		return { button: button, rootOnly: rootOnly, grid: grid };
	};

	this.onSelected = function (id) {
		_this4.props.onChange(id);

		var _getDefaultOptions2 = _this4.getDefaultOptions(_this4.props),
		    button = _getDefaultOptions2.button;

		if (button) _this4.hide();
		if (_this4.state.informalTaxonGroupsById && id) _this4.setState({ informalTaxonGroup: _this4.state.informalTaxonGroupsById[id] });
	};

	this.show = function () {
		_this4.setState({ show: true });
	};

	this.hide = function () {
		_this4.setState({ show: false });
	};

	this.onClear = function (e) {
		e.stopPropagation();
		_this4.onSelected(undefined);
	};
};

exports.default = InformalTaxonGroupChooserWidget;


function walk(allGroups, _group, parent) {
	_group.forEach(function (group) {
		allGroups[group.id] = group;
		if (parent) group.parent = parent;
		if (group.hasSubGroup) {
			allGroups = walk(allGroups, group.hasSubGroup, parent || group);
		}
	});
	return allGroups;
}

var mapGroupsById = function mapGroupsById(_groups) {
	return _groups.reduce(function (groups, group) {
		groups[group.id] = group;
		return groups;
	}, {});
};

var informalTaxonGroups = void 0,
    informalTaxonGroupsById = void 0;

function getInformalGroups(apiClient) {
	if (informalTaxonGroups) {
		return _promise2.default.resolve({ informalTaxonGroups: informalTaxonGroups, informalTaxonGroupsById: informalTaxonGroupsById });
	}
	return apiClient.fetchCached("/informal-taxon-groups/tree").then(function (response) {
		// Contains the current taxon group.
		var informalTaxonGroups = mapGroupsById(response.results);
		// Contains all groups in flat object.
		var informalTaxonGroupsById = walk({}, response.results);
		new _Context2.default().informalTaxonGroupsById = informalTaxonGroupsById;
		return _promise2.default.resolve({ informalTaxonGroups: informalTaxonGroups, informalTaxonGroupsById: informalTaxonGroupsById });
	});
}

var InformalTaxonGroupChooser = exports.InformalTaxonGroupChooser = function (_Component2) {
	(0, _inherits3.default)(InformalTaxonGroupChooser, _Component2);

	function InformalTaxonGroupChooser(props) {
		(0, _classCallCheck3.default)(this, InformalTaxonGroupChooser);

		var _this5 = (0, _possibleConstructorReturn3.default)(this, (InformalTaxonGroupChooser.__proto__ || (0, _getPrototypeOf2.default)(InformalTaxonGroupChooser)).call(this, props));

		_this5.onSelected = function (id) {
			return function () {
				_this5.props.onSelected(id);
			};
		};

		_this5.onSubgroupSelected = function (id) {
			return function () {
				var path = void 0;
				var existingIdx = _this5.state.path.indexOf(id);
				path = existingIdx >= 0 ? _this5.state.path.slice(0, existingIdx + 1) : [].concat((0, _toConsumableArray3.default)(_this5.state.path), [id]);
				_this5.setState({
					informalTaxonGroups: id ? mapGroupsById(_this5.state.informalTaxonGroupsById[id].hasSubGroup) : _this5.state.root,
					path: path
				});
			};
		};

		_this5.Container = function (_ref2) {
			var children = _ref2.children;
			var _this5$props = _this5.props,
			    modal = _this5$props.modal,
			    onHide = _this5$props.onHide;
			var translations = _this5.props.formContext.translations;

			return modal ? _react2.default.createElement(
				_reactBootstrap.Modal,
				{ show: true, onHide: onHide, dialogClassName: "laji-form informal-taxon-group-chooser" },
				_react2.default.createElement(
					_reactBootstrap.Modal.Header,
					{ closeButton: true },
					_react2.default.createElement(
						_reactBootstrap.Modal.Title,
						null,
						translations.PickInformalTaxonGroup
					)
				),
				_react2.default.createElement(
					_reactBootstrap.Modal.Body,
					null,
					children
				)
			) : _react2.default.createElement(
				"div",
				{ className: "informal-taxon-group-chooser" },
				children
			);
		};

		_this5.getButtonGroup = function (id) {
			var translations = _this5.props.formContext.translations;
			var informalTaxonGroupsById = _this5.state.informalTaxonGroupsById;

			return _react2.default.createElement(
				_reactBootstrap.ButtonGroup,
				null,
				informalTaxonGroupsById[id].hasSubGroup && _react2.default.createElement(
					_reactBootstrap.Button,
					{ key: "subgroups", onClick: _this5.onSubgroupSelected(id) },
					translations.ShowSubgroups
				),
				_react2.default.createElement(
					_reactBootstrap.Button,
					{ key: "select", onClick: _this5.onSelected(id) },
					translations.Select
				)
			);
		};

		_this5.getLabel = function (id) {
			var _this5$state = _this5.state,
			    path = _this5$state.path,
			    informalTaxonGroupsById = _this5$state.informalTaxonGroupsById;

			var name = informalTaxonGroupsById[id].name;
			return path.length <= 1 ? _react2.default.createElement(
				"h5",
				null,
				name
			) : _react2.default.createElement(
				"span",
				null,
				name
			);
		};

		_this5.GroupsContainer = function (_ref3) {
			var children = _ref3.children;
			var rootOnly = _this5.props.rootOnly;

			return rootOnly ? _react2.default.createElement(
				_reactBootstrap.Row,
				null,
				children
			) : _react2.default.createElement(
				_reactBootstrap.ListGroup,
				null,
				children
			);
		};

		_this5.Item = function (id) {
			var path = _this5.state.path;
			var _this5$props2 = _this5.props,
			    rootOnly = _this5$props2.rootOnly,
			    grid = _this5$props2.grid,
			    activeId = _this5$props2.activeId;

			return !rootOnly ? _react2.default.createElement(
				_reactBootstrap.ListGroupItem,
				{ key: id, className: path.length > 1 ? "not-root" : "" },
				path.length === 1 ? _react2.default.createElement("div", { className: "informal-group-image " + id }) : null,
				_this5.getLabel(id),
				_this5.getButtonGroup(id)
			) : _react2.default.createElement(
				_reactBootstrap.Col,
				(0, _extends3.default)({ key: id }, grid),
				_react2.default.createElement(
					_reactBootstrap.Panel,
					{ header: _this5.getLabel(id), onClick: _this5.onSelected(id), bsStyle: id === activeId ? "primary" : undefined },
					_react2.default.createElement("div", { className: "informal-group-image " + id })
				)
			);
		};

		_this5.state = { path: [undefined] };
		return _this5;
	}

	(0, _createClass3.default)(InformalTaxonGroupChooser, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			var _this6 = this;

			this.mounted = true;
			getInformalGroups(this.props.formContext.apiClient).then(function (state) {
				if (!_this6.mounted) return;
				_this6.setState((0, _extends3.default)({}, state, { root: state.informalTaxonGroups }));
			});
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			var _this7 = this;

			if (this.props.lang === props.lang) return;

			getInformalGroups(this.props.formContext.apiClient).then(function (state) {
				if (!_this7.mounted) return;
				_this7.setState((0, _extends3.default)({}, state, { root: state.informalTaxonGroups }));
			});
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
		}
	}, {
		key: "render",
		value: function render() {
			var _this8 = this;

			var _state = this.state,
			    path = _state.path,
			    informalTaxonGroupsById = _state.informalTaxonGroupsById,
			    informalTaxonGroups = _state.informalTaxonGroups;
			var rootOnly = this.props.rootOnly;
			var translations = this.props.formContext.translations;
			var Container = this.Container,
			    GroupsContainer = this.GroupsContainer,
			    Item = this.Item;


			return _react2.default.createElement(
				Container,
				null,
				!rootOnly && _react2.default.createElement(
					_reactBootstrap.Breadcrumb,
					null,
					path.map(function (id) {
						return _react2.default.createElement(
							_reactBootstrap.Breadcrumb.Item,
							{ key: id === undefined ? "root" : id, onClick: _this8.onSubgroupSelected(id) },
							id === undefined ? translations.All : informalTaxonGroupsById[id].name
						);
					})
				),
				informalTaxonGroups ? _react2.default.createElement(
					GroupsContainer,
					null,
					(0, _keys2.default)(informalTaxonGroups).map(Item)
				) : _react2.default.createElement(_reactSpinner2.default, null)
			);
		}
	}]);
	return InformalTaxonGroupChooser;
}(_react.Component);

InformalTaxonGroupChooser.propTypes = {
	onSelected: _propTypes2.default.func.isRequired,
	formContext: _propTypes2.default.object.isRequired
};