"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function PlainTextWidget(props) {
	var id = props.id,
	    value = props.value;

	var _getUiOptions = (0, _utils.getUiOptions)(props),
	    strong = _getUiOptions.strong,
	    formatterWidget = _getUiOptions["ui:widget"],
	    formatterOptions = _getUiOptions["ui:options"],
	    centered = _getUiOptions.centered;

	var formattedValue = (0, _utils.formatValue)((0, _extends3.default)({}, props, {
		uiSchema: formatterWidget ? { "ui:widget": formatterWidget, options: formatterOptions } : props.uiSchema,
		schema: props.schema,
		formData: props.value
	}));
	return _react2.default.createElement(
		"span",
		{ className: "plainText" + (centered ? " horizontally-centered row-height" : "") },
		strong ? _react2.default.createElement(
			"strong",
			null,
			formattedValue
		) : formattedValue,
		_react2.default.createElement("input", { type: "hidden", id: id, value: typeof value === "undefined" ? "" : value })
	);
}

if (process.env.NODE_ENV !== "production") {
	PlainTextWidget.propTypes = {
		id: _propTypes2.default.string.isRequired,
		value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
		schema: _propTypes2.default.shape({
			type: _propTypes2.default.oneOf(["string", "number", "integer"])
		})
	};
}

exports.default = PlainTextWidget;