"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require("react-dom");

var _Combobox = require("react-widgets/lib/Combobox");

var _Combobox2 = _interopRequireDefault(_Combobox);

var _Multiselect = require("react-widgets/lib/Multiselect");

var _Multiselect2 = _interopRequireDefault(_Multiselect);

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SelectWidget = function (_Component) {
	(0, _inherits3.default)(SelectWidget, _Component);

	function SelectWidget(props) {
		(0, _classCallCheck3.default)(this, SelectWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (SelectWidget.__proto__ || (0, _getPrototypeOf2.default)(SelectWidget)).call(this, props));

		_this.multiSelectOnChange = function (values) {
			_this.props.onChange(values.map(function (_ref) {
				var value = _ref.value;
				return _this.getEnum(value);
			}));
			new _Context2.default(_this.props.formContext.contextId).sendCustomEvent(_this.props.id, "resize");
		};

		_this.selectOnChange = function (item) {
			_this.setState({ value: item });
		};

		_this.onClick = function () {
			!_this.props.disabled && !_this.props.readonly && _this.setState({ open: true });
		};

		_this.onFocus = function () {
			return _this.setState({ open: true }, function () {
				(0, _reactDom.findDOMNode)(_this.comboRef.refs.inner.refs.input).select();
			});
		};

		_this.onBlur = function () {
			if ((0, _typeof3.default)(_this.state.value) !== "object") {
				_this.setState({ value: _this.state.valsToItems[_this.props.value] });
			} else {
				_this.props.onChange(_this.getEnum(_this.state.value.value));
			}
		};

		_this.onSelect = function (item) {
			_this.state.open && _this._context.setImmediate(function () {
				return _this.mounted && _this.setState({ open: false, value: item.value });
			});
			var value = _this.getEnum(item.value);
			(!_this.state.value || value !== _this.state.value.value) && _this.props.onChange(value);
		};

		_this.onToggle = function () {
			_this.setState({ open: false });
		};

		_this.setRef = function (elem) {
			return _this.comboRef = elem;
		};

		_this.getEnum = function (val) {
			return (0, _utils.isEmptyString)(val) ? undefined : val;
		};

		_this.onMultiSelectKeyDown = function (e) {
			if (e.key === "Enter" && _this.comboRef.refs.inner.props.open) {
				e.stopPropagation();
			}
		};

		_this.state = _this.getStateFromProps(props);
		_this._context = new _Context2.default(_this.props.formContext.contextId);
		return _this;
	}

	(0, _createClass3.default)(SelectWidget, [{
		key: "componentDidMount",
		value: function componentDidMount() {
			this.mounted = true;
			this._context.addFocusHandler(this.props.id, this.onFocus);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this.mounted = false;
			this._context.removeFocusHandler(this.props.id, this.onFocus);
		}
	}, {
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var enumOptions = props.options.enumOptions,
			    multiple = props.multiple,
			    value = props.value;


			if (multiple && enumOptions && enumOptions[0] && (0, _utils.isEmptyString)(enumOptions[0].label)) {
				enumOptions = enumOptions.slice(1);
			}

			function sort(enumOptions, order) {
				if (!Array.isArray(order)) return enumOptions;

				var idxs = order.reduce(function (idxs, _enum, i) {
					idxs[_enum] = i;
					return idxs;
				}, {});

				return enumOptions.slice(0).sort(function (a, b) {
					return idxs[a.value] - idxs[b.value];
				});
			}

			var _getUiOptions = (0, _utils.getUiOptions)(props),
			    _filter = _getUiOptions.filter,
			    filterType = _getUiOptions.filterType,
			    labels = _getUiOptions.labels,
			    order = _getUiOptions.order;

			if (_filter) {
				enumOptions = (0, _utils.filter)(enumOptions, _filter, filterType, function (item) {
					return item.value;
				});
			}

			if (labels) {
				enumOptions = enumOptions.map(function (_ref2) {
					var value = _ref2.value,
					    label = _ref2.label;

					return { value: value, label: labels.hasOwnProperty(value) ? labels[value] : label };
				});
			}

			if (enumOptions.every(function (_ref3) {
				var _value = _ref3.value;
				return value !== _value;
			})) {
				var _enum = this.props.options.enumOptions.find(function (_ref4) {
					var _value = _ref4.value;
					return value === _value;
				});
				if (_enum) {
					enumOptions.push(_enum);
				}
			}

			if (order) enumOptions = sort(enumOptions, order);

			var valsToItems = enumOptions.reduce(function (map, item) {
				map[item.value] = item;
				return map;
			}, {});

			return {
				valsToItems: valsToItems,
				enumOptions: enumOptions,
				value: multiple ? value : valsToItems[value]
			};
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    id = _props.id,
			    disabled = _props.disabled,
			    readonly = _props.readonly,
			    multiple = _props.multiple,
			    formContext = _props.formContext;
			var enumOptions = this.state.enumOptions;


			var commonOptions = {
				id: id,
				value: this.state.value,
				placeholder: (0, _utils.getUiOptions)(this.props).placeholder,
				data: enumOptions,
				valueField: "value",
				textField: "label",
				disabled: disabled || readonly,
				filter: "contains",
				messages: {
					open: formContext.translations.Open,
					emptyList: formContext.translations.NoResults,
					emptyFilter: formContext.translations.NoResults
				}
			};

			var selectComponent = multiple ? _react2.default.createElement(_Multiselect2.default, (0, _extends3.default)({}, commonOptions, {
				onChange: this.multiSelectOnChange,
				onKeyDown: this.onMultiSelectKeyDown,
				ref: this.setRef
			})) : _react2.default.createElement(_Combobox2.default, (0, _extends3.default)({}, commonOptions, {
				onChange: this.selectOnChange,
				ref: this.setRef,
				open: this.state.open,
				onToggle: this.onToggle,
				onClick: this.onClick,
				onFocus: this.onFocus,
				onBlur: this.onBlur,
				onSelect: this.onSelect
			}));

			return _react2.default.createElement(
				_components.TooltipComponent,
				{ placement: "top", trigger: "hover",
					tooltip: multiple || (0, _utils.isEmptyString)(this.props.value) ? undefined : this.state.valsToItems[this.props.value].label },
				_react2.default.createElement(
					"div",
					null,
					selectComponent
				)
			);
		}
	}]);
	return SelectWidget;
}(_react.Component);

SelectWidget.defaultProps = {
	autofocus: false
};

SelectWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string", "array"])
	}),
	id: _propTypes2.default.string.isRequired,
	uiSchema: _propTypes2.default.shape({
		"ui:options": _propTypes2.default.shape({
			enumOptions: _propTypes2.default.array,
			order: _propTypes2.default.array,
			filter: _propTypes2.default.array,
			filterType: _propTypes2.default.string,
			labels: _propTypes2.default.object
		})
	}),
	value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.array]),
	required: _propTypes2.default.bool,
	multiple: _propTypes2.default.bool,
	autofocus: _propTypes2.default.bool,
	onChange: _propTypes2.default.func
};

exports.default = SelectWidget;