"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _set = require("babel-runtime/core-js/set");

var _set2 = _interopRequireDefault(_set);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _immutabilityHelper = require("immutability-helper");

var _immutabilityHelper2 = _interopRequireDefault(_immutabilityHelper);

var _reactBootstrap = require("react-bootstrap");

var _BaseInput = require("./BaseInput");

var _BaseInput2 = _interopRequireDefault(_BaseInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextSelectWidget = function (_Component) {
	(0, _inherits3.default)(TextSelectWidget, _Component);

	function TextSelectWidget(props) {
		(0, _classCallCheck3.default)(this, TextSelectWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (TextSelectWidget.__proto__ || (0, _getPrototypeOf2.default)(TextSelectWidget)).call(this, props));

		_this.onCheckBoxChange = function (label) {
			return function () {
				var selectedCheckboxes = _this.state.selectedCheckboxes;

				if (selectedCheckboxes.has(label)) {
					selectedCheckboxes.delete(label);
				} else {
					selectedCheckboxes.add(label);
				}

				_this.setState({ selectedCheckboxes: selectedCheckboxes });

				_this.onChange(_this.state.otherValue);
			};
		};

		_this.onInputChange = function (value) {
			_this.onChange(value);
		};

		_this.onChange = function (textValue) {
			var newValue = [].concat((0, _toConsumableArray3.default)(_this.state.selectedCheckboxes));
			if (_this.state.selectedCheckboxes.has(_this.state.freeTextField)) {
				if (textValue && textValue.length > 0) {
					newValue = (0, _immutabilityHelper2.default)(newValue, { $push: [textValue] });
				}
				newValue.splice(newValue.indexOf(_this.state.freeTextField), 1);
			}
			_this.props.onChange(newValue.join(", "));
		};

		_this.state = _this.getInitialState(props);
		return _this;
	}

	(0, _createClass3.default)(TextSelectWidget, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "getInitialState",
		value: function getInitialState(props) {
			var _getUiOptions = (0, _utils.getUiOptions)(props),
			    _getUiOptions$enums = _getUiOptions.enums,
			    enums = _getUiOptions$enums === undefined ? [] : _getUiOptions$enums,
			    _getUiOptions$delimit = _getUiOptions.delimiter,
			    delimiter = _getUiOptions$delimit === undefined ? ", " : _getUiOptions$delimit,
			    freeTextField = _getUiOptions.freeTextField;

			var value = props.value;


			var selectedCheckboxes = new _set2.default();

			var values = !value ? [] : value.split(delimiter);

			var otherValues = [];
			values.map(function (val) {
				if (enums.indexOf(val) !== -1) {
					selectedCheckboxes.add(val);
				} else {
					otherValues.push(val);
				}
			});
			if (otherValues.length > 0) {
				selectedCheckboxes.add(freeTextField);
			}

			return { selectedCheckboxes: selectedCheckboxes, enums: enums, otherValue: otherValues.join(delimiter), freeTextField: freeTextField };
		}
	}, {
		key: "getStateFromProps",
		value: function getStateFromProps(props) {
			var _getUiOptions2 = (0, _utils.getUiOptions)(props),
			    _getUiOptions2$enums = _getUiOptions2.enums,
			    enums = _getUiOptions2$enums === undefined ? [] : _getUiOptions2$enums,
			    _getUiOptions2$delimi = _getUiOptions2.delimiter,
			    delimiter = _getUiOptions2$delimi === undefined ? ", " : _getUiOptions2$delimi;

			var value = props.value;

			var values = !value ? [] : value.split(delimiter);

			var otherValues = [];

			values.map(function (val) {
				if (enums.indexOf(val) === -1) {
					otherValues.push(val);
				}
			});
			return { otherValue: otherValues.join(delimiter) };
		}
	}, {
		key: "render",
		value: function render() {
			var _this2 = this;

			var _state = this.state,
			    enums = _state.enums,
			    otherValue = _state.otherValue,
			    freeTextField = _state.freeTextField,
			    selectedCheckboxes = _state.selectedCheckboxes;


			if (freeTextField) {
				enums = (0, _immutabilityHelper2.default)(enums, { $push: [freeTextField] });
			}

			return _react2.default.createElement(
				"div",
				{ className: "laji-text-select" },
				enums.map(function (label, i) {
					return _react2.default.createElement(
						_reactBootstrap.Checkbox,
						{ key: i,
							title: label,
							checked: selectedCheckboxes.has(label),
							onChange: _this2.onCheckBoxChange(label) },
						label
					);
				}),
				freeTextField ? _react2.default.createElement(_BaseInput2.default, (0, _extends3.default)({}, this.props, {
					id: this.props.id + "_input",
					value: otherValue,
					onChange: this.onInputChange,
					disabled: !selectedCheckboxes.has(freeTextField) })) : null
			);
		}
	}]);
	return TextSelectWidget;
}(_react.Component);

TextSelectWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}).isRequired,
	value: _propTypes2.default.string
};
exports.default = TextSelectWidget;