"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = undefined;

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require("babel-runtime/core-js/object/get-prototype-of");

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require("../../utils");

var _components = require("../components");

var _Context = require("../../Context");

var _Context2 = _interopRequireDefault(_Context);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TextareaWidget = function (_Component) {
	(0, _inherits3.default)(TextareaWidget, _Component);

	function TextareaWidget(props) {
		(0, _classCallCheck3.default)(this, TextareaWidget);

		var _this = (0, _possibleConstructorReturn3.default)(this, (TextareaWidget.__proto__ || (0, _getPrototypeOf2.default)(TextareaWidget)).call(this, props));

		_initialiseProps.call(_this);

		_this.state = _this.getStateFromProps(props);

		_this._context = new _Context2.default(props.formContext.contextId);
		var shortcuts = _this._context.shortcuts;

		(0, _keys2.default)(shortcuts || {}).some(function (keyCombo) {
			if (shortcuts[keyCombo].fn == "textareaRowInsert") {
				// Direct mutation should be ok in constructor.
				_this.state.keyCombo = keyCombo; // eslint-disable-line react/no-direct-mutation-state
				return true;
			}
		});
		return _this;
	}

	(0, _createClass3.default)(TextareaWidget, [{
		key: "componentWillReceiveProps",
		value: function componentWillReceiveProps(props) {
			this.setState(this.getStateFromProps(props));
		}
	}, {
		key: "componentDidMount",
		value: function componentDidMount() {
			this._context.addKeyHandler(this.props.id, this.keyFunctions);
		}
	}, {
		key: "componentWillUnmount",
		value: function componentWillUnmount() {
			this._context.removeKeyHandler(this.props.id, this.keyFunctions);
		}
	}, {
		key: "render",
		value: function render() {
			var _props = this.props,
			    id = _props.id,
			    options = _props.options,
			    placeholder = _props.placeholder,
			    disabled = _props.disabled,
			    readonly = _props.readonly,
			    autofocus = _props.autofocus;
			var value = this.state.value;
			var _options$required = options.required,
			    required = _options$required === undefined ? this.props.required : _options$required;


			var textarea = _react2.default.createElement("textarea", {
				id: id,
				className: "form-control",
				value: typeof value === "undefined" ? "" : value,
				placeholder: placeholder,
				required: required,
				disabled: disabled,
				readOnly: readonly,
				autoFocus: autofocus,
				rows: options.rows,
				onFocus: this.onFocus,
				onBlur: this.onBlur,
				onChange: this.onChange
			});

			return this.state.keyCombo ? _react2.default.createElement(
				_components.TooltipComponent,
				{ tooltip: (0, _utils.stringifyKeyCombo)(this.state.keyCombo) + " " + this.props.formContext.translations.textareaHint, placement: "bottom" },
				textarea
			) : textarea;
		}
	}]);
	return TextareaWidget;
}(_react.Component);

TextareaWidget.propTypes = {
	"ui:options": _propTypes2.default.shape({
		emptyValue: _propTypes2.default.string,
		rows: _propTypes2.default.number
	}),
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getStateFromProps = function (props) {
		return { value: props.value };
	};

	this.keyFunctions = {
		textareaRowInsert: function textareaRowInsert() {
			if (!_this2.props.disabled && !_this2.props.readonly) {
				_this2.props.onChange((_this2.props.value !== undefined ? _this2.props.value : "") + "\n");
				return true;
			}
			return false;
		}
	};

	this.onFocus = function (e) {
		_this2.focused = true;
		_this2.props.onFocus && _this2.props.onFocus(e);
	};

	this.onBlur = function (e) {
		_this2.focused = false;
		if (_this2.state.value !== _this2.props.value) {
			_this2.props.onChange(_this2.state.value);
		}
		if (_this2.timeout) clearTimeout(_this2.timeout);
		_this2.props.onBlur && _this2.props.onBlur(e);
	};

	this.onChange = function (_ref) {
		var value = _ref.target.value;

		_this2.setState({ value: value }, function () {
			if (!_this2.focused) {
				_this2.props.onChange(value);
			} else {
				if (_this2.timeout) clearTimeout(_this2.timeout);
				_this2.timeout = new _Context2.default(_this2.props.formContext.contextId).setTimeout(function () {
					_this2.props.onChange(value === "" ? (0, _utils.getUiOptions)(_this2.props).emptyValue : value);
				}, 1000);
			}
		});
	};
};

exports.default = TextareaWidget;