"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _moment = require("moment");

var _moment2 = _interopRequireDefault(_moment);

var _DateTimeWidget = require("./DateTimeWidget");

var _DateTimeWidget2 = _interopRequireDefault(_DateTimeWidget);

var _utils = require("../../utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var onChange = function onChange(_onChange) {
	return function (value) {
		_onChange((0, _utils.isEmptyString)(value) ? undefined : (0, _moment2.default)(value).format("HH:mm"));
	};
};

var TimeWidget = function TimeWidget(props) {
	return _react2.default.createElement(_DateTimeWidget2.default, (0, _extends3.default)({}, props, {
		onChange: onChange(props.onChange),
		calendar: false,
		value: props.value ? (0, _moment2.default)().format("YYYY-MM-DD") + ("T" + props.value) : null
	}));
};
TimeWidget.propTypes = {
	schema: _propTypes2.default.shape({
		type: _propTypes2.default.oneOf(["string"])
	}),
	value: _propTypes2.default.string
};

exports.default = TimeWidget;